2021-12-20  Werner Koch  <wk@gnupg.org>

	Release 2.3.4.
	+ commit f74c65fd9bbb97a24b1a3bfe73706c6fcf95ad2a


	gpg: Correctly set the ownertrust for a new key.
	+ commit 610528725290961ecc4a35d79ac9e4f2e07ed24e
	* g10/keygen.c (do_generate_keypair): Use update_ownertrust.

	po: auto update.
	+ commit 69195ab2550ef1e8ccf8bfe2b6972e822d27c253


	gpg: Add unfinished code for --export-secret-ssh-key.
	+ commit afe5fcda52e88438c7a7278117b2e03f510a9c1c
	* g10/gpg.c (exportSecretSshKey): New.
	(opts): Add --export-secret-ssh-key.
	(main): Implement option.
	* g10/export.c (do_export_stream): Factor keywrap key code out to ...
	(get_keywrap_key): new.
	(mb_write_uint32, mb_write_uint8)
	(mb_write_data, mb_write_cstring)
	(mb_write_string, mb_write_mpi): New.
	(receive_raw_seckey_from_agent): New.
	(export_secret_ssh_key): New.

	gpg: Allow passing a keygrip as description to pinentry.
	+ commit ace15e1b09dc9fc83d71faeeb7805802ed5bcc82
	* g10/keydb.h (FORMAT_KEYDESC_KEYGRIP): New.
	* g10/passphrase.c (gpg_format_keydesc): Add new mode.

	common: Add set_membuf_err.
	+ commit da391022160804785dad7d53b464e0448ab8aba0
	* common/membuf.c (set_membuf_err): New.

	wkd: Don't beg for donations.
	+ commit 038136ea48ae8963dd89c7e1999d640a112dd791
	* tools/gpg-wks-server.c (send_congratulation_message): Remove
	donation hint from message.

2021-12-20  Ingo Klöcker  <dev@ingo-kloecker.de>

	dirmngr: Ask keyservers to provide the key fingerprints.
	+ commit c7fa4c7f8bf375e3739ef8361f38b6b31113b8bf
	* dirmngr/ks-engine-hkp.c (ks_hkp_search): Add "fingerprint=on" to
	request URL.

2021-12-17  NIIBE Yutaka  <gniibe@fsij.org>

	dirmngr: Fix ldap-url.c.
	+ commit a9b95b20a8c358d9f8743acfa1076c3be4ff0ac1
	* dirmngr/ldap-url.c (ldap_charray2str): Use memcpy instead of strncpy
	when length is computed by strlen beforhand.

	w32: Prepare for the case gcrypt.h will not include winsock2.h.
	+ commit e08225030dfb2090e756d26575f38c371e5a81cf
	* common/dynload.h: Include specific headers only.
	* common/exechelp-w32.c: Include <windows.h>.
	* common/gettime.c: Likewise.
	* common/utf8conv.c: Likewise.
	* tests/gpgscm/ffi.c: Likewise.
	* tools/gpgconf.c: Likewise.
	* configure.ac: Check winsock2.h, removing gl_HEADER_SYS_SOCKET.

2021-12-10  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Emit compatible Ed25519 signature.
	+ commit 61ac580a2075564bc775b6764a239dad5e336251
	* g10/pkglue.c (sexp_extract_param_sos_nlz): New.
	* g10/pkglue.h: Add the declaration.
	* g10/sign.c (do_sign): Use sexp_extract_param_sos_nlz for Ed25519.

2021-11-24  Jakub Jelen  <jjelen@redhat.com>

	gpg: Fix function prototype to match declaration.
	+ commit 426d82fcf1c133bfc1d5c931109d71db3f3815a9
	* g10/test-stubs.c (keyserver_import_mbox): Fix prototype

	kbx: Fix allocation check.
	+ commit 46efee8cb7009b0a0c04b42822d4579424c536e1
	* kbx/kbxserver.c (cmd_search): Fix allocation check

	homedir: Avoid memory leaks on errors.
	+ commit 6ee3eb420207c51bc4f2e6aa0871bc8c51f977f0
	* common/homedir.c (unix_rootdir): Free allocated memory on error path

	dirmngr: Avoid memory leaks on errors.
	+ commit 940af3f05231dd85138fd3415c7bb7a974bec950
	* dirmngr/ldap-misc.c (ldap_parse_extfilter): Avoid direct return
	  without freeing resources on errors.

2021-11-24  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix format_keyid.
	+ commit a9be9f4e6e6d451698afa3d4780a53ed3718b30b
	* g10/keyid.c (format_keyid): Allocate buffer earlier.

	gpg: Fix key conversion for SSH.
	+ commit 07671917e476ad5ae8f5098630ef1cd531ff401a
	* g10/export.c (key_to_sshblob): Use put_membuf with length counted
	beforehand, and use memcmp instead of strncmp.

2021-11-22  Werner Koch  <wk@gnupg.org>

	gpg: New option --forbid-gen-key.
	+ commit c397ba3ac02e38b428d3e13d0bebac2a99b81f01
	* g10/gpg.c (oForbidGenKey, opts): New option.
	(mopt): New local struct
	(gen_key_forbidden): New.
	(main): Set and handle the option.

2021-11-19  Werner Koch  <wk@gnupg.org>

	gpgconf: Include output of --list-dirs in --show-configs.
	+ commit a0fb78ee0fba13fdbe22d8c3f408a78b847cee28
	* tools/gpgconf.c (list_dirs): Add arg special.
	(show_other_registry_entries): Print the Homedir.
	(show_configs): List directories.

2021-11-18  Werner Koch  <wk@gnupg.org>

	gpg,gpgsm: Add option --min-rsa-length.
	+ commit 5f39db70c069a95731a8a1f65547e3314d6b1f85
	* common/compliance.c (min_compliant_rsa_length): New.
	(gnupg_pk_is_compliant): Take in account.
	(gnupg_pk_is_allowed): Ditto.
	(gnupg_set_compliance_extra_info): New.
	* g10/gpg.c (oMinRSALength): New.
	(opts): Add --min-rsa-length.
	(main): Set value.
	* g10/options.h (opt): Add field min_rsa_length.
	* sm/gpgsm.c (oMinRSALength): New.
	(opts): Add --min-rsa-length.
	(main): Set value.
	* sm/gpgsm.h (opt): Add field min_rsa_length.

2021-11-17  Werner Koch  <wk@gnupg.org>

	gpgconf: --show-configs now prints a bunch of Registry entries.
	+ commit 749bb80cb7685c12f3c65796559990952758f294
	* tools/gpgconf.c (show_other_registry_entries): New.
	(show_configs): Call it.  Minor reformatting.

	gpgconf: Extend --show-config to show envvars.
	+ commit 9172fbc08473afa2c295f7c77a8ae78efd4f77b7
	* tools/gpgconf.c (my_copy_file): Add arg LISTP and record certain
	things.
	(show_configs_one_file): New arg LISTP to be passed thru.
	(show_configs): Show envars and regisiry values.

	common,w32: New function read_w32_reg_string.
	+ commit 50539394802fb9478296d52527582697a6693b52
	* common/w32-reg.c (get_root_key): Remove.
	(read_w32_registry_string): Turn into a wrapper for the gpgrt
	function.
	(read_w32_reg_string): New.

2021-11-15  Werner Koch  <wk@gnupg.org>

	sm: Detect circular chains in --list-chain.
	+ commit 74c5b350624b5636706bc39605857f10762371b1
	* sm/keylist.c (list_cert_chain): Break loop for a too long chain.

2021-11-15  NIIBE Yutaka  <gniibe@fsij.org>
	    Klas Lindfors

	scd:openpgp: Support longer data for INTERNAL_AUTHENTICATE.
	+ commit a575b0aba5424ed76b1067218beab748b56bde43
	* scd/app-openpgp.c (do_auth): Use extended Lc, when supported.

2021-11-14  Werner Koch  <wk@gnupg.org>

	agent: Print the non-option warning earlier.
	+ commit bd5c775878fdfc151a3d996b335ea22d5247c963
	* agent/gpg-agent.c (main): Move detection up.

2021-11-13  Werner Koch  <wk@gnupg.org>

	gpg: Remove stale ultimately trusted keys from the trustdb.
	+ commit 99ef78aa0ca7e48ceba400e1a43f8185cf9bbf71
	* g10/tdbdump.c (export_ownertrust): Skip records marked with the
	option --trusted-key.
	(import_ownertrust): Clear the trusted-key flag.
	* g10/tdbio.h (struct trust_record): Add field flags.
	* g10/tdbio.c (tdbio_dump_record): Improve output.
	(tdbio_read_record, tdbio_write_record): Handle flags.
	* g10/trustdb.c (verify_own_keys): Clear stale trusted-keys and set
	the flag for new --trusted-keys.
	(tdb_update_ownertrust): Add arg as_trusted_key.  Update callers.

	keyboxd: New option --steal-socket.
	+ commit b0079ab39d31c74673e576149c7ac66d00c45c49
	* kbx/keyboxd.c (oStealSocket): New const.
	(opts): Add option.
	(steal_socket): New file global flag.
	(main): Set option.
	(create_server_socket): Implement option.

	agent,dirmngr: New option --steal-socket.
	+ commit dd708f60d5cf571bd4f0312c1b291ec93c328047
	* agent/gpg-agent.c (oStealSocket): New.
	(opts): Add option.
	(steal_socket): New file global var.
	(main): Set option.
	(create_server_socket): Implement option.

	* dirmngr/dirmngr.c (oStealSocket): New.
	(opts): Add option.
	(steal_socket): New file global var.
	(main): Set option.  Add comment to eventually implement it.

2021-11-12  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Don't use malloc for kek_params.
	+ commit b124bca592e15dcf41b621be517bc4af9e1e9d4d
	* g10/ecdh.c (pk_ecdh_default_params): Use stack for kek_params.

2021-11-12  Jakub Jelen  <jjelen@redhat.com>
	    NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Avoid use of uninitialized value.
	+ commit fae1d2e2ccde6cb46974433cf769c83134b0f57d
	* kbx/backend-kbx.c (be_kbx_search): Initialize skipped_long_blobs
	value which is passed to keybox_search and incremented there.
	(be_kbx_seek): Likewise.

2021-11-12  Jakub Jelen  <jjelen@redhat.com>

	gpg: Avoid uninitialized revkey.fprlen.
	+ commit d24c5df52b55e86b49b48f153a1ada5a5081eda5
	* g10/keygen.c (parse_revocation_key): Store the fingerprint length in
	created structure.

2021-11-12  Jakub Jelen  <jjelen@redhat.com>
	    NIIBE Yutaka  <gniibe@fsij.org>

	agent: Avoid uninitialized buffer.
	+ commit ae3d0bb8e77ce1b2a096fff7d783c781c9f7a502
	* agent/sexp-secret.c (fixup_when_ecc_private_key): Initialize buffer to
	avoid its use on unexpected inputs.

2021-11-12  Jakub Jelen  <jjelen@redhat.com>

	agent: Correctly free memory on error path.
	+ commit 50f32eb0664d921242563f6602ce5a8f46557085
	* agent/protect.c (merge_lists): Free memory on error.

	scd: Avoid memory leak.
	+ commit c0b1bcc5c6b5558c9f1f665797979134ade66fd7
	* scd/command.c (cmd_readkey): Free allocated memory on failure path.

	tools: Avoid memory leak from gpgspilt.
	+ commit 50e6d63f12e700658f094bf1ff2fd25861690240
	* tools/gpgsplit.c (write_part): Free memory when no longer needed.

2021-11-09  Bernhard M. Wiedemann  <bwiedemann@suse.de>

	wks: Do not mark key files as executable.
	+ commit 0c8bc154342bf54f7e6cce2075ee8e851dfd09b5


	wks: Allow access to newly created dirs.
	+ commit 60be00b0336bebc319d3e444841526be87dfe3bc


2021-11-04  Werner Koch  <wk@gnupg.org>

	gpg: Fix indentation of --print-mds and --print-md sha512.
	+ commit d9deac7791904634848a4c178585f37205641124
	* g10/gpg.c (print_hex): Fix indentation.

	gpgconf: New command --show-configs.
	+ commit fa738173f9d8aa1ddd6b5e665d2f035dae2c0b1f
	* tools/gpgconf.c (aShowConfigs): New.
	(opts): Add --show-configs.
	(CUTLINE_FMT): New.
	(show_version_gnupg): Add arg "prefix" and adjust caller.
	(my_copy_file): New.
	(show_configs_one_file): New.New.
	(show_configs): New.
	(main): Call show_configs.

2021-11-03  Ingo Klöcker  <dev@ingo-kloecker.de>

	gpgconf: Allow changing gpg's deprecated keyserver option.
	+ commit 0a7d772a5c43eddad6fb3238614b8af722453919
	* tools/gpgconf-comp.c (known_options_gpg): Add "keyserver".

2021-11-02  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Simplify the loop of DEVINFO.
	+ commit 49f7fcb90b5d4f33b9b65baec8774745aa2242c9
	* scd/app.c (app_send_devinfo): Factor out lock/unlock.

2021-10-29  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix the previous commit.
	+ commit 99e00ec6db33ce86b92106307d637769e0914833


	scd: Modify DEVINFO behavior to support looping forever.
	+ commit 48e824b6ea69d21ccbc50aac125d8b442af66727
	* scd/app.c (struct mrsw_lock): Add notify_cond member.
	(notify_cond): Remove.
	(card_list_r_lock, card_list_r_unlock): Rename.
	(card_list_w_lock, card_list_w_unlock): Rename.
	(card_list_signal, card_list_wait): New, fixing thinko about
	notify/wakeup with MRSW lock.
	(app_send_devinfo): Support looping.
	(select_application): Notify app_send_devinfo thread for newly
	detected device.
	(initialize_module_command): Initialize notify_cond member.
	(app_wait): Remove.
	* scd/command.c (cmd_devinfo): Use new API of app_send_devinfo.
	* scd/scdaemon.h (app_wait): Remove.

2021-10-27  Werner Koch  <wk@gnupg.org>

	common: Support MYPROC_SELF_EXE for Solaris.
	+ commit 50e43af3f1081ba3fe677b1030c5c62063461665
	* common/homedir.c (MYPROC_SELF_EXE): Add case for SunOS.

2021-10-22  Werner Koch  <wk@gnupg.org>

	gpg: Fix printing of binary notations.
	+ commit 62f838ea1fcad1c008c783946559b607cae37674
	* g10/keylist.c (show_notation): Print binary notation from BDAT.

2021-10-20  Werner Koch  <wk@gnupg.org>

	common: Silence warning from unix_rootdir on systems w/o /proc.
	+ commit 4cb44914b57a8db9d2f0d24e11d2b5e6fedc0a87
	* common/homedir.c (unix_rootdir): Silence diagnostic in the common
	case.
	(MYPROC_SELF_EXE): Support NetBSD.

	common,w32: Do not always print "Garbled console data" warning.
	+ commit e293da3b214958ff86e7636d17b0b6e10264882e
	* common/init.c (_init_common_subsystems): Silence message.

2021-10-15  NIIBE Yutaka  <gniibe@fsij.org>

	dns: Make reading resolv.conf more robust.
	+ commit 48359c723206254d3a22f08eb537a6acc2f04e01
	* dirmngr/dns.c (dns_resconf_loadfile): Skip "search" which
	begins with '.'.

2021-10-13  Werner Koch  <wk@gnupg.org>

	gpg: New option --override-compliance-check.
	+ commit fb26e144adfd93051501d58f5d0d4f8826ddf436
	* g10/gpg.c (oOverrideComplianceCheck): New.
	(opts): Add new option.
	(main): Set option and add check for batch mode.
	* g10/options.h (opt): Add flags.override_compliance_check.

	* g10/sig-check.c (check_signature2): Factor complaince checking out
	to ...
	(check_key_verify_compliance): this.  Turn error into a warning in
	override mode.

2021-10-12  Werner Koch  <wk@gnupg.org>

	Release 2.3.3.
	+ commit 9470d0338364b781d701ad8e81972c782b48aa2d


	speedo: Put the keyboxd into the Windows installer.
	+ commit 10f52f9bf3bcc6cf29835c2f11ea91ab0d5e7cdc
	* build-aux/speedo/w32/inst.nsi: Install keyboxd.
	* Makefile.am (sign-release): Sign the wixlib only if generated.
	* autogen.rc: Remove meanwhile obsolete option --with-regex.

	tests: New way to make use of gpgconf.ctl in tests.
	+ commit bcd5feec0e916b864d004a47f36a41e2eba3b10e
	* Makefile.am (all-local): New to setup symlinks.
	(distclean-local): New.
	* tests/Makefile.am: Remove the gpgconf related targets.  Just keep
	gpgconf.ctl.in in EXTRA_DIST
	* tests/cms/Makefile.am (GNUPG_BUILD_ROOT):
	* tests/gpgme/Makefile.am (GPGSCM_PATH):
	* tests/openpgp/Makefile.am (GNUPG_BUILD_ROOT):
	* tests/pkits/Makefile.am (GNUPG_BUILD_ROOT):
	* tests/tpm2dtests/defs.scm (tools): Revert to the former values.
	* tests/openpgp/defs.scm (tools): Ditto.

2021-10-10  Werner Koch  <wk@gnupg.org>

	Do not build keyxboxd if sqlite has been disabled.
	+ commit cf29c7dec0e845040a71aac383ee9f1dda901590
	* configure.ac: Move clearing of build_keyboxd out of the conditional.

2021-10-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	common: Respect gpgconf.ctl when looking up translations.
	+ commit e99b9890c28dae491653279791e52771be866188
	* common/i18n.c (i18n_init): Use gnupg_localedir() instead of LOCALEDIR.
	(i18n_localegettext): Ditto.
	* tools/gpgconf-comp.c (my_dgettext): Ditto.

2021-10-06  Werner Koch  <wk@gnupg.org>

	dirmngr: New option --ignore-cert.
	+ commit 4b3e9a44b58e74b3eb4a59f88ee017fe7483a17d
	* dirmngr/dirmngr.h (struct fingerprint_list_s): Add field binlen.
	(opt): Add field ignored_certs.
	* dirmngr/dirmngr.c: Add option --ignore-cert
	(parse_rereadable_options): Handle that option.
	(parse_ocsp_signer): Rename to ...
	(parse_fingerprint_item): this and add two args.
	* dirmngr/certcache.c (put_cert): Ignore all to be igored certs.
	Change callers to handle the new error return.

	dirmngr: Fix Let's Encrypt certificate chain validation.
	+ commit 68799378859739887549108bf765568ccbc328bc
	* dirmngr/certcache.c (find_cert_bysubject): Return the first trusted
	certififcate if any.

2021-10-05  NIIBE Yutaka  <gniibe@fsij.org>

	agent,dirmngr,kbx,scd,tpm2d: Use gnupg_sleep.
	+ commit 3918fa1a9488d56040d43e4af1254f9564266513
	* agent/findkey.c (unprotect): Use gnupg_sleep.
	* agent/gpg-agent.c (handle_connections): Likewise.
	* dirmngr/crlfetch.c (handle_connections): Likewise.
	* kbx/keyboxd.c (handle_connections): Likewise.
	* tpm2d/tpm3daemon.c (handle_connections): Likewise.
	* scd/scdaemon.c (handle_connections): Likewise.
	* scd/command.c (cmd_lock): Likewise.
	* dirmngr/ldap-wrapper.c (ldap_reaper_thread): Likewise.
	(ldap_wrapper_wait_connections): Use gnupg_usleep.

	agent: Fix calibrate_get_time use of clock_gettime.
	+ commit eeb25df6f8fc1e3cf18ec5578445f8fc281e41bc
	* agent/protect.c (USE_CLOCK_GETTIME): New macro.
	(calibrate_get_time): Only use clock_gettime if USE_CLOCK_GETTIME.

2021-10-01  Werner Koch  <wk@gnupg.org>

	tests: Use the new gpgconf.ctl based method.
	+ commit 84fcd8e6eb7e0786399e1f6461c3f60b0db2d070
	* tests/openpgp/defs.scm:  We expect that stuff is now installed.
	(tools): Fix the names.
	(intsalled?, bin-prefix): Remove.
	(tool-hardcoded): Simplify.
	(gpg-conf'): Simplify.
	(GNUPG_BUILDDIR): Do not anymore set this envvar.
	* tests/tpm2dtests/defs.scm: Ditto.

	build: Prepare for using installed versions for tests.
	+ commit 399ebf6d873d4178c1d527aa4df34bf16a76360e
	* tests/gpgconf.ctl.in: New.
	* tests/Makefile.am (EXTRA_DIST): Add new file.
	(TESTINST_DIRS): New.
	(clean-local): New.
	(clean-local-testinst): New.
	(check-recursive): New hook.
	(bin/gpgconf.ctl): Run a test install.
	* tests/cms/Makefile.am (TESTS_ENVIRONMENT): Set new envvar
	GNUPG_BUILD_ROOT.
	* tests/gpgme/Makefile.am (TESTS_ENVIRONMENT): Ditto.
	* tests/openpgp/Makefile.am (TESTS_ENVIRONMENT): Ditto.
	* tests/pkits/Makefile.am (TESTS_ENVIRONMENT): Ditto.
	* tests/tpm2dtests/Makefile.am (TESTS_ENVIRONMENT): Ditto.

	common: Support gpgconf.ctl also for BSDs.
	+ commit dbe1b237a6525585b36ed84c8634d6436dddaad1
	* common/homedir.c (MYPROC_SELF_EXE): New.
	(unix_rootdir): Use it here.  Also support GNUPG_BUILD_ROOT as
	fallback.

	common: Add keyword sysconfdir to the optional gpgconf.ctl file.
	+ commit ec847cf17fa85b8684e88ccf04c6d4c75d59c3ba
	* common/homedir.c (unix_rootdir): Add arg want_sysconfdir.
	(gnupg_sysconfdir): Return it.

2021-09-30  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Let it include keybox.h to avoid multiple typedefs.
	+ commit ca54d3f148933baac1f0243f76e4961abca285b1
	* kbx/backend.h: Include keybox.h.

2021-09-29  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Handle backsig for v5 signature.
	+ commit dd2e092339627c03cd0f506f3ef1be3e98d5ff83
	* g10/getkey.c (merge_selfsigs_subkey): Check v5 signature correctly.

	gpg: Ed448 and X448 are only for v5 (for subkey).
	+ commit 86cb04a23d2b0849cf684238d6d704aa45293214
	* g10/keygen.c (generate_subkeypair): Specify
	KEYGEN_FLAG_CREATE_V5_KEY for Ed448 or X448 key.

2021-09-28  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: A 20 byte fingerprint is right filled in version 2 blob.
	+ commit 08a3a4db27dcc3d50038cf5bdba94a6f0b548b01
	* kbx/keybox-blob.c (create_blob_header): Fix creating FPR20 key
	in blob with 32-byte fingerprint.

	gpg: Skip the packet when not used for AEAD.
	+ commit cc6152b802f2ab0ceaf3abb20caef6f7d806ffa3
	* g10/free-packet.c (free_packet): Add the case for case
	PKT_ENCRYPTED_AEAD.

2021-09-20  Ingo Klöcker  <dev@ingo-kloecker.de>

	build: Fix several "include file not found" problems.
	+ commit e2069d563283ab295858d33a250f229aab240f75
	* dirmngr/Makefile.am (t_ldap_parse_uri_CFLAGS): Add KSBA_CFLAGS.
	* kbx/Makefile.am (libkeybox_a_CFLAGS, libkeybox509_a_CFLAGS): Add
	NPTH_CFLAGS.
	* tools/Makefile.am (gpgtar_CFLAGS, gpg_wks_server_CFLAGS,
	gpg_wks_client_CFLAGS, gpg_pair_tool_CFLAGS): Add LIBGCRYPT_CFLAGS.

2021-09-20  giomba  <giomba@linux.it>

	po: Fixed Italian translation for key expiration.
	+ commit 548ff0398353c106f4e361a46818cd1716b825b8
	* po/it.po: Fix italian translation.

2021-09-17  Werner Koch  <wk@gnupg.org>

	common: Support a gpgconf.ctl file under Unix.
	+ commit d4768bb982adb5c8410303334ee8d82ba0d71f3b
	* common/homedir.c (unix_rootdir): New.
	(gnupg_bindir): Use it.
	(gnupg_libexecdir): Use it.
	(gnupg_libdir): Use it.
	(gnupg_datadir): Use it.
	(gnupg_localedir): Use it.

	common: New function substitute_envvars.
	+ commit 9c272dc245456d5403e3bd50553b4fdccb370e27
	* common/stringhelp.c (substitute_envvars): New.  Based on code in
	gpg-connect-agent.
	* common/t-stringhelp.c: Include sysutils.h.
	(test_substitute_envvars): New.

2021-09-14  Werner Koch  <wk@gnupg.org>

	gpg: Print a warning when importing a bad cv25519 secret key.
	+ commit dbfb7f809b89cfe05bdacafdb91a2d485b9fe2e0
	* g10/import.c (transfer_secret_keys): Add simple check.

2021-09-13  Werner Koch  <wk@gnupg.org>

	common: New envvar GNUPG_EXEC_DEBUG_FLAGS.
	+ commit f2b01025c3da97068b699c1f51309e18730a4bdb
	* common/exechelp-w32.c (gnupg_spawn_process_detached): Silence
	breakaway messages and turn them again into debug messages.

2021-09-09  Werner Koch  <wk@gnupg.org>

	sm: Add LotW support to the key listing.
	+ commit 255d4d5815d00f8d1b45d93cc617c49d375e891b
	* sm/certdump.c (parse_dn_part): Translate OID to "Callsign"
	* sm/keylist.c (oidtranstbl): Some more OIDs.

2021-09-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	build: Fix "ksba.h not found" problem.
	+ commit 08f227052fa3cc7089829a3b2ab8c4dda990b05b
	* sm/Makefile.am (t_minip12_CFLAGS): Add KSBA_CFLAGS.

2021-09-07  Werner Koch  <wk@gnupg.org>

	agent: Fix segv in GET_PASSPHRASE (regression)
	+ commit af3b1901549baa8fbe8140d9fa75a4a2b7a77a7e
	* agent/command.c (cmd_get_passphrase): Do not deref PI.  PI is always
	NULL.

2021-08-27  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Fix checksum computation for no UBID entry on disk.
	+ commit 0b64c27446c6f17f9c108e0fa95639db12d376ff
	* kbx/keybox-blob.c (create_blob_header): Fix the flag to match no
	UBID entry,
	(create_blob_finish): Fix the length of data to be hashed.

	common: Fix put_membuf.
	+ commit f271c6916469c0054c143adb4cee0588866a2a61
	* common/membuf.c (put_membuf): Allow NULL for the second arg.

2021-08-26  NIIBE Yutaka  <gniibe@fsij.org>

	common: Fix get_signal_name for GNU/Linux.
	+ commit c4ba712736ddeda66055567874d573e79d22666b
	* common/signal.c (get_signal_name): Use sigdescr_np if available.
	* configure.ac: Check the function.

2021-08-24  Werner Koch  <wk@gnupg.org>

	Release 2.3.2.
	+ commit 3bf8d7e1b7e0482f698b54a6975bdd9aa354244e


	dirmngr: Change the default keyserver.
	+ commit 55b5928099bafbd5409d3377a42259c11e394cd0
	* configure.ac (DIRMNGR_DEFAULT_KEYSERVER): Change to
	keyserver.ubuntu.com.

	* dirmngr/certcache.c (cert_cache_init): Disable default pool cert.
	* dirmngr/http-ntbtls.c (gnupg_http_tls_verify_cb): Ditto.
	* dirmngr/http.c (http_session_new): Ditto.

	* dirmngr/server.c (make_keyserver_item): Use a different mapping for
	the gnupg.net names.

2021-08-24  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Report the status of NO_SECKEY for decryption.
	+ commit 3ed5f566fc057975d0158bb637c72bd118aba7f8
	* g10/mainproc.c (proc_encrypted): Fix the condition to report
	NO_SECKEY even when the key was not considered by get_session_key.

2021-08-20  Werner Koch  <wk@gnupg.org>

	wkd: Properly unescape the user-id from a key listing.
	+ commit 87d238de3d9d537cacc9dd3c6d954845203ea2cb
	* tools/wks-util.c (append_to_uidinfo_list): Unescape UID.

	wkd: Fix client issue with leading or trailing spaces in user-ids.
	+ commit b4345f7521cb4c3f4af7894f5d6d840fda85e82f
	* common/recsel.c (recsel_parse_expr): Add flag -t.
	* common/stringhelp.c: Remove assert.h.
	(strtokenize): Factor code out to do_strtokenize.
	(strtokenize_nt): New.
	(do_strtokenize): Add arg trim to support the strtokenize_nt.
	* common/t-stringhelp.c (test_strtokenize_nt): New test cases.

	* tools/wks-util.c (wks_list_key): Use strtokenize_nt and the recsel
	flag -t.

2021-08-20  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Don't release the context until list_finish for PC/SC.
	+ commit 1565baa93ae39a81c5b00ca4558cd24838b4ce54
	* scd/apdu.c (apdu_dev_list_start): Increment PCSC.COUNT here.
	(apdu_dev_list_finish): Decrement PCSC.COUNT.

2021-08-19  Werner Koch  <wk@gnupg.org>

	gpg: Return SUCCESS/FAILURE status also for --card-edit/name.
	+ commit c1a23c3664753656bd4d22aafe0fb89d9bac5147
	* g10/card-util.c (change_name): Call write_sc_op_status.

2021-08-18  Werner Koch  <wk@gnupg.org>

	agent: Use the sysconfdir for a pattern file.
	+ commit 661c2ae96699e135294cfd98e1fbc385d35f5f0e
	* agent/genkey.c (do_check_passphrase_pattern): Use make_filename.

	agent: Ignore passphrase constraints for a generated passphrase.
	+ commit b89b1f35c29ceaebe39b31444936aa66c9297f2c
	* agent/agent.h (PINENTRY_STATUS_PASSWORD_GENERATED): New.
	(MAX_GENPIN_TRIES): Remove.
	* agent/call-pinentry.c (struct entry_parm_s):
	(struct inq_cb_parm_s): Add genpinhash and genpinhas_valid.
	(is_generated_pin): New.
	(inq_cb): Suppress constraints checking for a generated passphrase.
	No more need for several tries to generate the passphrase.
	(do_getpin): Store a generated passphrase/pin in the status field.
	(agent_askpin): Suppress constraints checking for a generated
	passphrase.
	(agent_get_passphrase): Ditto.
	* agent/command.c (cmd_get_passphrase): Ditto.

	agent: Improve the GENPIN callback.
	+ commit 8ed79103474c17d8dce20c740fc9813ada5f79ac
	* agent/call-pinentry.c (DEFAULT_GENPIN_BYTES): Replace by  ...
	(DEFAULT_GENPIN_BITS): this and increase to 150.
	(generate_pin): Make sure that we use at least 128 bits.

	agent: Fix for zero length help string in pinentry hints.
	+ commit 9fb646660258c2842edd6662688eafbc8d751ba7
	* agent/call-pinentry.c: Remove unused assert.h.
	(inq_cb): Fix use use of assuan_end_confidential in case of nested
	use.
	(do_getpin): Ditto.
	(setup_formatted_passphrase): Escape the help string.
	(setup_enforced_constraints): Ignore empty help strings.

	common,w32: Replace log_debug by log_info for InProcessJobs.
	+ commit 629f4a5cffb737454aaf6a5965cfb6d7b03796fc
	* common/exechelp-w32.c (gnupg_spawn_process_detached): Use log_info.

2021-08-13  Werner Koch  <wk@gnupg.org>

	agent: Make QT_QPA_PLATFORMTHEME=qt5ct work for the pient.
	+ commit 1305baf0994059f458b1d5ca28a355c12932fab3
	* agent/call-pinentry.c (atfork_core): Pass DISPLAY.

	agent: New option --check-sym-passphrase-pattern.
	+ commit 7c45a69eb988e9c0329d75900af0c5b1e47291b7
	* agent/gpg-agent.c (oCheckSymPassphrasePattern): New.
	(opts): Add --check-sym-passphrase-pattern.
	(parse_rereadable_options): Set option.
	(main): Return option info.
	* tools/gpgconf-comp.c: Add new option.
	* agent/agent.h (opt): Add var check_sym_passphrase_pattern.
	(struct pin_entry_info_s): Add var constraints_flags.
	(CHECK_CONSTRAINTS_NOT_EMPTY): New to replace a hardwired 1.
	(CHECK_CONSTRAINTS_NEW_SYMKEY): New.
	* agent/genkey.c (check_passphrase_pattern): Rename to ...
	(do_check_passphrase_pattern): this to make code reading
	easier. Handle the --check-sym-passphrase-pattern option.
	(check_passphrase_constraints): Replace arg no_empty by a generic
	flags arg.  Also handle --check-sym-passphrase-pattern here.
	* agent/command.c (cmd_get_passphrase): In --newsymkey mode pass
	CHECK_CONSTRAINTS_NEW_SYMKEY flag.
	* agent/call-pinentry.c (struct entry_parm_s): Add constraints_flags.
	(struct inq_cb_parm_s): New.
	(inq_cb): Use new struct for parameter passing.  Pass flags to teh
	constraints checking.
	(do_getpin): Pass constraints flag down.
	(agent_askpin): Take constrainst flag from the supplied pinentry
	struct.

2021-08-12  Ingo Klöcker  <dev@ingo-kloecker.de>

	agent: Make --pinentry-formatted-passphrase a simple flag.
	+ commit 99601778f4a9dc1c9fee792361c959f5e0732cfd
	* agent/agent.h (opt): Change type of pinentry_formatted_passphrase
	to int (as for other flags).
	* agent/call-pinentry.c (setup_formatted_passphrase): Remove no longer
	needed translated strings. Write option without value to Assuan
	connection.
	* agent/gpg-agent.c (opts): Use ARGPARSE_s_n for
	oPinentryFormattedPassphrase.
	(parse_rereadable_options): Set option to 1.

2021-08-11  Werner Koch  <wk@gnupg.org>

	w32: Move socketdir to LCOAL_APPDATA.
	+ commit 0802cbb59b21e06e16b4fd8596934c5565e7f659
	* common/homedir.c (is_gnupg_default_homedir): Use standard_homedir
	instead of the constant which makes a difference on Windows.
	(_gnupg_socketdir_internal) [W32]: Move the directory to LOCAL_APPDATA.
	(gnupg_cachedir): Remove unsued function.

	* common/sysutils.c (gnupg_rmdir): New.
	* tools/gpgconf.c (main): s/rmdir/gnupg_rmdir/.

	gpgconf,w32: Print more registry diagnostics with --list-dirs.
	+ commit 4cc534020669fa038f6a2107a55fe3b42fc065dc
	* tools/gpgconf.c (list_dirs): Figure out classes with the key.

2021-08-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	agent: Add checkpin inquiry for pinentry.
	+ commit 5976d293ef9bd953b6e9c61a45ad1f4e85a2743c
	* agent/call-pinentry.c (inq_cb): Handle checkpin inquiry.
	(setup_enforced_constraints): New.
	(agent_get_passphrase): Call setup_enforced_constraints if new
	passphrase is requested.

	agent: New option --pinentry-formatted-passphrase.
	+ commit bf20a80f68449cc83b67c53ba9a0a84c45827ac4
	* agent/agent.h (opt): Add field pinentry_formatted_passphrase.
	* agent/call-pinentry.c (setup_formatted_passphrase): New.
	(agent_get_passphrase): Pass option to pinentry.
	* agent/gpg-agent.c (oPinentryFormattedPassphrase): New.
	(opts): Add option.
	(parse_rereadable_options): Set option.

2021-08-05  NIIBE Yutaka  <gniibe@fsij.org>

	build: Simplify for string.h and getopt.h.
	+ commit 29d58e9de7838bcf32e358602abd4ed4498566f8
	* configure.ac (AC_CHECK_HEADERS): Remove string.h and getopt.h.
	* dirmngr/ks-engine-ldap.c: Remove including getopt.h.
	* tools/make-dns-cert.c: Likewise.

	sm: Fix pwri.
	+ commit 100c954ab0d6df509df582cb22ef515171462654
	* sm/decrypt.c (pwri_parse_pbkdf2): Use int for digest algo.
	(pwri_decrypt): Use int for cipher algo and digest algo.

	build: Remove duplication of AC_HEADER_TIME.
	+ commit 3f33c7ffcca09d4252d0418fdc2d31c0c8e486f4
	* configure.ac: Have a single AC_HEADER_TIME.

	build: Update checking headers.
	+ commit a89f13726d08413d4bddcb6afed402de1de9e4fd
	* configure.ac (AC_CHECK_HEADERS): Remove pty.h utmp.h, util.h,
	and libutil.h.

2021-08-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	common: Pass XDG_SESSION_TYPE and QT_QPA_PLATFORM envvars to pinentry.
	+ commit 94d18320b2b0bb5e3fa2023df8ac57078b2f6ecb
	* common/session-env.c (stdenvnames): Add XDG_SESSION_TYPE and
	QT_QPA_PLATFORM.

2021-07-29  Werner Koch  <wk@gnupg.org>

	sm,w32: Fix Unicode problem on key box creation.
	+ commit 7cdd06af479298748c79357dcb36ca1ba4d36bb1
	* sm/keydb.c (maybe_create_keybox): Replace access by gnupg_access

	tools: Extend gpg-check-pattern.
	+ commit 73c03e02322880c740310207dd2151cfd843792e
	* tools/gpg-check-pattern.c: Major rewrite.

2021-07-22  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Small clean up for card access.
	+ commit 5c8124b8b9554c7843feccf408648c9689bce243
	* scd/app.c (app_get_challenge): Remove the check to ref_count.
	* scd/command.c (send_client_notifications): Update comments.

	scd: Fix direct use of card with no ctrl->card_ctx.
	+ commit 50ad29f9a72f5454067bd0ca34fc1a71ac06b831
	* scd/app.c (maybe_switch_app): Remove check of ref_count.

2021-07-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	agent: Add translatable text for Caps Lock hint.
	+ commit b2a6e5b5169602052ae87d38588bdd3bd76fddad
	* agent/call-pinentry.c (start_pinentry): Add new default text.

2021-07-21  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix access to list of cards (3/3).
	+ commit 0d6b4210cf31d1c3ca0e8b034537a158fe3caca8
	* scd/app-common.h (card_reset): Simplify more.
	(select_additional_application): Supply CARD.
	(card_ref, card_unref): Remove.
	(card_get, card_put): New.
	* scd/app.c (card_reset): No locking/unlocking inside.
	(app_switch_current_card): Fix comment.
	(select_additional_application): No locking/unlocking inside.
	(do_with_keygrip): New, unlocked version.
	(card_get): New, with support of KEYGRIP.
	(card_unref): Remove.
	(card_put): New.
	(app_write_learn_status, app_readcert: No locking/unlocking inside.
	(app_readkey, app_getattr, app_setattr, app_sign, app_auth): Likewise.
	(app_decipher, app_writecert, app_writekey): Likewise.
	(app_genkey, app_get_challenge, app_change_pin): Likewise.
	(app_check_pin, app_switch_active_app): Likewise.
	* scd/command.c (do_reset): Use card_get/card_put.
	(open_card_with_request): Use card_get/card_put, return CARD locked.
	(cmd_serialno): Follow the change of open_card_with_request.
	(cmd_switchapp): Use card_get/card_put.
	(cmd_learn, cmd_readcert, cmd_readkey, cmd_pksign): Likewise.
	(cmd_pkauth, cmd_pkdecrypt, cmd_getattr): Likewise.
	(cmd_setattr, cmd_writecert, cmd_writekey): Likewise.
	(cmd_genkey, cmd_random, cmd_passwd): Likewise.
	(cmd_checkpin, cmd_getinfo, cmd_restart): Likewise.
	(cmd_disconnect, cmd_apdu, cmd_devinfo): Likewise.

	scd: Fix access to list of cards (2/3).
	+ commit b436fb6766b400167e5d57ff1116600bb496b04f
	* scd/app-common.h (card_reset, select_application): Simplify.
	* scd/app.c (card_reset, select_application): Simplify.
	* scd/command.c (do_reset): Follow the change.
	(open_card, open_card_with_request): Follow the change.

	scd: Fix access to list of cards (1/3).
	+ commit 216945a80e7b6b9d366493fa43fc7e99c830d81c
	* scd/app.c (card_list_lock): Use MRSW lock.
	(lock_r_card_list, unlock_r_card_list): New.
	(lock_w_card_list, unlock_w_card_list): New.
	(app_dump_state, app_send_devinfo): Use the MRSW lock.
	(select_application, app_switch_current_card): Likewise.
	(scd_update_reader_status_file): Likewise.
	(initialize_module_command, send_card_and_app_list): Likewise.
	(app_do_with_keygrip, app_wait): Likewise.

2021-07-08  Werner Koch  <wk@gnupg.org>

	kbx: Improve debugging of the search descriptions in keyboxd.
	+ commit b871824fefa114db931762243537663cc1095cfa
	* kbx/frontend.c (dump_search_desc): New.
	(kbxd_search): Actually log the search descriptions.

	kbx: Fix keyboxd searching with multiple patterns.
	+ commit 101ba4f18aceb39c4d5f0e0a7e16e66827f8e612
	* kbx/keybox-search-desc.h (struct keydb_search_desc): New flag
	name_used.
	* common/userids.c (classify_user_id): Set flag.
	* kbx/kbxserver.c (struct search_backing_store_s): New.
	(cmd_search): use a backing store for the const pointers.
	(kbxd_start_command_handler): Release the backing store.

2021-07-06  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Detect external interference when PCSC_SHARED.
	+ commit 044e5a3c3801fde7fa3b26986825377016e73103
	* scd/app-common.h (check_aid): New method.
	* scd/app-openpgp.c (do_check_aid): New.
	* scd/app-piv.c (do_check_aid): New.
	* scd/app.c (check_external_interference): New.
	(maybe_switch_app): Check interference to determine switching is
	needed.

2021-06-29  Werner Koch  <wk@gnupg.org>

	artwork: Explain the license for the logo.
	+ commit 5f78ae696c10df43c2b2fc29765e28b85caf5376


2021-06-25  Werner Koch  <wk@gnupg.org>

	agent: Fix regression in agent_get_shadow_info_type.
	+ commit a6efde307f7beb199b543f78b61c317fa2708202
	* agent/protect.c (agent_get_shadow_info_type): Return the correct
	value.

	gpg: Let --fetch-key return an exit code on failure.
	+ commit 9579c7786278b75d9c58b7c21b2f3c8bc7849810
	* g10/keyserver.c (keyserver_fetch): Return an error code.
	* g10/gpg.c (main) <aFetchKeys>: Return 1 in case of no data.

2021-06-23  NIIBE Yutaka  <gniibe@fsij.org>

	scd:ccid: Handle LIBUSB_TRANSFER_OVERFLOW interrupt transfer.
	+ commit 25ae80b8eb6e9011049d76440ad7d250c1d02f7c
	* scd/ccid-driver.c (intr_cb): Ignore LIBUSB_TRANSFER_OVERFLOW.

2021-06-22  Werner Koch  <wk@gnupg.org>

	tools: Extend ccidmon to print T=1 APDUs.
	+ commit 2c6b62b3572fe43cb6b89ec5fb0bc62385a4b230
	* tools/ccidmon.c (print_as_ascii): New.
	(print_t1_block): New.
	(print_p2r_xfrblock): Print APDUs
	(print_r2p_datablock): Ditto.

	tests: Cope with broken Libgcrypt versions.
	+ commit 5df658233a3a0c05fac0b4d4889f033ea0d0e034
	* common/t-sexputil.c (test_ecc_uncompress): Ignore unknwon curve
	errors.

	w32: Add fallback in case the Windows console can't cope with Unicode.
	+ commit edfe9453be5f8ba374da0ab860be863d66965c56
	* common/ttyio.c (w32_write_console): Fallback to WriteConsoleA on
	error.

	scd:p15: Prepare AODF parsing for other authentication types.
	+ commit e387cc97c82313457e4f79729a137e5871891bc1
	* scd/app-p15.c (auth_type_t): New.
	(struct aodf_object_s): Add field auth_type.
	(read_ef_aodf): Distinguish between pin and authkey types.  Include
	the authtype in the verbose mode diags.

2021-06-21  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix regression in KS_GET for mail address pattern.
	+ commit d5126efd895bc2af0a7e63dbf4aa782ce47ecc40
	* dirmngr/ks-engine-hkp.c (ks_hkp_search): Munge mail address pattern.
	(ks_hkp_get): Allow for mail addresses.
	-

	Before the keyserver changes in 2.2.28 gpg passed dirmngr a pail
	address as an exact pattern (e.g. "=foo@example.org").  Since 2.2.28
	the mail address is detected gpg gpg and we see for example
	"<foo@example.org>".  This patch fixes this to turn a mail address
	into an exact match again.

2021-06-18  Werner Koch  <wk@gnupg.org>

	scd:p15: Add pre-check for ascii-numeric PINs.
	+ commit 029924a46e08ffcda038d89f06abfb41c980a9ad
	* scd/app-p15.c (verify_pin): acii-numerix is different than BCD.

	scd:p15: Add basic support for AET JCOP cards.
	+ commit 544ec7872aed24c296ea34fac777eca287f7bb47
	* scd/app-p15.c (CARD_TYPE_AET): New.
	(cardtype2str): Add string.
	(card_atr_list): Add corresponding ATR.
	(app_local_s): New flag no_extended_mode.  Turn two other flags into
	bit flags.
	(select_ef_by_path): Hack to handle the 3FFF thing.
	(readcert_by_cdf): Do not use etxended mode for AET.
	(app_select_p15): Set no_extended_mode.

	scd:p15: Handle cards with bad encoded path objects.
	+ commit 7a8545c91b09277b0833dc0e5881ba5d1c8dbca3
	* scd/app-p15.c (read_ef_prkdf, read_ef_pukdf)
	(read_ef_cdf, read_ef_aodf): Allow for a zero length path and
	correctly skip unsupported auth types.

	scd: Improve reading of binary records.
	+ commit 44f977d0e332e77fb8a775c4837c00118bbe08cb
	* scd/iso7816.c (iso7816_read_binary_ext): Handle the 0x6a86 SW the
	same as 6b00.
	* scd/apdu.c (apdu_get_atr): Modify debug messages.
	* scd/app-p15.c (app_select_p15): Print FCI on error.
	(read_p15_info): Clean up diag in presence of debug options.

2021-06-17  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix RESET handling.
	+ commit 7718244168c948171ffd37d7e964cbcd172661c6
	* scd/app.c (scd_update_reader_status_file): Clear ->reset_requested.

2021-06-16  NIIBE Yutaka  <gniibe@fsij.org>

	dirmngr: Fix build with --disable-ldap.
	+ commit c6900f5723b4edc899aaea267ed599b5ad724142
	* dirmngr/dirmngr.c (parse_rereadable_options) [USE_LDAP]:
	Conditionalize.

2021-06-16  Werner Koch  <wk@gnupg.org>

	sm: New option --ldapserver as an alias for --keyserver.
	+ commit 89df86157e3580aae7e391382f4a5451a192fc68
	* sm/gpgsm.c (opts): Add option --ldapserver and make --keyserver an
	alias.

	dirmngr: Allow to pass no filter args to dirmngr_ldap.
	+ commit 14528ec66bd7dce28c7540fa9a34f35de54261c1
	* dirmngr/dirmngr_ldap.c (main): Handle no args case.

	dirmngr: Rewrite the LDAP wrapper tool.
	+ commit 864ea251983977b91a7f6ff5964e497cf4b208dc
	* dirmngr/ldap-misc.c: New.
	* dirmngr/ldap-misc.h: New.
	* dirmngr/ks-engine-ldap.c: Include ldap-misc.h.
	(ldap_err_to_gpg_err, ldap_to_gpg_err): Move to ldap-misc.c.
	* dirmngr/ldap-wrapper.c (ldap_wrapper): Print list of args in debug
	mode.
	* dirmngr/server.c (lookup_cert_by_pattern): Handle GPG_ERR_NOT_FOUND
	the saqme as GPG_ERR_NO_DATA.
	* dirmngr/ldap.c (run_ldap_wrapper): Add args tls_mode and ntds.
	Remove arg url.  Adjust for changes in dirmngr_ldap.
	(url_fetch_ldap): Remove args host and port.  Parse the URL and use
	these values to call run_ldap_wrapper.
	(attr_fetch_ldap): Pass tls flags to run_ldap_wrapper.
	(rfc2254_need_escape, rfc2254_escape): New.
	(extfilt_need_escape, extfilt_escape): New.
	(parse_one_pattern): Rename to ...
	(make_one_filter): this.  Change for new dirmngr_ldap calling
	convention.  Make issuer DN searching partly work.
	(escape4url, make_url): Remove.
	(start_cert_fetch_ldap): Change for new dirmngr_ldap calling
	convention.
	* dirmngr/dirmngr_ldap.c: Major rewrite.

	* dirmngr/t-ldap-misc.c: New.
	* dirmngr/t-support.h (DIM, DIMof): New.
	* dirmngr/Makefile.am (dirmngr_ldap_SOURCES): Add ldap-misc.c
	(module_tests) [USE_LDAP]: Add t-ldap-misc.
	(t_ldap_parse_uri_SOURCES): Ditto.
	(t_ldap_misc_SOURCES): New.

	dirmngr: Remove useless code.
	+ commit bcb99315627ec38aa5c9fe097075a82bdc8a2043
	* dirmngr/ks-engine-ldap.c (my_ldap_connect): Remove the
	password_param thing because we set the password directly without an
	intermediate var.

	dirmngr: Fix default port for our redefinition of ldaps.
	+ commit 58e4c82512a4b0828f78fc9f03dbcdbf77760b5c
	* dirmngr/server.c (make_keyserver_item): Fix default port for ldaps.
	Move a tmpstr out of the blocks.
	* dirmngr/ks-engine-ldap.c (my_ldap_connect): Improve diagnostics.

	dirmngr: Use --ldaptimeout for OpenPGP LDAP keyservers.
	+ commit 3e05f99e8db5c4039d352d5bd9dde01ed9653f2f
	* dirmngr/ks-engine-ldap.c (my_ldap_connect): Use LDAP_OPT_TIMEOUT.

	* dirmngr/dirmngr.c (main): Move --ldaptimeout setting to ...
	(parse_rereadable_options): here.

	dirmngr: New option --ldapserver.
	+ commit 52cf32ce2f904b2e6f53f406a90458f6ef148af9
	* dirmngr/dirmngr.c (opts): Add option --ldapserver.
	(ldapserver_list_needs_reset): New var.
	(parse_rereadable_options): Implement option.
	(main): Ignore dirmngr_ldapservers.conf if no --ldapserver is used.

	* dirmngr/server.c (cmd_ldapserver): Add option --clear and list
	configured servers if none are given.

	dirmngr: Allow for non-URL specified ldap keyservers.
	+ commit eb3a629154de10a5414a5d2c2b9941ef8bf1eeaf
	* dirmngr/server.c (cmd_ldapserver): Strip an optional prefix.
	(make_keyserver_item): Handle non-URL ldap specs.
	* dirmngr/dirmngr.h (struct ldap_server_s): Add fields starttls,
	ldap_over_tls, and ntds.

	* dirmngr/ldapserver.c (ldapserver_parse_one): Add for an empty host
	string.  Improve error messages for the non-file case.  Support flags.
	* dirmngr/ks-action.c (ks_action_help): Handle non-URL ldap specs.
	(ks_action_search, ks_action_get, ks_action_put): Ditto.
	* dirmngr/ks-engine-ldap.c: Include ldapserver.h.
	(ks_ldap_help): Handle non-URL ldap specs.
	(my_ldap_connect): Add args r_host and r_use_tls.  Rewrite to support
	URLs and non-URL specified keyservers.
	(ks_ldap_get): Adjust for changes in my_ldap_connect.
	(ks_ldap_search): Ditto.
	(ks_ldap_put): Ditto.

	gpg,sm: Simplify keyserver spec parsing.
	+ commit bebc71d2291e93afb76792c5e210836857103c36
	* common/keyserver.h: Remove.
	* sm/gpgsm.h (struct keyserver_spec): Remove.
	(opt): Change keyserver to a strlist_t.
	* sm/gpgsm.c (keyserver_list_free): Remove.
	(parse_keyserver_line): Remove.
	(main): Store keyserver in an strlist.
	* sm/call-dirmngr.c (prepare_dirmngr): Adjust for the strlist.  Avoid
	an ambiguity in dirmngr by adding a prefix if needed.

	* g10/options.h (struct keyserver_spec): Move definition from
	keyserver.h to here.  Remove most fields.
	* g10/keyserver.c (free_keyserver_spec): Adjust.
	(cmp_keyserver_spec): Adjust.
	(parse_keyserver_uri): Simplify.
	(keyidlist): Remove fakev3 arg which does not make any sense because
	we don't even support v3 keys.

	dirmngr: Support pseudo URI scheme "opaque".
	+ commit 1c96f4d663c020167ed3d39e513751641dfc3567
	* dirmngr/http.h (HTTP_PARSE_NO_SCHEME_CHECK): New.
	* dirmngr/http.c (http_parse_uri): Use this flag.  Change all callers
	to use the new macro for better readability.
	(do_parse_uri): Add pseudo scheme "opaque".
	(uri_query_value): New.

2021-06-11  Werner Koch  <wk@gnupg.org>

	sm: Fix finding of issuer in use-keyboxd mode.
	+ commit 6b76693ff54297456b724ba53f7e6283e2a5a126
	* sm/keydb.c (struct keydb_local_s): Add field saved_search_result.
	(keydb_push_found_state): Implement for keyboxd.
	(keydb_pop_found_state): Ditto.
	(keydb_get_cert): Do not release the cert so that the function can be
	used again to get the same cert.  This is the same behaviour as in
	pubring.kbx mode.

	* sm/certchain.c, sm/import.c: Improve some error messages.

2021-06-11  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Support clearing of Reset Code by ''.
	+ commit 4e02db75e3a1da9012176f2cfe1638c8c0129f6f
	* scd/app-openpgp.c (do_change_pin): Allow null-string.

2021-06-09  Werner Koch  <wk@gnupg.org>

	gpgtar,w32: Fix file size computation.
	+ commit 14e36bdbe1c39bc23e70db775e05319367ee8adb
	* tools/gpgtar-create.c (fillup_entry_w32): Move parentheses.

2021-06-09  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix importing protected secret key.
	+ commit 7a80004d5407c6c48b21d57ba6edb8e5a2db4995
	* agent/cvt-openpgp.c (do_unprotect): Only modify SKEY when it is
	correctly decrypted.

2021-06-08  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix serial number detection for Yubikey 5.
	+ commit c3a9ee0b658887ca9baa4514187b17857fdf6586
	* scd/app.c (app_new_register): Handle serial number correctly.

2021-06-07  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix READER-PORT option handling for PC/SC.
	+ commit ee5b6af370fbee1b08136e5dc384cf7996bcfc4c
	* scd/apdu.c (apdu_open_reader): READERNO should be -1 when
	READER-PORT is specified for PC/SC.

2021-06-04  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Appropriate error code for importing key with no passwd.
	+ commit 21ef425e222ddfa460b37dece63adb67ff2e4dd1
	* agent/cvt-openpgp.c (convert_from_openpgp_main): Return
	GPG_ERR_BAD_SECKEY.

2021-06-03  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Support KEYGRIP search with traditional keyring.
	+ commit 9668ee097a1474299b8debecb1ee38620a327082
	* g10/keyring.c (keyring_search): Handle KEYDB_SEARCH_MODE_KEYGRIP.

2021-06-02  Werner Koch  <wk@gnupg.org>

	common: Allow for GCM decryption in de-vs mode.
	+ commit c17dac5ac3ccb374e5a1276d4bc9b444c390a4c5
	* common/compliance.c (gnupg_cipher_is_allowed): Allow GCM for gpgsm
	in decrypt mode.

	* tests/cms/samplemsgs/pwri-sample.gcm.p7m: Remove duplicated authtag

	sm: Support AES-GCM decryption.
	+ commit 4980fb3c6dde8c1dda975e8a36d6086c8456a631
	* tests/cms/samplemsgs/: Add sample messages.
	* sm/gpgsm.c (main): Use gpgrt_fcancel on decryption error.
	* sm/decrypt.c (decrypt_gcm_filter): New.
	(gpgsm_decrypt): Use this filter if requested.  Check authtag.

2021-05-28  Werner Koch  <wk@gnupg.org>

	gpgconf: Make runtime changes with different homedir work.
	+ commit 31c0aa2ff37f662c6391885d61ffd46ec3062e5a
	* tools/gpgconf-comp.c (dirmngr_runtime_change): Pass --homedir first.

2021-05-28  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix calling handle_pincache_put.
	+ commit 36f50b259cae0428264f4b7d60b82209e3dd8725
	* agent/call-scd.c (padding_info_cb): Fix the argument.

	scd: Fix zero-byte handling in ECC.
	+ commit 5b1806454c03b3b493222f405ffced80a5d430ad
	* scd/app-openpgp.c (ecc_writekey): Don't remove zero-byte.

2021-05-27  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Ed448 and X448 are only for v5 for --full-gen-key.
	+ commit 2b50f942672d9a2c325a818f21f69d3ee69255d3
	* g10/keygen.c (generate_keypair): Set pVERSION = 5, pSUBVERSION = 5,
	when it's Ed448 or X448.

	build: _DARWIN_C_SOURCE should be 1.
	+ commit be81941e1aca75d9e1d0dd2e2b234ae6df53c05a
	* configure.ac (*-apple-darwin*): Set _DARWIN_C_SOURCE 1.

2021-05-25  Werner Koch  <wk@gnupg.org>

	gpg: Partial fix for Unicode problem in output files.
	+ commit 30563ea29705016b08ff04fd8a833940ea94e4e8
	* g10/openfile.c (overwrite_filep): Use gnupg_access.

2021-05-21  Werner Koch  <wk@gnupg.org>

	common: Annotate leaked memory in homedir.c.
	+ commit 260bbb4ab27eab0a8d4fb68592b0d1c20d80179c
	* g10/trustdb.c (how_to_fix_the_trustdb): Use gnupg_homedir.
	* common/homedir.c (standard_homedir): Annotate leaked memory.
	(gnupg_daemon_rootdir): Ditto.
	(gnupg_socketdir): Ditto.
	(gnupg_sysconfdir): Ditto.
	(gnupg_bindir): Ditto.
	(gnupg_libdir): Ditto.
	(gnupg_datadir): Ditto.
	(gnupg_localedir): Ditto.
	(gnupg_cachedir): Ditto.
	(gpg_agent_socket_name): Ditto.
	(dirmngr_socket_name): Ditto.
	(keyboxd_socket_name): Ditto.
	(get_default_pinentry_name): Ditto.
	(gnupg_module_name): Ditto.
	(default_homedir): Ditto.  Make static.

2021-05-20  Werner Koch  <wk@gnupg.org>

	sm: Let --dump-cert --show-cert also print an OpenPGP fingerprint.
	+ commit 52bbdc731fd54ff6d2744d7aca8e48e2c2389cc9
	* sm/keylist.c (list_cert_raw): Print the OpenPGP fpr.

2021-05-20  Jakub Jelen  <jjelen@redhat.com>

	card: Intialize pointer to avoid double free.
	+ commit 98c52aeb31f4bf2604727aacad982fb51c04063f
	* tools/gpg-card.c (cmd_salut): Initialize data pointer

	scd: avoid memory leaks.
	+ commit 27e7bde12ee2b67425ae7011d976d2544c90fd9a
	* scd/app-p15.c (send_certinfo): free labelbuf
	  (do_sign): goto leave instead of return
	* scd/app-piv.c (do_sign): goto leave instead of return, fix typo in
	  variable name, avoid using uninitialized variables
	* scd/command.c (cmd_genkey): goto leave instead of return

	kbx: Avoid uninitialized read.
	+ commit fc5fac83b778f0ff61608c286448ab7fa14ccb2d
	* kbx/kbx-client-util.c (datastream_thread): Initialize pointer
	* kbx/keybox-dump.c (_keybox_dump_cut_records): free blob
	* kbx/kbxserver.c (kbxd_start_command_handler): do not free passed ctrl
	* kbx/keyboxd.c (check_own_socket): free sockname

	g10: Avoid memory leaks.
	+ commit fa0771f609b5fcb104c64a11aefc501b7a91696d
	* g10/call-agent.c (card_keyinfo_cb): free keyinfo.  Restructure to
	avoid backward gotos.
	* g10/keyedit.c (menu_set_keyserver_url): properly enclose the block
	* g10/keygen.c (gen_card_key): free pk and pkt

	dirmgr: Avoid double free.
	+ commit 25aa353bf833fdae1a96158b49daf7588ae3b109
	* dirmgr/http.c (http_prepare_redirect): Avoid double free
	* dirmgr/ocsp.c (check_signature): Initialize pointer

	common: Avoid double-free.
	+ commit 4704d1ce4e1e2ba9f986fb221346eda5c97f947b
	* common/name-value.c (do_nvc_parse): reset to null after ownership
	change

	agent: Fix memory leaks.
	+ commit 33a2362e566c0e0d7011abf2e5fa5704d7cb4206
	* agent/call-daemon.c (daemon_start): free wctp
	* agent/call-scd.c (agent_card_pksign): return error instead of noop
	(card_keyinfo_cb): free keyinfo.  Restructure to avoid a goto backwards.
	* agent/protect.c (agent_get_shadow_info_type): allocate only as a last
	action.  Catch xtrymalloc failure.
	(agent_is_tpm2_key): Free buf.

	sm: Avoid memory leaks and double double-free.
	+ commit e6132bc9f41727ea1abe2d6298610223c11639a2
	* sm/certcheck.c (extract_pss_params): Avoid double free
	* sm/decrypt.c (gpgsm_decrypt): goto leave instead of return
	* sm/encrypt.c (encrypt_dek): release s_pkey
	* sm/server.c (cmd_export): free list
	(do_listkeys): free lists

	g10: Fix memory leaks.
	+ commit 2af7bb2295cda5377546cedd0c906a3cff4d2427
	* g10/card-util.c (change_pin): free answer on errors
	  (ask_card_keyattr): free answer on error
	* g10/cpr.c (do_get_from_fd): free string
	* g10/gpg.c (check_permissions): free dir on weird error
	* g10/import.c (append_new_uid): release knode
	* g10/keyedit.c (menu_set_keyserver_url): free answer
	  (menu_set_keyserver_url): free user
	* g10/keygen.c (print_status_key_not_created): move allocation after
	  sanity check
	  (ask_expire_interval): free answer
	  (card_store_key_with_backup): goto leave instaed of return
	* g10/keyserver.c (parse_keyserver_uri): goto fail instead of return
	* g10/revoke.c (gen_desig_revoke): release kdbhd
	  (gen_desig_revoke): free answer
	* g10/tofu.c (ask_about_binding): free sqerr and response
	* g10/trustdb.c (ask_ownertrust): free pk

	dirmgr: clean up memory on error code paths.
	+ commit 0d2c1e9046faf102809bc65329c22b6cf8d62ea0
	* dirmgr/crlcache.c (finish_sig_check): goto leave instead of return
	* dirmgr/http.c (send_request): free authstr and proxy_authstr
	* dirmgr/ldap.c (start_cert_fetch_ldap): free proxy
	* dirmgr/ocsp.c (check_signature): release s_hash

	agent: Avoid memory leaks in error code paths.
	+ commit a95ddffdcd58383cce93677be5e7e11c5c229a98
	* agent/command.c (cmd_genkey): Use goto instead of return.
	* agent/cvt-openpgp.c (convert_from_openpgp_main): Ditto.
	* agent/genkey.c (agent_ask_new_passphrase): Fix typo to free correct
	pointer
	(agent_genkey): Release memory
	* agent/gpg-agent.c (check_own_socket): Free sockname
	* agent/protect-tool.c (read_key): Free buf.
	(agent_askpin): Free passphrase

2021-05-19  Werner Koch  <wk@gnupg.org>

	dirmngr: For KS_SEARCH return the fingerprint also with LDAP.
	+ commit a660e1060630e8d75ecb43abf69dbb73378c1df9
	* dirmngr/ks-engine-ldap.c (extract_keys): Return the fingerprint if
	available.
	(ks_ldap_search): Ditto.
	(extract_keys): Make sure to free the ldap values also in corner
	cases.
	(my_ldap_value_free): New.
	(ks_ldap_get): Ditto.
	(ks_ldap_search): Ditto.
	(my_ldap_connect): Ditto.

	gpg: Improve speed of secret key listing.
	+ commit 40da61b89b62dcb77847dc79eb159e885f52f817
	* agent/command.c (cmd_keyinfo): Factor some code out to ...
	(get_keyinfo_on_cards): ... new.
	(cmd_havekey): Add --list mode.
	* g10/gpg.h (struct server_control_s): Add new caching vars.
	* g10/gpg.c (gpg_deinit_default_ctrl): Release cache.
	* g10/call-agent.c (agent_probe_any_secret_key): Init and try to use
	the keygrip cache.
	(agent_genkey): Clear the cache.
	(agent_import_key): Ditto.

	* g10/keylist.c (list_all, list_one): Pass ctrl to
	agent_probe_any_secret_key.
	* g10/getkey.c (lookup): Ditto.

2021-05-18  Werner Koch  <wk@gnupg.org>

	gpg: Fix sending an OpenPGP key with umlaut to an LDAP keyserver.
	+ commit b8e6e485ee0b3389992f5de4d717e2e9cca92a9e
	* g10/call-dirmngr.c (record_output): Rewrite.

2021-05-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	scd:p15: Fix logic for appending product name to MANUFACTURER.
	+ commit 65bc5ea95e608869fe57dae43e201ed47b98f9fe
	* scd/app-p15.c (do_getattr): Append product name to MANUFACTURER if
	manufacturer_id does not already contain a bracket and if we have a
	product name.

2021-05-17  Werner Koch  <wk@gnupg.org>

	gpg: Use a more descriptive prompt for symmetric decryption.
	+ commit 6dfae2f402a702ccd7f2c585b28cb356e9f26a26
	* g10/keydb.h (GETPASSWORD_FLAG_SYMDECRYPT): New.
	(passphrase_to_dek_ext): Remove this obsolete prototype.
	* g10/passphrase.c (passphrase_get): Add arg flags.  Use new flag
	value.
	(passphrase_to_dek): Add arg flags and pass it on.
	* g10/mainproc.c (proc_symkey_enc): Use new flag.

	* sm/decrypt.c (pwri_decrypt): Use "passphrase".

	dirmngr: LDAP search by a mailbox now ignores revoked keys.
	+ commit 1406f551f1e00a03eabf5b8bd3011bf6393ce318
	* dirmngr/ks-engine-ldap.c (keyspec_to_ldap_filter): Ignore revoked
	and disable keys in mail mode.

	sm: Ask for the password for password based decryption (pwri)
	+ commit eeb65d3bbd7d461694d30009631739735a2b9bad
	* sm/decrypt.c (pwri_decrypt): Add arg ctrl.  Ask for passphrase.

	* sm/export.c (export_p12): Mark string as translatable.
	* sm/import.c (parse_p12): Ditto.

2021-05-14  Werner Koch  <wk@gnupg.org>

	sm: Support decryption of password based encryption (pwri)
	+ commit 02029f9eab87e9fd667829dfb083846275576398
	* sm/decrypt.c (pwri_parse_pbkdf2): New.
	(pwri_decrypt): New.
	(prepare_decryption): Support pwri.
	(gpgsm_decrypt): Test for PWRI.  Move IS_DE_VS flag to DFPARM.

2021-05-14  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Remove wrong assertion and add protection to PCSC.COUNT.
	+ commit 58b330e935b9225d5a389c5d858a0e7304f573ad
	* scd/apdu.c (apdu_dev_list_finish): Fix for calling
	release_pcsc_context.

2021-05-12  Werner Koch  <wk@gnupg.org>
	    Jakub Jelen  <jjelen@redhat.com>

	agent: Use SHA-256 for SSH fingerprint by default.
	+ commit 310b064f5271fe8566ebc996702ea1422875f425
	* agent/gpg-agent.c (parse_rereadable_options): Change default ssh
	fingerprint digest.
	(main): Ditto.

2021-05-11  Werner Koch  <wk@gnupg.org>

	A few minor code cleanups and typo fixes.
	+ commit 965bb0693c0df04e6dbd57a8b471944367cf6c4e
	* agent/command-ssh.c (ssh_handler_request_identities): Remove double
	check of ERR.
	* g10/getkey.c (get_pubkey_byname): Remove double use of break.
	* g10/pkglue.c (pk_encrypt): Handle possible NULL-ptr access due to
	failed malloc.

2021-05-11  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix allocation for EXTRAHASH.
	+ commit ac731dbbbd21f53d2f6bf69343e6bf553ebc9dad
	* g10/sign.c (clearsign_file): Fix the size to allocate.

	scd: Serialize READER_TABLE access for PC/SC.
	+ commit 32baa9acfb153004bdb2509f9516482b78f256a4
	* scd/apdu.c (apdu_dev_list_start): Remove locking READER_TABLE_LOCK.
	Don't increment PCSC.COUNT here.
	(apdu_dev_list_finish): Don't decrement PCSC.COUNT here.
	(apdu_open_reader): Protect access with READER_TABLE_LOCK.

2021-05-10  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix close_pcsc_reader.
	+ commit ec5591dc4e1f1b0340b9043a410dc62b63a90416
	* scd/apdu.c (close_pcsc_reader): Don't touch .RDRNAME field.
	(apdu_dev_list_finish): Clear .RDRNAME field and replace call of
	close_pcsc_reader by release_pcsc_context.  Add assertion.

	scd: Make sure releasing PC/SC context.
	+ commit cccc9bd5db1f00c35dff192935e91d46cafb259f
	* scd/apdu.c (release_pcsc_context): New.
	(close_pcsc_reader): Use release_pcsc_context.  Add assertion.
	(apdu_dev_list_start): Replace call of close_pcsc_reader
	into release_pcsc_context, add condition.

2021-05-07  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Increment PCSC.COUNT correctly.
	+ commit 0498ea8fbd57d0df3093301d551db6b287ccf622
	* scd/apdu.c (open_pcsc_reader): PCSC.COUNT should
	be incremented before possible call of close_pcsc_reader.

	scd: Fix memory leak for RDRNAME and serialize access.
	+ commit 5d1b41310682a599a16bcb95e18f56e62299059e
	* scd/apdu.c (close_pcsc_reader): Move locking to...
	(apdu_close_reader): ... here, as it's also needed for CCID driver.
	Free RDRNAME when closed.

	scd: Fix declarations for PC/SC access.
	+ commit 039aed9d401f3875eee0251d34be74de7a1daf84
	* scd/apdu.c (pcsc_begin_transaction, pcsc_transmit): Use HANDLE.

2021-05-06  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Recover the partial match for PORTSTR for PC/SC.
	+ commit 53bdc6288f9b474e53f06088130e304cee41b12d
	* scd/apdu.c (apdu_open_reader): Allow partial match of
	PORTSTR again just like 2.2 does.

	scd: When reader is specified, make sure only open once.
	+ commit d6fe82d3d1699eb417f87b487048f95fee91e2cd
	* scd/apdu.c (apdu_open_reader): Make sure not to try multiple times,
	when PORTSTR is specified.

2021-04-29  Werner Koch  <wk@gnupg.org>

	scd: Fix PC/SC removed card problem.
	+ commit 8d81fd7c01e8dfacc719ff190f8e364014e32fdf
	* scd/apdu.c (pcsc_cancel): New.
	(pcsc_init): Load new function.
	(connect_pcsc_card): Use it after a removed card error.

2021-04-28  Werner Koch  <wk@gnupg.org>

	scd: Fix problem with reader list becoming empty.
	+ commit bb8e3996e44f4f057f0771b9b72c89feae00f1b1
	* scd/apdu.c (close_pcsc_reader): Do not decrement refcount if already
	zero.  Always release context if or becomes zero.
	(apdu_dev_list_start): Unlock prior to close_pcsc_reader.  For PC/SC
	increment the count.  Always release the lock.
	(apdu_dev_list_finish): No more unlocking.  Use close_pcsc_reader
	instead of code duplication.

	* scd/apdu.c (pcsc_error_string): Add an error code.
	* scd/scdaemon.c (scd_kick_the_loop): Fix a diagnostic.

2021-04-27  Kirill Elagin  <kirelagin@gmail.com>

	scd: Fix unblock PIN by a Reset Code with KDF.
	+ commit f209d7d2db0e963a6ad1fa8c4f0c034ba0297842
	* scd/app-openpgp.c (do_change_pin): Use correct CHVNO=1 for
	pin2hash_if_kdf, for user's PIN.

2021-04-26  Werner Koch  <wk@gnupg.org>

	gpg: Fix mailbox based search via AKL keyserver method.
	+ commit 4fcfac6feb2a6c2b14883ba406afc917e8d4be42
	* g10/keyserver.c (keyserver_import_name): Rename to ...
	(keyserver_import_mbox): this.  And use mail search mode.
	* g10/getkey.c (get_pubkey_byname): Change the two callers.

	gpg: Do not use import-clean for LDAP keyserver imports.
	+ commit 99db4b0c7fd128ea5b2e251fe854bd57f6322238
	* g10/options.h (opts): New field expl_import_only.
	* g10/import.c (parse_import_options): Set it.
	* g10/keyserver.c (keyserver_get_chunk): Add special options for LDAP.

2021-04-25  Werner Koch  <wk@gnupg.org>

	gpg: Auto import keys specified with --trusted-keys.
	+ commit 100037ac0f558e8959fc065d4703c85c2962489e
	* g10/getkey.c (get_pubkey_with_ldap_fallback): New.
	* g10/trustdb.c (verify_own_keys): Use it.

	scd:p15: Fix last commit and improve D-TRUST detection.
	+ commit cc5aa68b6310bdeaa1102bb0d6a33420920648e7
	* scd/app-p15.c (read_p15_info): Improve D-TRUST card detection.
	(do_getattr): Fix faulty code for the last commit.  Append the product
	name to MANUFACTURER.

	scd:p15: Shorten the displayed s/n of RSCS cards.
	+ commit 21e3f750bd7dde2ae9ece01b1abdd1b47ba4fb04
	* scd/app-p15.c (get_dispserialno): Add dedicated handling for RSCS.

2021-04-23  Werner Koch  <wk@gnupg.org>

	gpg: Replace an obsolete trustdb function.
	+ commit 3cbc66410d62ad2f7e559095753a2385fe644d07
	* g10/trustdb.c (tdb_register_trusted_keyid): Make static.
	(tdb_register_trusted_key): Replace register_trusted_keyid by
	tdb_register_trusted_key.
	* g10/keygen.c (do_generate_keypair): Ditto.
	* g10/trust.c (register_trusted_keyid): Remove.

	gpg: Allow decryption w/o public key but with correct card inserted.
	+ commit 50293ec2ebf2a997dbad9a47166d694efcc0709a
	* agent/command.c (cmd_readkey): Add option --no-data and special
	handling for $SIGNKEYID and $AUTHKEYID.
	* g10/call-agent.c (agent_scd_getattr): Create shadow keys for KEY-FPR
	output.
	* g10/skclist.c (enum_secret_keys): Automagically get a missing public
	key for the current card.

	agent: Require verbose level 2 for handler started/terminated notices.
	+ commit 84c2d97cca76045bbe9d0598a10623d5d91e6530
	* agent/gpg-agent.c (do_start_connection_thread): Silence diags even
	more.

2021-04-23  NIIBE Yutaka  <gniibe@fsij.org>

	tools: Fix for --disable-tpm2d.
	+ commit 97ba94e52b2390f43fc1ac7db98e8ee7a37ddfb1
	* tools/gpgconf-comp.c: Conditionalize with BUILD_WITH_TPM2D.

2021-04-22  Werner Koch  <wk@gnupg.org>

	scd: Fix PSO_CSV for 512 bit curves.
	+ commit 9e24f2a45ce8038f662ec1a9893669e1d5604ec7
	* scd/iso7816.c (iso7816_pso_csv): Use BER-TLV instead of SIMPLE-TLV

	tests: Make sure that the build keyboxd is used.
	+ commit d36c4dc95b72b780375d57311bdf4ae842fd54fa
	* tests/openpgp/defs.scm (create-gpghome): Add keyboxd-program.

2021-04-21  Werner Koch  <wk@gnupg.org>

	card: New option --shadow for command list.
	+ commit 2fce99d73a6afc1a1a29041722a934bb81c7d739
	* tools/card-call-scd.c (scd_readkey): Add arg create_shadow.
	* tools/gpg-card.c (list_one_kinfo): Add arg create_shadow and pass it
	down to scd-readkey.  Change all callers to convey this arg.
	(cmd_list): Add option --shadow.

	agent: Silence error messages for READKEY --card.
	+ commit 8f2c9cb73538baab7da8107f2cceb2f6fc49642a
	* agent/command.c (cmd_readkey): Test for shadow key before creating
	it.

	gpg: Allow fingerprint based lookup with --locate-external-key.
	+ commit ec36eca08cdbf6653e7362e8e0e6c5f2c75b4a60
	* g10/keyserver.c (keyserver_import_fprint_ntds): New.
	* g10/getkey.c (get_pubkey_byname): Detect an attempt to search by
	fingerprint in no_local mode.

	keyboxd: Fix searching for exact mail addresses.
	+ commit f79e9540ca643b5cb912e7bfca2af56be428efed
	* kbx/kbxserver.c (cmd_search): Use the openpgp hack for calling
	classify_user_id.
	* kbx/backend-sqlite.c (run_select_statement): Remove angle brackets
	in exact addrspec mode.
	* g10/call-keyboxd.c (keydb_search): Do not duplicate the left angle
	bracket.
	* sm/keydb.c (keydb_search): Ditto.

	gpg,sm: Ignore the log-file option from common.conf.
	+ commit d153e4936e05ab3b15df3c092024d83ac9d6ca46
	* g10/gpg.c (main): Don't use the default log file from common.conf.
	* sm/gpgsm.c (main): Ditto.

2021-04-20  Werner Koch  <wk@gnupg.org>

	Release 2.3.1.
	+ commit cbbdb88627fe57ebf02b8b4bf9002d356e57e2e4


	Support log-file option from common.conf for all daemon.
	+ commit 45918813f0599505e4f84bd44b09fb708b4e7f23
	* agent/gpg-agent.c: Include comopt.h.
	(main): Read log-file option from common.conf.
	(reread_configuration): Ditto.
	* dirmngr/dirmngr.c: Include comopt.h.
	(main): Read log-file option from common.conf.
	(reread_configuration): Ditto.
	* kbx/keyboxd.c: Include comopt.h.
	(main): Read log-file option from common.conf.
	(reread_configuration): Ditto.
	* scd/scdaemon.c: Include comopt.h.
	(main): Read log-file option from common.conf.

	gpgconf: Fix a diagnostic output.
	+ commit b657d6c3bd8103d40d511a3293313a891a26a9f5
	* tools/gpgconf-comp.c (gc_component_launch): Fix diagnostic.
	* doc/examples/common.conf: Fix example.

	sm: New command --show-certs.
	+ commit 51419d63415ae2aa029f8829099b6789b264edc5
	* sm/keylist.c (do_show_certs): New.
	(gpgsm_show_certs): New.
	* sm/gpgsm.c (aShowCerts): New.
	(opts): Add --show-certs.
	(main): Call gpgsm_show_certs.

2021-04-19  Werner Koch  <wk@gnupg.org>

	build: Fix build problems on macOS for gpgsm tests and gpg-card.
	+ commit 5fe60576d50f7c857d0a865a9630212422fa1ad1
	* tools/gpg-card.c: Include ctype.h.
	* sm/Makefile.am (t_common_ldadd): Add LIBICONV.

2021-04-19  Damien Goutte-Gattat via Gnupg-devel  <gnupg-devel@gnupg.org>

	build: Allow selection of TSS library.
	+ commit 93c88d0af36b70a406997b40c49bfc14c17b4cd2
	* configure.ac: New option --with-tss to force the use of a
	specific TSS library.

	gpg: Fix showpref to list AEAD feature.
	+ commit 86f446fd446fcc7295ecf6b37a3f4cca45a165f1
	* g10/keyedit.c (show_prefs): Show 'AEAD' if flags.aead is set.

2021-04-19  Werner Koch  <wk@gnupg.org>

	gpg,gpgsm: Move use-keyboxd to the new conf file common.conf.
	+ commit d13c5bc244ce1daed285424d920171fc2bcd7290
	* common/comopt.c, common/comopt.h: New.
	* common/Makefile.am: Add them.
	* g10/gpg.c: Include comopt.h.
	(main): Also parse common.conf.
	* sm/gpgsm.c: Include comopt.h.
	(main): Set a flag for the --no-logfile option.  Parse common.conf.

	* tools/gpgconf-comp.c (known_options_gpg): Remove "use-keyboxd", add
	pseudo option "use_keyboxd".
	(known_pseudo_options_gpg): Add pseudo option "use_keyboxd".
	(known_options_gpgsm): Remove "use-keyboxd".

	* tests/openpgp/defs.scm (create-gpghome): Create common.conf.

	* doc/examples/common.conf: New.

2021-04-16  Werner Koch  <wk@gnupg.org>

	gpg: Lookup a missing public key of the current card via LDAP.
	+ commit d7e707170fbe2956deb3d81e2802d21352079722
	* g10/getkey.c (get_seckey_default_or_card): Lookup a missing public
	key from the current card via LDAP.
	* g10/call-dirmngr.c: Include keyserver-intetnal.h.
	(gpg_dirmngr_ks_get): Rename arg quick into flags.  Take care of the
	new LDAP flag.
	* g10/keyserver-internal.h (KEYSERVER_IMPORT_FLAG_QUICK): New.
	Replace the use of the value 1 for the former quick arg.
	(KEYSERVER_IMPORT_FLAG_LDAP): New.
	* g10/keyserver.c (keyserver_get_chunk): Increase the reserved line
	length.
	* dirmngr/ks-action.c (ks_action_get): Add arg ldap_only.
	* dirmngr/server.c (cmd_ks_get): Add option --ldap.

	scd:p15: Support attribute KEY-FPR.
	+ commit 30f90fc8574be4c48ac8d3ff41479481414c0dee
	* scd/app-p15.c: Include openpgpdefs.h.
	(struct prkdf_object_s): Add fields have_keytime and ecdh_kdf.
	(read_p15_info): Set ecdh_kdf.
	(keygrip_from_prkdf): Flag that we have the keytime.
	(send_keypairinfo): Send the key time only if valid.
	(send_key_fpr_line): New.
	(send_key_fpr): New.
	(do_getattr): Add KEY-FPR.

	common: New module to compute openpgp fingerprints.
	+ commit 2f2bdd9c0894eb43f719da8b529b4c7a46f742a0
	* common/openpgp-fpr.c: New.
	* common/Makefile.am (common_sources): Add it.

2021-04-13  Werner Koch  <wk@gnupg.org>

	gpg: Do not use self-sigs-only for LDAP keyserver imports.
	+ commit 6c26e593df51475921410ac97e9227df6b258618
	* dirmngr/ks-engine-ldap.c (ks_ldap_get): Print a SOURCE status.
	* g10/options.h (opts): New field expl_import_self_sigs_only.
	* g10/import.c (parse_import_options): Set it.
	* g10/keyserver.c (keyserver_get_chunk): Add special options for LDAP.

2021-04-13  Jakub Jelen  <jjelen@redhat.com>

	common: Fix memory leaks.
	+ commit a16f726f9404f173705cc3bef71daee38d2c094b
	* common/name-value.c (do_nvc_parse): Free NAME.
	* common/recsel.c (recsel_parse_expr): Release SE_HEAD and EXPR_BUFFER.

	kbx: Fix memory leak.
	+ commit 51bbd99a3c9b09a78e766a312d97a1d40372c6cd
	* kbx/keybox-update.c (blob_filecopy): Goto leave instead of return.

	tools: Fix memory leaks.
	+ commit 4c8be54cc430bbebd41fd7c452ff4ff9e8ff2bd5
	* tools/gpgsplit.c (write_part): Free BLOB on error.

	scd: Fix memory leaks.
	+ commit 7cbe29c4fb4f593e194b6c25cb31633b4a6e0b2b
	* scd/apdu.c (apdu_dev_list_start): Free DL.
	* scd/app-nks.c (pubkey_from_pk_file): Fix typo in condition.

	agent,kbx: Add LIBASSUAN_CLFAGS.
	+ commit cd66b2eb0d34b135175899362e191fff81588608
	* agent/Makefile.am (gpg_preset_passphrase_CFLAGS, t_protect_CFLAGS):
	Add LIBASSUAN_CFLAGS.
	* kbx/Makefile.am (libkeybox_a_CFLAGS, libkeybox509_a_CFLAGS):
	Likewise.

2021-04-12  Werner Koch  <wk@gnupg.org>

	scd:p15: Match private keys with certificates also by labels.
	+ commit ecb9265b8dc03a153044e19be804d4c2d2caa4e8
	* scd/app-p15.c (cdf_object_from_label): New.
	(cdf_object_from_certid): Fallback to label matching.
	(read_p15_info): Ditto.
	(keygrip_from_prkdf): Ditto.  Replace duplicated code by a call to
	cdf_object_from_objid.

2021-04-08  Werner Koch  <wk@gnupg.org>

	scd:nks: Handle APP_READKEY_FLAG_INFO.
	+ commit 63320ba2f8147ee86f4406c9590f6b28cad4771d
	* scd/app-nks.c (keygripstr_from_pk_file): Fix ignored error.
	(get_nks_tag): New.
	(do_learn_status_core): Use it.  Make sure not to mange the
	KEYPAIRINFO line if no usage is known.
	(do_readkey): Output the KEYPAIRINFO for the keygrip case.

	scd: Fix duplicate output of KEYPAIRINFO by readkey command.
	+ commit 22fd48e48d007a0cba6c8a8f6ad6cb4fe7470534
	* scd/app-help.c (app_help_get_keygrip_string_pk): Make HEXKEYGRIP
	parm optional.
	* scd/command.c (do_readkey): Remove duplicate output of keypairinfo
	lines.

2021-04-08  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Ed448 and X448 are only for v5.
	+ commit 36355394d865f5760075e62267d70f7a7d5dd671
	* g10/keygen.c (parse_key_parameter_part): Generate with version 5
	packet, when it's Ed448 or X448.

	scd: Fix CCID driver for SCM SPR332/SPR532.
	+ commit ab66c4357595b8a10ca25fd735f439fe795919b2
	* scd/ccid-driver.c (ccid_vendor_specific_pinpad_setup): New.
	(ccid_vendor_specific_setup): Only send CLEAR_HALT.
	(ccid_transceive_secure): Each time, use send_escape_cmd.

	common: Fix gnupg_wait_processes, by skipping invalid PID.
	+ commit d82dae5d2229a30dbc78aadc4d544d30dac76a1c
	* common/exechelp-posix.c (gnupg_wait_processes): Skip invalid PID.

2021-04-07  Werner Koch  <wk@gnupg.org>

	Release GnuPG 2.3.0.
	+ commit c922a798a341261f1aafaf7c1c0217e4ce3e3acf


2021-04-01  Werner Koch  <wk@gnupg.org>

	gpgconf: Return a new pseudo option compliance_de_vs.
	+ commit a78475fbb7b60ca96137fbe179d8b939cfe2cd89
	* tools/gpgconf-comp.c (known_pseudo_options_gpg): Add
	"compliance_de_vs".
	* g10/gpg.c (gpgconf_list): Returh that pseudo option.

	common: Make the compliance check more robust.
	+ commit 1d1ec1146c04415c7051af62e133459a4537c945
	* common/compliance.c (get_compliance_cache): New.
	(gnupg_rng_is_compliant): Use per mode cache.
	(gnupg_gcrypt_is_compliant): Ditto.

	card: New flag --reread for LIST.
	+ commit c727951a2440913bbab5b250c9bd2bb1d35ab0d7
	* tools/gpg-card.c (cmd_list): Add flag --reread.
	* tools/card-call-scd.c (scd_learn): New arg reread.

	* tools/card-call-scd.c (release_card_info): Fix releasing of the new
	label var.

	scd: New flag --reread for LEARN.
	+ commit ff87f4e578f412332ae59fdab016f0a5304baaf9
	* scd/command.c (cmd_learn): Add flag --reread.
	* scd/app-common.h (struct app_ctx_s): New field need_reset.
	* scd/app.c (write_learn_status_core): Set need_reset if we notice an
	error after returning from a reread.  Change all callers of card
	functions to return GPG_ERR_CARD_RESET so that that app is not anymore
	used.

	scd:p15: New flag APP_LEARN_FLAG_REREAD.
	+ commit e17d3f866057543d142d63379fd4f4a36d79147f
	* scd/app-p15.c (do_deinit): Factor code out to ...
	(release_lists, release_tokeninfo): new.
	(read_ef_tokeninfo): Reset all data before reading.
	(read_p15_info): Ditto.
	(do_learn_status): Implement reread flag.

2021-03-31  Werner Koch  <wk@gnupg.org>

	scd: Replace all assert macros by the log_assert macro.
	+ commit 1c16878efd0bcf036f56abef93d64ac41ce9e95b


	build: Require automake 1.16.3.
	+ commit 6ca540715139899137e1f86c7e1dcbd0288f15b3
	* configure.ac (min_automake_version): Bump to 1.16.3

2021-03-31  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit 8d6152a4cfd8a4cf176c01f99e1d49eeecab4367
	* m4/gpg-error.m4: Update from libgpg-error.

2021-03-30  Werner Koch  <wk@gnupg.org>

	card: Print the key's label if available.
	+ commit 0d6f276f61c583d776687029c715b1ee4280e4ed
	* tools/gpg-card.h (struct key_info_s): Add field 'label'.
	* tools/card-call-scd.c (learn_status_cb): Parse KEY-LABEL.
	(scd_learn): Always request KEY-LABEL.
	* tools/gpg-card.c (nullnone): New.
	(list_one_kinfo, list_card): Use it.  Print the label.

	scd:p15: Return labels for keys and certificates.
	+ commit 7f9126363265a6b6fe4223d68fc4e87678c4ddfc
	* scd/app-p15.c (send_certinfo): Extend certinfo.
	(do_getattr): Support KEY-LABEL.

	scd:p15: For CardOS make use of ISO7816_VERIFY_NOT_NEEDED.
	+ commit 651c07a7301c33229af051d83edbf898bae52e8b
	* scd/app-p15.c (verify_pin): Take care of verify status.

	scd:p15: Return the creation time of the keys.
	+ commit de4d3c99aa58ee06ae978d59e7e3aa7bace1c440
	* scd/app-p15.c (struct prkdf_object_s): Add keytime and keyalgostr.
	(keygrip_from_prkdf): Set them.
	(send_keypairinfo): Extend KEYPAIRINFO.

2021-03-30  NIIBE Yutaka  <gniibe@fsij.org>

	build: Fix for make distcheck, no EPS support.
	+ commit d1bac0a3be7081a4bfc7f813f9d626e1396ad5c1
	* Makefile.am (AM_DISTCHECK_DVI_TARGET): Specify 'pdf'.
	* doc/Makefile.am (EXTRA_DIST, BUILT_SOURCES): Remove EPS files.
	(gnupg.dvi): Remove.

2021-03-29  Werner Koch  <wk@gnupg.org>

	scd:p15: Make RSA with SHA512 work with CardOS.
	+ commit 592f48011790e30d4bcfd9093eb58b786c8c9a8b
	* scd/app-p15.c (do_sign): Rewrite.

	agent: Skip unknown unknown ssh curves seen on cards.
	+ commit 2d2391dfc25cfe160581b1bb4b4b8fc4764ac304
	* agent/command-ssh.c (ssh_handler_request_identities): Skip unknown
	curves.

	scd:p15: Support ECDSA and ECDH for CardOS.
	+ commit a494b29af9cc9c4c8c8323bae20e845d5a390448
	* scd/iso7816.c (iso7816_pso_csv): New.
	* scd/app-help.c (app_help_pubkey_from_cert): Uncompress a point if
	needed.

	* scd/app-p15.c (CARD_PRODUCT_RSCS): New.
	(struct prkdf_object_s): Add fields is_ecc, token_label, and
	tokenflags.
	(do_deinit): Free new fields.
	(cardproduct2str): New.
	(read_ef_prkdf): Set new is_ecc flag.
	(read_ef_tokeninfo): Store some data and move Tokeninfo diags to ...
	(read_p15_info): here.  set the product info here after all data has
	been gathered.
	(send_keypairinfo): Chnage the way the gpgusage flags are used.
	(make_pin_prompt): If the token has a label and the current cert has
	no CN, show the label as holder info.
	(do_sign): Support ECDSA.  Take care of the gpgusage flags.
	(do_decipher): Support ECDH.  Take care of the gpgusage flags.

	gpg: Allow ECDH with a smartcard returning just the x-ccordinate.
	+ commit f129b0e97730b47d62482fba9599db39b526f3d2
	* g10/ecdh.c (extract_secret_x): Add extra safety check. Allow for
	x-only coordinate.

2021-03-28  Werner Koch  <wk@gnupg.org>

	gpgconf: Do not i18n an empty string to the PO files meta data.
	+ commit 18d884f8411a0ca263a8aa588bb49eb0dae9ee19
	* tools/gpgconf-comp.c (my_dgettext): Ignore empty strings.

2021-03-26  Werner Koch  <wk@gnupg.org>

	tests: Make sure the built keyboxd is used by the tests.
	+ commit a5e72b663b3649c939d32d6526b5e2b3347dedd9
	* tests/openpgp/defs.scm (tool): Add keyboxd.
	* tests/openpgp/setup.scm: Ditto.

	gpgconf: Fix another argv overflow if --homedir is used.
	+ commit 057131159b445d2d49392e95c677ad7b4cd4ae9c
	* tools/gpgconf-comp.c (gc_component_check_options): Increase array.

	gpgconf: Fix argv overflow if --homedir is used.
	+ commit d3d57a1bc88ece0c12c91f54b089482cce92c5a0
	* tools/gpgconf-comp.c (gc_component_launch): Fix crasg due to too
	small array.
	(gpg_agent_runtime_change): Fix error message.
	(scdaemon_runtime_change): Ditto.
	(tpm2daemon_runtime_change): Ditto.
	(dirmngr_runtime_change): Ditto.
	(keyboxd_runtime_change): Ditto.

	agent: Add debug output for failed RSA signature verification.
	+ commit 6de1ec3ba59fa54ab60b2923ba9caa77fc9d5281
	* agent/pksign.c (agent_pksign_do): Support ECC and DSA verification
	and print some debug info in the error case.

	common: New function to uncompress an ECC public key.
	+ commit 935765b451aadc63fbba763a4a00f4efa0254436
	* common/sexputil.c (ec2os): New.
	(uncompress_ecc_q_in_canon_sexp): New.

	* common/t-sexputil.c (fail2): new.
	(test_ecc_uncompress): New.
	(main): Run new test.

2021-03-26  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix PC/SC error handling at apdu_dev_list_start.
	+ commit d4e5979c630c2960cf1fd5796f1060419e71cb04
	* scd/apdu.c (PCSC_E_NO_READERS_AVAILABLE): Add.
	(pcsc_error_to_sw): Handle PCSC_E_NO_READERS_AVAILABLE.
	(apdu_dev_list_start): Return error correctly.

2021-03-24  Werner Koch  <wk@gnupg.org>

	card: Add option --use-default-pin to command "login".
	+ commit 73bad368dacf5334bf78af15b243d06fd1273849
	* tools/gpg-card.c (cmd_login): Add option.

	scd:p15: Make $SIGNKEY et al determination more fault tolerant.
	+ commit 964363e788210f96a471e31ffa8fd17b534c0aa8
	* scd/app-p15.c (do_getattr): Change how we use gpgUsage to figure out
	the keys to use.

2021-03-24  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix v5 signature for clearsign.
	+ commit 14ef703ad65850fa22d394c4d521ba602ff2cc8d
	* g10/sign.c (clearsign_file): Prepare EXTRAHASH.

	gpg: Support ECDH with v5 key.
	+ commit 90a5b4e648b3c8a6fe645df7e61654dfdb3548be
	* g10/ecdh.c (build_kdf_params): Use the first 20 octets.
	* g10/pkglue.c (pk_encrypt): Remove length check to 20.
	* g10/pubkey-enc.c (get_it): Likewise.

2021-03-23  Werner Koch  <wk@gnupg.org>

	gpgconf: Fix listing of default_pubkey_algo.
	+ commit a107b24ddb45c9eef432d456f302c1acea3af27c
	* tools/gpgconf-comp.c (known_options_gpg, known_options_gpgsm): No
	flags needed for pseudo options.
	(known_pseudo_options_gpg, known_pseudo_options_gpgsm): New.
	(gc_component): Add field known_pseudo_options.
	(struct read_line_wrapper_parm_s): New.
	(read_line_wrapper): New.
	(retrieve_options_from_program): Use read_line_wrapper to handle
	pseudo options.

2021-03-22  Werner Koch  <wk@gnupg.org>

	kbxd: Group the options.
	+ commit ed82ef91459f72b955f4e342ab88a7a0949c436b
	* kbx/keyboxd.h (opt): Remove unused field 'batch'.
	* kbx/keyboxd.c (opts): Remove --batch.  Add group descriptions.

2021-03-22  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Support exporting Ed448 SSH key.
	+ commit 1524a942b645d9facbedd9ed4a472e343838b6a1
	* common/openpgp-oid.c (oid_ed448, openpgp_oidbuf_is_ed448): New.
	(openpgp_oid_is_ed448): New.
	* common/util.h (openpgp_oid_is_ed448): New.
	* g10/export.c (export_one_ssh_key): Support Ed448 key.

	gpg: Fix exporting SSH key.
	+ commit 0b45c5a9941094bd4529c3bf5b1cb8ce2584b9a4
	* g10/export.c (export_one_ssh_key): Finish base 64 encoder before
	writing out the comment string.

2021-03-19  Werner Koch  <wk@gnupg.org>

	card: Support OpenPGP.1 and OpenPGP.2 for readcert and writecert.
	+ commit 475644e049436c49de7620a1539515479ad2aa4f
	* tools/gpg-card.c (cmd_writecert): Allow the other key references.
	(cmd_readcert): Ditto.

	scd:openpgp: Allow reading and writing user certs for keys 1 and 2.
	+ commit 37b1c5c2004c1147a13b388863aaa8f0caf7d71f
	* scd/iso7816.c (CMD_SELECT_DATA): New.
	(iso7816_select_data): New.
	* scd/app-openpgp.c (do_readcert): Allow OpenPGP.1 and OPENPGP.2
	(do_writecert): Ditto.
	(do_setattr): Add CERT-1 and CERT-2.

	scd:openpgp: Rename an internal variable.
	+ commit bbdb48ec0ddd99ce23fcba42949c00a2594fb9a5
	* scd/app-openpgp.c (struct app_local_s): s/extcap_v3/is_v3/.
	s/max_certlen_3/max_certlen.  Change users.

	scd:openpgp: Small speedup reading card properties.
	+ commit d5fb5983232cf4d60cf6aa00d0ae5a16cf948e19
	* scd/app-openpgp.c (struct app_local_s): Add new flag.
	(get_cached_data): Force chace use if flag is set.
	(app_select_openpgp): Avoid reading DO 6E multiple times.

2021-03-18  Werner Koch  <wk@gnupg.org>

	scd:p15: Allow to use an auth object label with cmd CHECKPIN.
	+ commit 85082a83c2c1bda50fe6b7aa2ac68cef4faca4c7
	* scd/app-p15.c (prepare_verify_pin): Allow for PRKDF to be NULL.
	(make_pin_prompt): Ditto.
	(verify_pin): Ditto.
	(do_check_pin): Allow using the Label to specify a PIN.

	card: Print PIN descriptions and fix number of printed retry counters.
	+ commit 1ac189f2df6cedab3a133baca69558fdf6a908d4
	* tools/gpg-card.h (struct card_info_s): Add fields nmaxlen, nchvinfo,
	and chvlabels.
	* tools/card-call-scd.c (release_card_info): Free chvlabels.
	(learn_status_cb): Parse CHV-LABEL.  Set nmaxlen and nchvinfo.
	* tools/gpg-card.c (list_retry_counter): Print CHV labels.

	scd:p15: New attribute CHV-LABEL.
	+ commit ef29a960bf06005c34093cd9a6bca5a202ed359a
	* scd/app-p15.c (parse_common_obj_attr): Map spaces in the lapel to
	underscores.
	(read_ef_aodf): Prettify printing of the type.
	(do_getattr): New attribute CHV-LABEL
	(do_learn_status): Emit CHV-LABEL.
	(verify_pin): Distinguish the PIN prompts.

	agent: Simplify a function.
	+ commit 26215cb211ad93ad9cc51fb4f8257b9e3c254a4e
	* agent/findkey.c (agent_public_key_from_file): Use a membuf instead
	of handcounting space.

2021-03-16  Werner Koch  <wk@gnupg.org>

	scd:p15: Implement CHV-STATUS attribute.
	+ commit bf1d7bc3697c7d650994ba94d3704af189594657
	* scd/command.c (send_status_direct): Return an error.
	* scd/app-p15.c (do_learn_status): Emit CHV-STATUS.
	(compare_aodf_objid): New.
	(do_getattr): Implement CHV-STATUS.

	card: Generalize the CHV counter printing.
	+ commit e4c2d7be22ffb47b41a3b6c1152bd75dceed74e2
	* tools/gpg-card.c (list_retry_counter): New.  Factored out from the
	other functions.
	(cmd_verify): Re-read the chv status.

2021-03-16  Damien Goutte-Gattat via Gnupg-devel  <gnupg-devel@gnupg.org>

	build: Check for the IBM TSS tools to run the tpm2d tests.
	+ commit c0f50811fcf81e5ebe2df326342081cfdacfbbfc
	* configure.ac (TEST_LIBTSS): Make that conditional depend on the
	detection of tssstartup.

	build: Fix distcheck when tpm2dtests are run.
	+ commit ad481666ea6ef3743041ec6d043a3e6901ebab33
	* tests/tpm2dtests/Makefile.am (EXTRA_DIST): Distribute test files.
	(CLEANFILES): Make sure to remove log files.

2021-03-15  James Bottomley  <James.Bottomley@HansenPartnership.com>

	tests:tpm2d: add missing start_sw_tpm.sh script.
	+ commit a788f2e8306d80f7f3df34eb62ec7ce1a62d48e1
	* tests/tpm2dtests/start_sw_tpm.sh: New.
	* tests/tpm2dtests/Makefile.am: Add.

2021-03-15  Werner Koch  <wk@gnupg.org>

	gpg: New option --no-auto-trust-new-key.
	+ commit 1523b5f76f6e600c4f2d153b49a807ff2dc8d268
	* g10/gpg.c (oNoAutoTrustNewKey): New.
	(opts): Add --no-auto-trust-new-key.
	(main): Set it.
	* g10/options.h (opt): Add flags.no_auto_trust_new_key.

	build: new option to disable building of tpm2daemon.
	+ commit 8d6123faa8cae0bad6f82c9021e9ac6686b2f55d
	* configure.ac (build_tpmd): New configure option --disable-tpm2d
	(BUILD_WITH_TPM2D): New.
	* Makefile.am (tests): Use conditionally BUILD_TPM2D instead of
	HAVE_LIBTSS.
	* build-aux/speedo.mk (speedo_pkg_gnupg_configure) [W32]: Do not build
	tpm2d.
	* autogen.rc: Ditto.

2021-03-15  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Add handling of Ed448 key.
	+ commit b743942a9719be59f1da67cd338248fe7ee5aeab
	* scd/app-openpgp.c (struct app_local_s): Add ecc.algo field.
	(send_key_attr): Use ecc.algo field.
	(ecc_read_pubkey): Use ecc.algo field.
	(ecc_writekey): Ed448 means EdDSA.
	(parse_algorithm_attribute): Set ecc.algo field from card.
	Add checking for Ed25519 for ECC_FLAG_DJB_TWEAK flag.

	scd: Fix count_sos_bits handling.
	+ commit f482e4bd121ff2862bfb53a82f1d5c2cf3524a10
	* scd/app-openpgp.c (count_sos_bits): Handle an exceptional case.

	common: Fix the NBITS of Ed448in OIDTABLE.
	+ commit 373b52e69a6ca609a663a0c4a018358fdf52dc7e
	common/openpgp-oid.c (oidtable): Ed448 uses 456-bit signature.

2021-03-12  Werner Koch  <wk@gnupg.org>

	scd: New option --pcsc-shared.
	+ commit 5732e7a8e97cebf8e850c472e644e2a9b040836f
	* scd/scdaemon.h (opt): Add field opcsc_shared.
	* scd/scdaemon.c (opcscShared): New.
	(opts): Add "--pcsc-shared".
	(main): Set flag.
	* scd/apdu.c (connect_pcsc_card): Use it.
	(pcsc_get_status): Take flag in account.
	* scd/app-openpgp.c (cache_pin): Bypass in shared mode.
	(verify_chv2: Do not auto verify chv1 in shared mode.
	* scd/app-piv.c (cache_pin): By pass caceh in shared mode.

2021-03-12  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix computing fingerprint for ECC with SOS.
	+ commit 95156ef9bfb6a3a525454d50ae2f5b538ccbd774
	* scd/app-openpgp.c (count_sos_bits): New.  Count as sos_write does.
	(store_fpr): For ECC, use count_sos_bits.

	gpg: Fix compute_fingerprint for ECC with SOS.
	+ commit cfc1497efa8c98cf490f5efc9b280a6ec44514bd
	* g10/keyid.c (hash_public_key): Tweak NBITS just as sos_write does.

2021-03-11  Valtteri Vuorikoski  <vuori@notcom.org>

	scd:piv: Improve APT parser compatibility.
	+ commit 8cad11d13b15b0ef672545b06450dfbea1fef18e
	* scd/app-piv.c (app_select_piv): Allow for full AID.

2021-03-11  Werner Koch  <wk@gnupg.org>

	gpg: New option --force-sign-key.
	+ commit fe02ef04500c1b35cd27132fb99ac1961f555193
	* g10/gpg.c (oForceSignKey,opts): New option "--force-sign-key".
	(main): Set it.
	* g10/options.h (opt): New flag flags.force_sign_key.
	* g10/keyedit.c (sign_uids): Use new flag.

2021-03-11  James Bottomley via Gnupg-devel  <gnupg-devel@gnupg.org>

	tpmd2: Add Support for the Intel TSS.
	+ commit b9c560e3a400da83073b232ee12fae090b21d20c
	* configure.ac: Check for Intel TSS.
	* tpm2d/intel-tss.h: New.
	* tpm2d/tpm2.h (HAVE_INTEL_TSS): Use the Intel code.

2021-03-10  James Bottomley  <James.Bottomley@HansenPartnership.com>

	tpm2d: add tests for the tpm2daemon.
	+ commit 6720f1343aef9342127380b155c19e12c92d65ac
	* configure.ac: Detect TPM emulator and enable tests.
	* tests/tpm2dtests/: New test suite.
	* tests/Makefile.am: Run tests.

	gpg: Add new command keytotpm to convert a private key to TPM format.
	+ commit 92b601fceec7da64939591001dba94e202f6e6a0
	* agent/command.c (cmd_keytotpm): New.
	(agent/command.c): Register new command KEYTOTPM.
	* g10/call-agent.c (agent_keytotpm): New.
	* g10/keyedit.c (cmdKEYTOTPM): New command "keytotpm".
	(keyedit_menu): Implement.

	agent: Add new shadow key type and functions to call tpm2daemon.
	+ commit 1f995b9ba42b76c1d83b484e5362548a54a70dab
	* agent/call-tpm2d.c: New.
	* divert-tpm2.c: New.
	* agent/Makefile.am: Add new files.
	* agent/agent.h (DAEMON_TPM2D): New.  Add stub fucntions.
	* agent/call-daemon.c (GNUPG_MODULE_NAME_TPM2DAEMON): New.
	* agent/command.c (do_one_keyinfo): Handle tpmv2.
	* agent/gpg-agent.c (oTpm2daemonProgram): New.
	(opts): New option --tpm2daemon-program.
	(parse_rereadable_options): Handle option.
	* agent/pkdecrypt.c (agent_pkdecrypt): Divert to tpm2d.
	(agent_pksign_do): Ditto.
	---

	A new shadow key type: "tpm2-v1" is introduced signalling that the
	shadowed key is handled by the tpm2daemon.  A function to identify
	this type is introduced and diversions to the tpm2daemon functions are
	conditioned on this function for pkign and pkdecrypt where the same
	diversions to scd are currently done.  The (info) field of the
	shadowed key stores the actual TPM key.  The TPM key is encrypted so
	only the physical TPM it was created on can read it (so no special
	protection is required for the info filed), but if the (info) field
	becomes corrupt or damaged, the key will be lost (unlike the token
	case, where the key is actually moved inside the token).

	Note, this commit adds handling for existing TPM format shadow keys,
	but there is still no way to create them.


	Additional changes:
	* Add ChangeLog entries.
	* Some minor indentation fixes.
	* agent/Makefile.am (gpg_agent_SOURCES): Change to make distcheck
	  work.
	* agent/agent.h [!HAVE_LIBTSS]: Do not return -EINVAL but an
	  gpg_error_t.  Mark args as unused.
	* agent/protect.c (agent_is_tpm2_key): Free BUF.

	tpm2d: Add tpm2daemon code.
	+ commit 62a7854816b8f3661fb41f05463289e5b96663ee
	* tpm2d: New directory.
	* Makefile.am (SUBDIRS): Add directory.
	* configure.ac: Detect libtss and decide whether to build tpm2d.
	* am/cmacros.am: Add a define.
	* util.h (GNUPG_MODULE_NAME_TPM2DAEMON): New.
	* common/homedir.c (gnupg_module_name): Add tpm2d.
	* common/mapstrings.c (macros): Add "TPM2DAEMON".
	* tools/gpgconf.h (GC_COMPONENT_TPM2DAEMON): New.
	* tools/gpgconf-comp.c (known_options_tpm2daemon): New.
	(gc_component): Add TPM2.
	(tpm2daemon_runtime_change): New.
	* tpm2d/Makefile.am: New.
	* tpm2d/command.c: New.
	* tpm2d/ibm-tss.h: New.
	* tpm2d/tpm2.c: New.
	* tpm2d/tpm2.h: New.
	* tpm2d/tpm2daemon.c: New.
	* tpm2d/tpm2daemon.h: New.

	---
	This commit adds and plumbs in a tpm2daemon to the build to mirror the
	operation of scdaemon.  The architecture of the code is that
	tpm2daemon.c itself is pretty much a clone of scd/scdaemon.c just with
	updated function prefixes (this argues there could be some further
	consolidation of the daemon handling code).  Note that although this
	commit causes the daemon to be built and installed, nothing actually
	starts it or uses it yet.

	Command handling
	----------------

	command.c is copied from the command handler in scd.c except that the
	command implementation is now done in terms of tpm2 commands and the
	wire protocol is far simpler.  The tpm2daemon only responds to 4
	commands

	IMPORT:    import a standard s-expression private key and export it to
	           TPM2 format.  This conversion cannot be undone and the
	           private key now can *only* be used by the TPM2.  To anyone
	           who gets hold of the private key now, it's just an
	           encrypted binary blob.

	PKSIGN:    create a signature from the tpm2 key.  The TPM2 form private
	           key is retrieved by KEYDATA and the hash to be signed by
	           EXTRA.  Note there is no hash specifier because the tpm2
	           tss deduces the hash type from the length of the EXTRA
	           data.  This is actually a limitation of the tpm2 command
	           API and it will be interesting to see how this fares if the
	           tpm2 ever supports say sha3-256 hashes.

	PKDECRYPT: decrypt (RSA case) or derive (ECC case) a symmetric key.
		   The tpm2 for private key is retrieved by KEYDATA and the
		   information used to create the symmetric key by EXTRA.

	KILLTPM2D: stop the daemon

	All the tpm2 primitives used by command.c are in tpm2.h and all the
	tpm2 specific gunk is confined to tpm2.c, which is the only piece of
	this that actually does calls into the tss library.


	Changes from James' patch:

	- gpgconf: The displayed name is "TPM" and not "TPM2".  That
	  string is used by GUIs and should be something the user
	  understands.  For example we also use "network" instead
	  of "Dirmngr".
	- Removed some commented includes.
	- Use 16 as emulation of GPG_ERR_SOURCE_TPM2.
	- Silenced a C90 compiler warning and flags unused parameters.
	- Removed "if HAVE_LIBS" from tpm2/Makefile.am and add missing
	  files so that make distcheck works.

2021-03-10  Werner Koch  <wk@gnupg.org>

	scd:p15: Support special extended usage flags for OpenPGP keys.
	+ commit 08b5ac492afc6c6e7eaaa1f70d67c81cbda2c9be
	* scd/app-p15.c (struct gpgusage_flags_s): New.
	(struct prkdf_object_s): Add field gpgusage.
	(struct app_local_s): Add field any_gpgusage.
	(dump_gpgusage_flags): New.
	(read_p15_info): Parse athe gpgusage flags.
	(do_getattr): Take care of the gpgusage flags.

2021-03-08  Werner Koch  <wk@gnupg.org>

	sm: Init nPth which might be used by some helper code.
	+ commit a4021d9be4aeac7429bf6a8e9f336dbb62cacfc4
	* sm/gpgsm.c: Include npth.h.
	(main): Init nPth.

	w32: Cleanup use of pid_t in call-daemon.
	+ commit 33c492dcb955bff01fffae31fb7750f88e07b8ff
	* agent/call-daemon.c (struct wait_child_thread_parm_s) [W32]: Do not
	use HANDLE for pid_t.
	(wait_child_thread): Ditto.

	w32: Change spawn functions to use Unicode version of CreateProcess.
	+ commit cf2f6d8a3f0594c03c383b4989a3041e9c4536d7
	* common/exechelp-w32.c (gnupg_spawn_process): Change to use
	CreateProcessW.
	(gnupg_spawn_process_fd): Ditto.
	(gnupg_spawn_process_detached): Ditto.
	* g10/exec.c (w32_system): Ditto.

2021-03-08  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix for X448.
	+ commit fc99f77b14b6c2cdfb547607651922c16863dcf0
	* scd/app-openpgp.c (do_decipher): Support with no prefix.

2021-03-05  Werner Koch  <wk@gnupg.org>

	w32: Always use Unicode for console input and output.
	+ commit 8c41b8aac3efb78178fe1eaf52d8d1bbc44941a8
	* common/init.c (_init_common_subsystems) [W32]: Set the codepage to
	UTF-8 for input and putput.  Switch gettext to UTF-8.
	* tools/gpgconf.c (main): Display the input and output codepage if
	they differ.
	* g10/gpg.c (utf8_strings) [W32]: Make sure this is always set.

	w32: Free memory allocated by new function w32_write_console.
	+ commit 31b708e268ebb725307856865f34a61670a35586
	* common/ttyio.c (w32_write_console): Free buffer.

	common,w32: Allow Unicode input and output with the console.
	+ commit f165c8a737cc968554c9d78932c69869456108ff
	* common/ttyio.c (do_get) [W32]: Use ReadConsoleW.
	(w32_write_console): New.
	(tty_printf, tty_fprintf) [W32]: Use new function.

	common: Re-indent ttyio.c and remove EMX, RISCOS, and CE support.
	+ commit 8622f53994249d8fb49a488cfe480ffbeb8cbfba
	* common/ttyio.c: Remove cruft like EMX and RISCOS support.  Translate
	a few strings.  Re-indent.

2021-03-04  Werner Koch  <wk@gnupg.org>

	common: Rename w32-misc.c to w32-cmdline.c.
	+ commit 7262d602d802c4a3840097d5de217fcfb9728b49
	* common/w32-misc.c: Rename to ....
	* common/w32-cmdline.c: this.
	* common/Makefile.am: Adjust.

	common,w32: Implement globing of command line args.
	+ commit 089c9439674e8ecbc64f0ba924e6fb447bbc2b9d
	* common/w32-misc.c [W32]: Include windows.h
	(struct add_arg_s): New.
	(add_arg): New.
	(glob_arg): New.
	(parse_cmdstring): Add arg argvflags and set it.
	(w32_parse_commandline): Add arg r_itemsalloced.  Add globing.

	* common/init.c (prepare_w32_commandline): Mark glob created items as
	leaked.

	* common/t-w32-cmdline.c : Include windows.h
	(test_all): Add simple glob test for Unix.
	(main): Add manual test mode for Windows.

	common,w32: Refine the command line parsing for \ in quotes.
	+ commit 20c60076866904187a09393de596deef286116f8
	* common/t-w32-cmdline.c (test_all): Add new test cases.
	* common/w32-misc.c (strip_one_arg): Add arg endquote.
	(parse_cmdstring): Take care of backslashes in quotes.

	gpg: Prepare for globing with UTF-8.
	+ commit 8e15506d6680bbee85bc01453da28fc90b4cb673
	* g10/gpg.c (_dowildcard): Remove.
	(my_strusage): Enable wildcards using our new system.

	common: First take on handling Unicode command line args.
	+ commit deb6c94362c0f179de1cac18707aad2f51a21e10
	* common/w32-misc.c: New.
	* common/t-w32-cmdline.c: New.
	* common/init.c: Include w32help.h.
	(prepare_w32_commandline): New.
	(_init_common_subsystems) [W32]: Call prepare_w32_commandline.

	* common/Makefile.am (common_sources) [W32]: Add w32-misc.c
	(module_tests): Add t-w32-cmdline
	(t_w32_cmdline_LDADD): New.

2021-03-01  Nicolas Fella via Gnupg-devel  <gnupg-devel@gnupg.org>

	gpg: Keep temp files when opening images via xdg-open.
	+ commit be2da244565822ad1f268f84dc88a23e5aa8d26a
	* g10/photoid.c (get_default_photo_command): Change parameter for
	xdg-open.

2021-02-25  Werner Koch  <wk@gnupg.org>

	scd:p15: Read out the access flags.
	+ commit d51a5ca1084c69c0ed304126a7aaa0a648b2eba6
	* scd/app-p15.c (struct keyaccess_flags_s): New.
	(struct prkdf_object_s): Add field accessflags.
	(dump_keyusage_flags): New.
	(dump_keyaccess_flags): New.
	(parse_keyaccess_flags): New.
	(parse_common_key_attr): Return access flags.
	(read_ef_prkdf): Parse the access flags.  Allow for ECkeys.
	(read_ef_pukdf): Ditto.  Use new functions for printing.
	(read_p15_info): Use new fucntion for printing.

	sm: Do not print certain issuer not found diags in quiet mode.
	+ commit a170f0e73f38e474b6d4463433fe344eca865fa5
	* sm/certchain.c (find_up_dirmngr): Print one diagnostic only in
	verbose mode.  Do not print issuer not found diags in quiet mode.
	* sm/minip12.c (parse_bag_data): Add missing verbose condition.

	sm: Fix issuer certificate look error due to legacy error code.
	+ commit 473b83d1b9efe51fcca68708580597dddf3f50b7
	* sm/certchain.c (find_up): Get rid of the legacy return code -1 and
	chnage var name rc to err.
	(gpgsm_walk_cert_chain): Change var name rc to err.
	(do_validate_chain): Get rid of the legacy return code -1.

2021-02-24  Werner Koch  <wk@gnupg.org>

	scd:p15: Get the label value of all objects for better diagnostics.
	+ commit cfdaf2bcc85b3b6f16904006f239b400a3487ff8
	* scd/app-p15.c (struct cdf_object_s): Add fields authid, authidlen,
	and label.
	(struct prkdf_object_s): Add field label.
	(struct aodf_object_s): Ditto.
	(release_cdflist): Free new fields.
	(release_prkdflist): Free new field.
	(release_aodf_object): Ditto.
	(parse_common_obj_attr): Return the label.
	(read_ef_prkdf): Store the label.
	(read_ef_pukdf): Ditto.
	(read_ef_cdf): Use parse_common_obj_attr and store authid and label.
	Print them im verbose mode.
	(read_ef_aodf): Store the label and print it.

	sm: Silence some output on --quiet.
	+ commit 615d2e4fb15859320ea0ebec1bb457c692c57f0a
	* sm/encrypt.c (gpgsm_encrypt): Take care of --quiet.
	* sm/gpgsm.c: Include minip12.h.
	(set_debug): Call p12_set_verbosity.
	* sm/import.c (parse_p12): Dump keygrip only in debug mode.
	* sm/minip12.c (opt_verbose, p12_set_verbosity): New.
	(parse_bag_encrypted_data): Print info messages only in verbose mode.

2021-02-23  Werner Koch  <wk@gnupg.org>

	scd:p15: Make it code work again for D-Trust cards.
	+ commit 33aaa37e5bc0beb75305cdf9d8be850daccaee5e
	* scd/app-p15.c (select_and_read_binary): Allow to skip the select.
	(select_and_read_record): Return the statusword.  Silence error
	message for SW_FILE_STRUCT.
	(select_ef_by_path): Fix selection with a home_DF.
	(read_first_record): Fallback to read_binary for CardOS and return
	info about this.
	(read_ef_prkdf): Use info from read_first_record to decide whether to
	use record or binary mode.
	(read_ef_pukdf): Ditto.
	(read_ef_aodf): Ditto.
	(read_ef_cdf): Ditto.  New arg cdftype for diagnostics.
	(read_p15_info): Pass cdftype.

	* scd/apdu.h (SW_FILE_STRUCT): New.
	* scd/apdu.c (apdu_strerror): Map that one to a string.
	* scd/iso7816.c (map_sw): and to a gpg-error.

2021-02-22  Werner Koch  <wk@gnupg.org>

	scd: Fix readkey --info in case a readkey command is available.
	+ commit 2490f4e8e1d1feecb44aefa79bd71f5f8b06c9a4
	* scd/command.c (do_readkey): Make --info also work if a readkey
	command is available.

	* scd/app-p15.c (cdf_object_from_certid): Fix a but introduced with
	the previous commit.

	scd:p15: Extract extended usage flagsand act upon them.
	+ commit 488eaedc9a332d8164dea22e469354fc10b0a253
	* scd/app-p15.c: Add a couple of oid constants.
	(struct cdf_object_s): Replace fields image and imagelen by cert.
	(struct prkdf_object_s): Add extusage flags
	(send_keypairinfo): Use them.
	(cdf_object_from_certid): Factor parts out to ...
	(cdf_object_from_objid): new function.
	(read_ef_prkdf): Move info printing to ...
	(read_p15_info): here.  Fill the extusage flags.
	(readcert_by_cdf): Cache the ksba cert object instead of the binary
	cert.
	* scd/app.c (select_additional_application): Fix a log_debug call.
	(scd_update_reader_status_file): Ditto.

	sm: Extend the list of known OIDs.
	+ commit 4c9b509d2402f79668e502a9db5879280a4f683b
	* sm/keylist.c (oidtranstbl): Add a couple of OIDs and mark them for
	key usage.

2021-02-19  Werner Koch  <wk@gnupg.org>

	build: Remove now obsolete HAVE_NEWER_LIBGCRYPT AM conditional.
	+ commit 5573ab714b92f6ee899a816998e56e1238f4c573
	* configure.ac (HAVE_NEWER_LIBGCRYPT): Remove conditional.
	* tools/Makefile.am (gpg_pair_tool_SOURCES):  We build it always.

	scd: Minor tweak for easier backporting.
	+ commit 6d4280b13ddc928ff6bc41bdf482030f0f814fdb
	* scd/app-common.h (APP_CARD): New.  Use it in app-*.c to access
	app->card.

2021-02-18  Werner Koch  <wk@gnupg.org>

	po: Change translatability of a fallback string.
	+ commit 0be4861762c21ebfb4c2e28bb9a3e5cfbc08e1a9
	* agent/call-pinentry.c (setup_genpin): Do not make the fallback
	translatable.

	speedo: Update w32 stuff from 2.2.
	+ commit 919a969354d4021f2e64a948b4c224cd37323713
	* build-aux/speedo.mk: Update from 2.2.  Add target w32-msi-release.
	* build-aux/speedo/w32/inst.nsi: Fix location of doc files.
	* build-aux/speedo/w32/wixlib.wxs: Add gpg-card and fix a wrong name.
	* Makefile.am (release): Support a WITH_MSI variable.
	(wixlibfile): Improve copying to archive.
	(release): Use AMTAR instead of TAR.

2021-02-17  Werner Koch  <wk@gnupg.org>

	dirmngr: Support new gpgNtds parameter in LDAP keyserver URLs.
	+ commit ab7dc4b524c3e2ad5153acfdbfa879a9e62d2dbe
	* dirmngr/ldap-parse-uri.c (ldap_parse_uri): Support a new gpgNtds
	extension.
	* dirmngr/ks-engine-ldap.c (my_ldap_connect): Do ldap_init always with
	hostname - which is NULL and thus the same if not given.  Fix minor
	error in error code handling.

2021-02-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4 again.
	+ commit 3fa1fa747b61867076e344c3eb07a66826c1983a
	* m4/gpg-error.m4: Update from libgpg-error.

2021-02-15  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit 985e85dc0e6c54aa465a2af610c5a04fc10649a0
	* m4/gpg-error.m4: Update from libgpg-error.

2021-02-12  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit e1e3f1db4660b5416828aeb636a7f767fadcc7a4
	* m4/gpg-error.m4: Update from libgpg-error.

	build: Fix library dependency of g13 test program.
	+ commit 83e0a9d6b990aa517bc338b578f7faf393ae1b0d
	* g13/Makefile.am (t_common_ldadd): Add GPG_ERROR_LIBS.

2021-02-10  Werner Koch  <wk@gnupg.org>

	gpg: Do not allow old cipher algorithms for encryption.
	+ commit 825dd7220ff6079cbe2d0df7fde93526c077fb6d
	* g10/gpg.c: New option --allow-old-cipher-algos.
	(set_compliance_option): Set --rfc4880bis explictly to SHA256 and
	AES256.  Allow old cipher algos for OpenPGP, rfc4880, and rfc2440.
	* g10/options.h (opt): Add flags.allow_old_cipher_algos.
	* g10/misc.c (print_sha1_keysig_rejected_note): Always print the note
	unless in --quiet mode.
	* g10/encrypt.c (setup_symkey): Disallow by default algos with a
	blocklengt < 128.
	(encrypt_crypt): Ditto.  Fallback by default to AES instead of 3DES.
	* g10/pkclist.c (algo_available): Take care of old cipher also.
	(select_algo_from_prefs): Use AES as implicit algorithm by default.

	* tests/openpgp/defs.scm (create-gpghome): Set allow-old-cipher-algos.

	Remove obsolete M4 macros.
	+ commit 6e730c18816fbb3e074d93840396ed18f00ab7e2
	* m4/gnupg-pth.m4: Remove.
	* m4/libcurl.m4: Remove.

	Require GpgRT version 1.41.
	+ commit 2b75b256054427119a284792540243c3471267d4
	* configure.ac (NEED_GPG_ERROR_VERSION): Rename to NEED_GPGRT_VERSION
	and set to 1.41.
	* common/sysutils.c (gnupg_access): Remove code for older gpgrt
	versions.
	* kbx/backend-sqlite.c: Ditto.
	* sm/gpgsm.c (main): Ditto.

2021-02-09  Werner Koch  <wk@gnupg.org>

	build: Make make distcheck work again.
	+ commit f9e4dae08d7caed741d35916c46b8302e098d521
	* m4/Makefile.am (EXTRA_DIST): Remove isc-posix.m4

	tools: Remove the symcryptrun tool.
	+ commit 209b7113f3493bd829ec5c90275ff95a273d9dd4
	* tools/symcryptrun.c: Remove.
	* tools/Makefile.am: Ditto.
	* doc/tools.texi: Remove man page.
	* configure.ac: Remove build option and tests used only by this tool.
	* Makefile.am (AM_DISTCHECK_CONFIGURE_FLAGS): Do not build
	symcryptrun.

2021-02-05  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix selection of key.
	+ commit 390f597868a5b5934f21f81ebf6ff110b6792283
	* g10/getkey.c (pubkey_cmp): Handle the case of TRUST_EXPIRED.

2021-02-02  Werner Koch  <wk@gnupg.org>

	gpg: Remove support for PKA.
	+ commit 7f3ce66ec56a5aea6170b7eb1bda5626eb208c83
	* g10/gpg.c (oPrintPKARecords): Remove.
	(opts): Remove --print-pka-records.
	(main): Remove "pka-lookups","pka-trust-increase" and other PKA stuff.
	* g10/options.h (EXPORT_DANE_FORMAT): Remove.
	(VERIFY_PKA_LOOKUPS, VERIFY_PKA_TRUST_INCREASE): Remove.
	(KEYSERVER_HONOR_PKA_RECORD): Remove.
	* g10/packet.h (pka_info_t): Remove.
	(PKT_signature): Remove flags.pka_tried and pka_info.
	* g10/parse-packet.c (register_known_notation): Remove
	"pka-address@gnupg.org".
	* g10/pkclist.c (check_signatures_trust): Remove PKA stuff.
	* g10/call-dirmngr.c (gpg_dirmngr_get_pka): Remove.
	* g10/export.c (parse_export_options): Remove "export-pka".
	(do_export): Adjust for this.
	(write_keyblock_to_output): Ditto.
	(do_export_stream): Ditto.
	(print_pka_or_dane_records): Rename to ...
	(print_dane_records): this and remove two args. Remove PKA printing.
	* g10/free-packet.c (free_seckey_enc, cp_pka_info): Adjust for removed
	pka_info field.
	* g10/getkey.c (get_pubkey_byname): Make AKL_PKA a dummy.
	* g10/keyserver.c: Remove "honor-pka-record".
	(keyserver_import_pka): Remove.
	* g10/mainproc.c (get_pka_address): Remove.
	(pka_uri_from_sig): Remove.
	(check_sig_and_print): Remove code for PKA.

	gpg: Remove more or less useless tool gpgcompose.
	+ commit fde7d833573d358b2c5b5eb7d837bc27c6dcb3d1
	* g10/gpgcompose.c: Remove

	gpg: Remove experimental feature to export w/o user-ids.
	+ commit 3491faa3bb62c1c96c6dd5947516128b2a966535
	* g10/options.h (IMPORT_DROP_UIDS, EXPORT_DROP_UIDS): Remove.
	* g10/import.c (parse_import_options): Remove option import-drop-uids.
	(import_one_real): Remove drop uids code.
	(remove_all_uids): Remove function.
	* g10/export.c (parse_export_options): Remove option export-drop-uids.
	(do_export_one_keyblock): Remove drop uids code.

	card: List keys of pkcs#15 cards.
	+ commit a06c79b6143fc49e6f5169b8a9f53c691031d6ca
	* tools/gpg-card.c (list_p15): New.
	(list_card): Call it.

	scd:p15: Read PuKDF and minor refactoring.
	+ commit 0c080ed5791ecf1606d1c2fddc0c55362fd171d3
	* scd/app-p15.c (pukdf_object_t): New.
	(struct app_local_s): Add field public_key_info.
	(release_pukdflist): New.
	(select_and_read_record): No diagnostic in case of not_found.
	(read_first_record): New.  Factored out from the read_ef_ fucntions.
	(read_ef_pukdf): New.  Basically a copy of read_ef_prkdf for now.
	(read_p15_info): Also read the public keys.

	(cardtype2str): New.
	(read_ef_tokeninfo): Print a string with the cardtype.

2021-02-01  Werner Koch  <wk@gnupg.org>

	sm: Add a few OIDs and merge OID tables.
	+ commit 0737dc8187a0eb9ca4661e2ad45954c718daa451
	* sm/keylist.c (OID_FLAG_KP): New.
	(key_purpose_map): Merge into ...
	(oidtranstbl): this.
	(get_oid_desc): New arg 'matchflag'.  Use function in place of direct
	access to key_purpose_map.

2021-01-28  Werner Koch  <wk@gnupg.org>

	Include the library version in the compliance checks.
	+ commit 90c514868ff5fcf6d39490d4874ac3a31ba9e85f
	* common/compliance.c (gnupg_gcrypt_is_compliant): New.
	(gnupg_rng_is_compliant): Also check library version.
	* g10/mainproc.c (proc_encrypted): Use new function.
	(check_sig_and_print): Ditto.
	* sm/decrypt.c (gpgsm_decrypt): Ditto.
	* sm/encrypt.c (gpgsm_encrypt): Ditto.
	* sm/verify.c (gpgsm_verify): Ditto

2021-01-27  Werner Koch  <wk@gnupg.org>

	scd:p15: Make file selection more robust.
	+ commit 1e197c29ed95d021f5693cd3652b6acb07d928ea
	* scd/app-p15.c: Include host2net.h.
	(DEFAULT_HOME_DF): New.
	(select_and_read_binary): Replace slot by app.  Change callers.  Use
	select_ef_by_path.
	(select_and_read_record): ditto.
	(select_ef_by_path): Make use use the home_df.
	(parse_certid): Adjust for always set home_df.
	(print_tokeninfo_tokenflags): Ditto.
	(app_select_p15): Take the home_df from the FCI returned by select.

	scd: Define new status word.
	+ commit 7620473cd007c074b0625a678caa6105a4c87142
	* scd/apdu.h (SW_NO_CURRENT_EF): New.

	scd:p15: Factor the commonKeyAttributes parser out.
	+ commit 5bcbc8cee310067aa3cc48665b0fb0595c64ae4d
	* scd/app-p15.c (read_ef_prkdf): Fix detection of unsupported key
	 objects.  Factor some code out to ...
	(parse_common_key_attr): new.

	gpg: Fix ugly error message for an unknown symkey algorithm.
	+ commit b08418d22cc898c9d135217e07ca77f3daf3c9e9
	* g10/mainproc.c (proc_symkey_enc): Do not continue with an unknown
	algorithm.

2021-01-26  Werner Koch  <wk@gnupg.org>

	scd:p15: Factor the commonObjectAttributes parser out.
	+ commit fb84674d6c645a423b8ed9835437d25e4893e183
	* scd/app-p15.c (parse_common_obj_attr): New.
	(read_ef_prkdf): Use new function.
	(read_ef_aodf): Ditto.

	scd:p15: First step towards real CardOS 5 support.
	+ commit fc287c0552b0fe489c66bb493879f4330c34f287
	* scd/iso7816.c (iso7816_select_path): Add arg from_cdf.
	* scd/app-nks.c (do_readkey): Adjust for this change.

	* scd/app-p15.c (CARD_TYPE_CARDOS_53): New.
	(IS_CARDOS_5): New.
	(card_atr_list): Add standard ATR for CardOS 5.3.
	(select_and_read_binary): Remove the fallback to record read hack.
	(select_and_read_record): New.
	(select_ef_by_path): Rework and support CardOS feature.
	(read_ef_prkdf): Use read record for CardOS.
	(read_ef_cdf): Ditto.
	(read_ef_aodf): Ditto.  Also fix bug in the detection of other
	unsupported attribute types.
	(verify_pin): Use IS_CARDOS_5 macro.
	(app_select_p15): Force direct method for CardOS.

2021-01-25  Werner Koch  <wk@gnupg.org>

	agent: Support ssh-agent extensions for environment variables.
	+ commit 224e26cf7b67f22bb0140133eac6b4ad24f3b1b7
	* common/session-env.c (session_env_list_stdenvnames): Extend to allow
	return all names as one string.
	* agent/command-ssh.c (SSH_REQUEST_EXTENSION): New.
	(SSH_RESPONSE_EXTENSION_FAILURE): New.
	(request_specs): Add handler for the extension command.
	(ssh_handler_extension): New.

2021-01-21  Werner Koch  <wk@gnupg.org>

	scd:p15: Show the ATR as part of the TokenInfo diagnostics.
	+ commit 60499d98940d4b7a1673b8584cafe0f7ac2901dd
	* scd/app-p15.c (read_ef_tokeninfo): Print the ATR in verbose mode.

2021-01-19  Werner Koch  <wk@gnupg.org>

	Require Libgcrypt 1.9.
	+ commit 9500432b7ae10d98b30c58de4357e2ffb93bf795
	* configure.ac: Require at least Libgcrypt 1.9.0.  Remove all
	GCRYPT_VERSION_NUMBER dependent code.

2021-01-12  Werner Koch  <wk@gnupg.org>

	tools: Add option --clock to watchgnupg.
	+ commit 93d5d7ea2a8b110b3ad88be25f2f67d706361e44
	* tools/watchgnupg.c (print_fd_and_time) [ENABLE_LOG_CLOCK]: Use
	clock_gettime.
	(print_version): New option --clock.

2021-01-11  Werner Koch  <wk@gnupg.org>

	gpg,w32: Fix gnupg_remove.
	+ commit b6967d31912912ad3c0a2ff6bf6eb9822a194562
	* common/sysutils.c (map_w32_to_errno): New.
	(gnupg_w32_set_errno): New.
	(gnupg_remove) [w32]: Set ERRNO

2021-01-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	I meant "SHA-2 digests" in the previous commit.
	+ commit 7eef40cc1143fb19132786ebcca1c9a6c9a85e6e


	scd:nks: Add support for signing plain SHA-3 digests.
	+ commit 8fe976d5b9a0f2902868737dd502c749565222a6
	* scd/app-nks.c (do_sign): Handle plain SHA-3 digests and verify
	encoding of ASN.1 encoded hashes.

2020-12-30  Werner Koch  <wk@gnupg.org>

	wkd: Minor permission fix for created files.
	+ commit c008e8d20e12c8845403ad7dad499f6a196ecc6a
	* tools/wks-util.c (wks_cmd_install_key): Don't set u+x on the file.
	(ensure_policy_file): No need to make the policy file group writable.

2020-12-21  Werner Koch  <wk@gnupg.org>

	common: Remove superfluous debug output from dotlock.c.
	+ commit fc0eaa9add3c9bc93d4404988be3e1eb8f88ffa2
	* common/dotlock.c (dotlock_create_unix): Remove debug output.

	doc: Explain LDAP keyserver parameters.
	+ commit e0cbb97925a109fee7c0a7450bcac120f2766ed2


2020-12-18  Werner Koch  <wk@gnupg.org>

	dirmngr: Do not block threads in LDAP keyserver calls.
	+ commit 355e2992c043dd3241a9e838255f01418490ef33
	* dirmngr/ks-engine-ldap.c: Wrap some ldap calls.

2020-12-17  Werner Koch  <wk@gnupg.org>

	gpg: New AKL method "ntds"
	+ commit 4a3836e2b2f9a91995d5ce058820e1121298f548
	* dirmngr/ks-engine-ldap.c (keyspec_to_ldap_filter): Change the new
	support for KEYDB_SEARCH_MODE_MAIL.
	(ks_ldap_get): Add a debug.
	* g10/options.h (AKL_NTDS): New.
	* g10/keyserver.c (keyserver_import_ntds): New.
	(keyserver_get_chunk): Allow KEYDB_SEARCH_MODE_MAIL.
	* g10/getkey.c (parse_auto_key_locate): Support "ntds".
	(get_pubkey_byname): Ditto.

	dirmngr: Support "ldap:///" for the current AD user.
	+ commit 1194e4f7e2dff620e0da87f212f3a35f8021b142
	* dirmngr/http.h (struct parsed_uri_s): Add field ad_current.
	* dirmngr/ldap-parse-uri.c (ldap_parse_uri): Set it.
	* dirmngr/ks-engine-ldap.c (my_ldap_connect): Take care of ad_current.

	dirmngr: Allow LDAP searches via fingerprint.
	+ commit 2cadcce3e877c857bb8859574762b59b9c193b44
	* dirmngr/ks-engine-ldap.c (keyspec_to_ldap_filter): Add arg
	serverinfo and allow searching by fingerprint.
	(ks_ldap_get, ks_ldap_search): First connect then create teh filter.

2020-12-15  Werner Koch  <wk@gnupg.org>

	dirmngr: Store all version 2 schema attributes.
	+ commit a2434ccabdd1956876b44e05e07c3c3630c50f8f
	* g10/call-dirmngr.c (ks_put_inq_cb): Emit "fpr" records.
	* dirmngr/ks-engine-ldap.c (extract_attributes): Add args
	extract-state and schemav2.  Add data for the new schema version.
	remove the legacy code to handle UIDs in the "pub" line.
	(ks_ldap_put): Set new attributes for NTDS use the fingerprint as CN.

2020-12-14  Werner Koch  <wk@gnupg.org>

	dirmngr: Support the new Active Directory schema.
	+ commit e9ddd61fe979b1b8e1a4801f7f916d0222397245
	* dirmngr/ks-engine-ldap.c (SERVERINFO_): New constants.
	(my_ldap_connect): Relace args pgpkeyattrp and real_ldapp by a new
	serverinfo arg.  Set the new info flags.
	(ks_ldap_get): Adjust for change.
	(ks_ldap_search): Ditto.
	(ks_ldap_put): Ditto.  Replace xmalloc by xtrymalloc.  Change the DN
	for use with NTDS (aka Active Directory).
	* doc/ldap/gnupg-ldap-init.ldif (pgpSoftware): Update definition of
	pgpVersion.
	* doc/ldap/gnupg-ldap-ad-init.ldif: New.
	* doc/ldap/gnupg-ldap-ad-schema.ldif: New.

	dirmngr: Do not store the useless pgpSignerID in the LDAP.
	+ commit cc056eb534c1b8f7d1a90af3b9ecb9d6b2f322fa
	* dirmngr/ks-engine-ldap.c (extract_attributes): Do not store the
	pgpSignerID.
	* g10/call-dirmngr.c (ks_put_inq_cb): Do not emit sig records.

	dirmngr: Fix adding keys to an LDAP server.
	+ commit 37a899d0e4fd49512d522e7f6f86b6968309fece
	* dirmngr/ks-engine-ldap.c (ks_ldap_put): Extract attribites into
	addlist.

2020-12-11  NIIBE Yutaka  <gniibe@fsij.org>

	scd:nks: Support READKEY with keygrip and for "NKS-IDLM" keyref.
	+ commit 3b392630881350baabeba16fa760bad04be94d03
	* scd/app-nks.c (do_readkey): Allow KEYGRIP access.
	Support NKS-IDLM.XXXX keyref.

	scd:nks: Factor out pubkey retrieval from keygrip handling.
	+ commit b7c087375d84c31ab8a645cd81e6b1e6185cb30d
	* scd/app-nks.c (pubkey_from_pk_file): New.
	(keygripstr_from_pk_file): Use pubkey_from_pk_file.

2020-12-10  NIIBE Yutaka  <gniibe@fsij.org>

	scd:nks: Add support of KEYGRIP for do_readcert.
	+ commit 4020cd9d656264bec5e7fb5e45c5e06eff8656c3
	* scd/app-nks.c (do_readcert): Support KEYGRIP.

	scd:nks: Factor out iteration over filelist.
	+ commit 6c4365847666cefac73ccc743a99fac473da2186
	* scd/app-nks.c (iterate_over_filelist): New.
	(do_with_keygrip): Use iterate_over_filelist.

2020-12-09  Werner Koch  <wk@gnupg.org>

	wks-client: Improve an error message.
	+ commit c7c88648b71b8ce3a5507946afb91761fc6d931e
	* tools/gpg-wks-client.c (read_confirmation_request): Print trust
	letter.

2020-12-09  NIIBE Yutaka  <gniibe@fsij.org>

	scd:ccid:spr532: Extend abort_cmd for initialization time.
	+ commit a9aa30ed2c2c399c2baa6a5aa2624d8fdee6286f
	* scd/ccid-driver.c (abort_cmd): Add INIT argument to support
	synchronize until success, even ignoring timeout.
	(bulk_in): Normal use case of abort_cmd.
	(ccid_vendor_specific_init): Initial use case of abort_cmd.

	scd:ccid: Call libusb_clear_halt in ccid_vendor_specific_setup.
	+ commit f50373027222f28ab9d37843178a5d44cc1e3cc0
	* scd/ccid-driver.c (ccid_vendor_specific_setup): Only for SPR532,
	call libusb_clear_halt.

	scd:ccid: Revert the addition of libusb_clear_halt for EP_INTR.
	+ commit ffabc29d5eadfe81b9f62b7d4fe6e858b191354d
	* scd/ccid-driver.c (ccid_setup_intr): Don't call libusb_clear_halt.

2020-12-08  NIIBE Yutaka  <gniibe@fsij.org>

	scd:yubikey: Fix support of Yubikey NEO.
	+ commit 946555ea3ceb823b95ed13654ae4fd667daa4337
	* scd/app-openpgp.c (get_public_key): Yubikey NEO also has this issue.

	agent: Allow decryption with card but no file.
	+ commit eda3c688fc2e85c7cd63029cb9caf06552d203b4
	* agent/pkdecrypt.c (agent_pkdecrypt): Support decryption with card
	but without a stub key.

	agent: Clean up the API of agent_pkdecrypt.
	+ commit 9beab36dfa39106f6efd1bb89551a581bcf9df60
	* agent/agent.h (agent_pkdecrypt): Use gpg_error_t type.
	* agent/pkdecrypt.c (agent_pkdecrypt): Use gpg_error_t type.

	agent: Allow pksign operation with card but no file.
	+ commit cbb0e069f55bc45037bbd69d54ce23dae2af2ac6
	* agent/pksign.c (agent_pksign_do): Add support with no file.

2020-12-07  Ingo Klöcker  <dev@ingo-kloecker.de>

	gpg: Make quick-gen-key with algo "card" work for keys without keytime.
	+ commit 255d33d65126df00bc036580d0b32735d7178c8b
	* g10/keygen.c (quick_generate_keypair): Set pCARDKEY flag if algostr
	is "card" or "card/...".

2020-12-07  NIIBE Yutaka  <gniibe@fsij.org>

	gpg,card: Allow no version information of Yubikey.
	+ commit 1cd615afe3010d2c3919de489d7c9a78513c8694
	* g10/call-agent.c (learn_status_cb): Assume >= 2 when no version.
	* tools/card-call-scd.c (learn_status_cb): Likewise.

2020-12-03  NIIBE Yutaka  <gniibe@fsij.org>

	scd:nks: Fix caching keygrip (more).
	+ commit 87d2c579cc38c1d2787945650125fb0e0336652c
	* scd/app-nks.c (keygripstr_from_pk_file): Distinguish by APP_ID.

	scd: Fix KEYINFO command with --data option.
	+ commit 54b88ae4606265f3d51c1ca603dbf846f3dfd678
	* scd/command.c (cmd_keyinfo): Handle --data option correctly.

	scd:openpgp: Fix writing ECC key to card.
	+ commit a25c99b156ca9acaa7712e9c09a6df0a7a23c833
	* scd/app-openpgp.c (build_privkey_template): Adding another argument
	of ecc_d_fixed_len to handle variable-size MPI.

2020-12-02  Werner Koch  <wk@gnupg.org>

	kbx: Better error message in case of a crippled Libgcrypt.
	+ commit 63ed2054a1f3cfbdff5cda390952f10a512dab83
	* kbx/keybox-openpgp.c (keygrip_from_keyparm): Detect missing curve.

2020-12-01  Jens Meißner  <meissner@b1-systems.de>

	doc: Add parameters for batch generation of ECC keys.
	+ commit 4f9ac5dac093300ac18fd3732bffdd2a3fc38776
	* doc/gpg.texi: Add parameters for batch generation of ECC keys.

2020-11-30  Werner Koch  <wk@gnupg.org>

	scd:nks: Minor additions to the basic IDLM application support.
	+ commit 806547d9d243b26c2275fc00c645ee39d258b49b
	* scd/app-nks.c (filelist): Use special value -1 for IDLM pubkeys.
	(keygripstr_from_pk_file): Handle special value.
	(do_readcert): Ditto.
	(do_writecert): Ditto.

2020-11-27  Werner Koch  <wk@gnupg.org>

	card: Let the APDU command prints a description of the status word.
	+ commit ad469609b101fe6c1128135180fef8eae13279ff
	* tools/card-call-scd.c (scd_apdu_strerror): New.
	* tools/gpg-card.c (cmd_apdu): Print a description.

	scd: New getinfo sub-command apdu_strerror.
	+ commit 0e34683a6c4b037aa50ca0f97ddb9d5c4e499084
	* scd/apdu.c (apdu_strerror): Add missing status codes.
	* scd/command.c (cmd_getinfo): New sub-command apdu_strerror.

	card: Netkey improvement for passwd.
	+ commit 5804db1a13d2cf8f4010d1257c586bed978c3173
	* tools/gpg-card.c (cmd_passwd) [Netkey]: No Standard/QES menu if the
	card does not support it.  Print no error in cases the user canceled.

2020-11-27  NIIBE Yutaka  <gniibe@fsij.org>

	scd:ccid-driver: Fix pinpad error handling for cancel/timeout.
	+ commit bb591222c3c5cb1a1750b1b1dd26d0bc53b347cb
	* scd/apdu.h (SW_HOST_UI_CANCELLED, SW_HOST_UI_TIMEOUT): New.
	* scd/ccid-driver.h (CCID_DRIVER_ERR_UI_CANCELLED): New.
	(CCID_DRIVER_ERR_UI_TIMEOUT): New.
	* scd/ccid-driver.c (bulk_in): Handle PIN input cancel/timeout error.
	* scd/iso7816.c (map_sw): Support SW_HOST_UI_CANCELLED and
	SW_HOST_UI_TIMEOUT.

2020-11-26  Werner Koch  <wk@gnupg.org>

	agent: Fix YK s/n and prettify the request card prompt for Yubikeys.
	+ commit 7113263a00d8c9b09f0dfdb9590bfe2bab1bc776
	* agent/divert-scd.c (ask_for_card): Detect and re-format the Yubikey
	prompt.
	* scd/app.c (app_munge_serialno): Fix Yubikey s/n munging.
	(card_get_dispserialno): Ditto.
	* scd/app-openpgp.c (get_disp_serialno): Remove.
	(get_prompt_info): Use app_get_dispserialno.--

	scd: Do not try to use a non-enabled app after card switching.
	+ commit d784e763495c8d53e29a2debdd9c0e0578f15a6a
	* scd/app.c (app_dump_state): Also print the refcount.
	(maybe_switch_app): Make sure the app exists on the card.

	scd: Add special serialno compare for OpenPGP cards.
	+ commit 764c69a841abc1a4dff2fa86b4cd0b63ec737860
	* scd/app.c (is_same_serialno): New.
	(check_application_conflict): Use this.
	(select_application): Ditto.
	(app_switch_current_card): Ditto.
	* scd/app-openpgp.c (check_keyidstr): Ignore the card version and also
	compare case insensitive.

2020-11-26  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Report an error for receiving key from agent.
	+ commit 605ab99912ac632363d1b4378a710229e40ca99e
	* g10/export.c (do_export_one_keyblock): Report an error.

	scd,nks: Fix caching keygrip.
	+ commit 920154370834ad8d947aed19c9d914a27dde6baa
	* scd/app-nks.c (keygripstr_from_pk_file): Identify by cfid if
	available.

2020-11-25  Werner Koch  <wk@gnupg.org>

	scd:p15: Print the internal card type.
	+ commit 00037f499db830c75fee2111dfbef72fa11bd98a
	* scd/app-p15.c (read_ef_tokeninfo): Print the internal card type.

	scd:p15: Improve support for some CardOS based cards.
	+ commit c7b9a4ee439eca5a4bde4781f7d8983af3b9201e
	* scd/iso7816.c (iso7816_read_binary_ext): Add optional arg r_sw and
	change callers.
	(iso7816_read_record): Factor all code out to ...
	(iso7816_read_record_ext): new.
	* scd/app-p15.c (select_and_read_binary): Fallback to record reading.
	(read_ef_aodf): Clear EOF error.

	scd: Rework the handling of the displayed serial number.
	+ commit 3a8250c02031080c6c8eebd5dea03f5f87f9ddd7
	* scd/app.c (app_new_register): Call app_munge_serialno for Yubikeys.
	(app_munge_serialno): Handle Yubikey serial numbers.
	(card_get_serialno): Remove special Yubikey treatment.  Drop arg
	is_canonical.
	(app_get_serialno): Clear ERRNO on error.
	(card_get_dispserialno): New.  Also change formatting of Yubikey and
	OpenPGP numbers to match those printed on the card.
	(app_get_dispserialno): New.
	* scd/app-openpgp.c (do_getattr): Use app_get_dispserialno.
	(yubikey_get_serialno): Remove.
	* scd/app-piv.c (get_dispserialno): Remove.
	(do_getattr): Use app_get_dispserialno.

2020-11-25  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix an error return for READKEY.
	+ commit c3a20c88fb30b0fc4ce50a01de97fae333003682
	* scd/command.c (cmd_readkey): Return when error.

	scd,nks: Fix SEGV for learn for older card.
	+ commit 006944b856ee2202905290e8a2f5523a7877d444
	* scd/app-nks.c (keygripstr_from_pk_file): Set algostr.

2020-11-20  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Change API of agent_scd_serialno.
	+ commit 777019faf0b8f10a897c3ee477d35f9b29f02224
	* g10/call-agent.c (agent_scd_serialno): Extend API to allow with
	R_SERIALNO == NULL.
	* g10/card-util.c (card_status): Use NULL for agent_scd_serialno.
	(factory_reset): Likewise.
	* g10/skclist.c (build_sk_list): Likewise.

	Fix the previous comment changes help doc string.
	+ commit cc8b99d18e26397028ca185e44d0886a94cc1bf6
	* scd/command.c (hlp_learn): Fix the doc string.

2020-11-19  Werner Koch  <wk@gnupg.org>

	gpgconf: Also print revision of libksba.
	+ commit 4070f302e4decc8d54d1305cbd30f6dab052ef7e
	* dirmngr/dirmngr.c (get_revision_from_blurb): Fix detection of empty
	string.
	(gpgconf_versions): Print ksba revision.

2020-11-19  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix creating shadow key on card key generation.
	+ commit 8ddadbbdbbe20b9e87eb2bfa142577e26dae297e
	* agent/command.c (cmd_readkey): Fix handling --card option.

	gpg: Fix --card-edit command.
	+ commit e45455d3020ca8f21c54112b6dfb1cc9bd3f2623
	* g10/card-util.c (get_info_for_key_operation): Revert the change.

2020-11-18  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update to newer autoconf constructs.
	+ commit d66fb3aa53a6c4a815fe35a15e3c61886c5df628
	* acinclude.m4 (GNUPG_CHECK_ENDIAN): Use AC_COMPILE_IFELSE instead of
	AC_TRY_COMPILE.  Use AC_RUN_IFELSE instead of AC_TRY_RUN.
	(GNUPG_BUILD_PROGRAM): Use AS_HELP_STRING instead of AC_HELP_STRING.
	* configure.ac: Use AC_USE_SYSTEM_EXTENSIONS instead of AC_GNU_SOURCE.
	Use AS_HELP_STRING instead of AC_HELP_STRING.
	(AC_ISC_POSIX): Replace by AC_SEARCH_LIBS.
	(AC_TYPE_SIGNAL): Remove.
	* m4/isc-posix.m4: Remove.
	* m4/codeset.m4: Update from gnulib.
	* m4/gettext.m4: Update from gnulib.
	* m4/lcmessage.m4: Update from gnulib.
	* m4/socklen.m4: Update from gnulib.
	* m4/ldap.m4: Use AS_HELP_STRING instead of AC_HELP_STRING.
	Use AC_LINK_IFELSE instead of AC_TRY_LINK.
	Use AC_RUN_IFELSE instead of AC_TRY_RUN.
	* m4/gpg-error.m4: Update from libgpg-error.
	* m4/readline.m4: Update from libgpg-error.
	* m4/npth.m4: Update from npth.
	* m4/libassuan.m4: Update from libassuan.
	* m4/libgcrypt.m4: Update from libgcrypt.
	* m4/ksba.m4: Update from libksba.
	* m4/ntbtls.m4: Update from ntbtls.
	* common/signal.c [!HAVE_DOSISH_SYSTEM] (init_one_signal): Replace
	RETSIGTYPE to void.
	[!HAVE_DOSISH_SYSTEM] (got_fatal_signal, got_usr_signal): Likewise.

	build: Use modern Autoconf check for types.
	+ commit aeeb8e975dc740cb79954de7fec4fcfe902d3a42
	* common/types.h: Use HAVE_TYPE_BYTE, HAVE_USHORT_TYPEDEF,
	HAVE_ULONG_TYPEDEF, HAVE_U16_TYPEDEF, and HAVE_TYPE_U32.
	* configure.ac (byte, ushort, ulong, u16, u32): Use AC_CHECK_TYPES.

2020-11-13  Werner Koch  <wk@gnupg.org>

	gpg: Fix the encrypt+sign hash algo preference selection for ECDSA.
	+ commit e37c2e184448f64e285f925ab9636b5f21be99f7
	* g10/keydb.h (pref_hint): Change from union to struct and add field
	'exact'.  Adjust callers.
	* g10/pkclist.c (algo_available): Take care of the exact hint.
	* g10/sign.c (sign_file): Rework the hash detection from
	recipient prefs.

2020-11-12  Werner Koch  <wk@gnupg.org>

	gpgconf: Yet another fix for --apply-profile.
	+ commit e546cc78b75978a696298f2fcc072faeb7f69be4
	* tools/gpgconf.c (main): Use gnupg_homedir instead of
	default_homedir.  Check for existance of the directory.

2020-11-11  Werner Koch  <wk@gnupg.org>

	w32: Replace some fopen by es_fopen.
	+ commit d574213ce21c495d9432eeb5956e8857826876c6
	* agent/protect-tool.c (read_file): Replace fopen by es_fopen.
	* dirmngr/dirmngr-client.c (read_pem_certificate):  Ditto.
	(read_certificate): Ditto.
	* g10/keydb.c (rt_from_file): Ditto.
	* kbx/kbxutil.c (read_file): Ditto.
	* g10/plaintext.c (get_output_file) [__riscos__]: Remove code.

2020-11-11  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix the previous commit.
	+ commit dd2703096f3ee7f4b6b96e2b649daf85aa8d6030
	* g10/delkey.c (do_delete_key): Fix the condition for the error.

2020-11-10  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: In batch mode, delete-secret-key is not okay without --yes.
	+ commit f9bbc751633f38f58fecb71c33aae735e9b30241
	* g10/delkey.c (do_delete_key): Emit an error when not --yes.

	gpg: Fix agent_delete_key interaction.
	+ commit 9854369a729b9fde43eac2e2f7154f5187378787
	* g10/call-agent.c (agent_delete_key): Set up CTX.

2020-11-09  Werner Koch  <wk@gnupg.org>

	card: Run factory-reset in locked stated also in gpg-card.
	+ commit 12fd10791f1dec4ec42810d7b92c69e1ae2327b9
	* tools/card-call-scd.c (scd_apdu): Add more pseudo APDUs.
	* tools/card-misc.c (send_apdu): Handle them.
	* tools/gpg-card.c (cmd_factoryreset): Use lock commands.

	card: Run factory-reset in locked stated.
	+ commit 8fb0d5e3c775f40e321689b35431d81425406237
	* scd/command.c (reset_notify): Add option --keep-lock.
	(do_reset): Add arg keep_lock.
	(cmd_lock): Send progress status.
	* g10/call-agent.c (agent_scd_apdu): Add more pseudo APDUs.
	* g10/card-util.c (send_apdu): Ditto.
	(factory_reset): Use lock commands.

	gpg: Do not print rejected digest algo notes with --quiet.
	+ commit e08e1d62d089a154ec5d7c80cd58e8e3b18d2d6b
	* g10/misc.c (print_digest_rejected_note): Do not print in quiet mode.
	(print_sha1_keysig_rejected_note): Ditto.

2020-11-09  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix SOS handling when exporting SSH key with libgcrypt 1.8.
	+ commit bf3a9377d147d8a83d9c71ca5a7284897c913951
	* g10/export.c (key_to_sshblob): Fix SOS correctly.

	agent: Fix SOS handling with libgcrypt 1.8.
	+ commit ba4f68416742eb241ec5490d16f88b0eb0bdc811
	* agent/cvt-openpgp.c (apply_protection): Handle opaque MPI.

2020-11-06  Werner Koch  <wk@gnupg.org>

	agent: Minor tweaks to the new genpin inquiry.
	+ commit c896112fa3f7f3289b5198bfac992160feb0ad0a
	* agent/call-pinentry.c (generate_pin): Use STRING random which is
	sufficient for a passphrase.
	(inq_cb): s/rc/err/.  Do not print two errors in case generate_pin
	fails.  Lowercase strings as per GNU standards.
	(setup_genpin): Fix translation test.
	(setup_qualitybar): Ditto.

2020-11-06  Andre Heinecke  <aheinecke@gnupg.org>

	agent: Add genpin inquiry for pinentry.
	+ commit 557ddbde32585c534626b57a595a2ccf28fd585e
	* agent/call-pinentry.c (agent_get_passphrase): Setup genpin.
	(do_getpin): Update with new name for inquire callback.
	(inq_quality): Rename to inq_cb and add genpin support.
	(inq_cb): Renamed form inq_quality.
	(generate_pin): New helper to generate a pin.
	(agent_askpin): Fix some typos.
	(setup_genpin): Provide new strings for pinentry.

2020-11-05  Ben Kibbey  <bjk@luxsci.net>

	gpg: Add canceled status message.
	+ commit 31e47dfad0f40e31e8b3113b933696e8e4105136
	* common/status.h (STATUS_CANCELED_BY_USER): New.
	* g10/passphrase.c (passphrase_to_dek): Send STATUS_CANCELED_BY_USER
	instead of STATUS_MISSING_PASSPHRASE when canceled is set.

2020-11-05  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Use lock_slot for apdu_send_direct.
	+ commit f808012ac2cf67ec563da178d963f300a7f2564d
	* scd/apdu.c (apdu_send_direct): Use lock_slot.

	scd: Internal CCID driver: Fix a race condition on close.
	+ commit 484bafda4dbf5ffe9e7c41ef24fbc5bd791a3b32
	* scd/ccid-driver.c (ccid_require_get_status): For VENDOR_SCM reader,
	return 0 only at the initial call.
	(bulk_in): Don't detect an error for VENDOR_SCM reader, just kicking
	the loop, to invoke scd_update_reader_status_file, which calls
	ccid_slot_status again.
	(ccid_slot_status): Move the call of ccid_vendor_specific_setup to...
	(ccid_get_atr): ... here.

2020-11-04  Werner Koch  <wk@gnupg.org>

	speedo,w32: Install gpg-check-pattern and example profiles.
	+ commit f5a81953e172a7bb4d02f2dc0e398f379c39ec84
	* doc/examples/vsnfd.prf: Rename to VS-NfD.prf.
	* doc/examples/Automatic.prf: New.
	* doc/Makefile.am (examples): Adjust.
	* build-aux/speedo/w32/inst.nsi: Install gpg-check-pattern.exe and 3
	example files.
	* build-aux/speedo/w32/wixlib.wxs: Add new files.

	g13: Include a now missing header file.
	+ commit b7f4e2d71fe3dee680f834cfc3dd620352830147
	* g13/create.c: Include sysutuls.h

	gpgconf: Make sure the homedir exists for --apply-profile.
	+ commit 7d95f2e7e7a09e3d433d449b117e3470f9dd38c7
	* tools/gpgconf.c (main) <aApplyDefaults, aApplyProfile>: Create the
	standard home directory.

	common: Fix duplicate implementation of try_make_homedir.
	+ commit dabc314b71378f585fac2753149f3358e32ec621
	* g10/openfile.c (try_make_homedir): Move core of the code to ...
	* common/homedir.c (gnupg_maybe_make_homedir): new.
	* sm/keydb.c (try_make_homedir): Implement using new function.

	* common/homedir.c: Include i18n.h.
	* po/POTFILES.in: Add common/homedir.c.

2020-11-04  Andre Heinecke  <aheinecke@gnupg.org>

	w32: Add another pinentry search path.
	+ commit c8f6f6bbc8b203e633d382aa84862807c1aeb3d1
	* common/homedir.c (get_default_pinentry_name): Try ../bin/pinentry.exe

	w32: Add windows subsystem variant of gpgconf.
	+ commit e2659f4bf603693c43af0444239bc52744291edc
	* tools/Makefile.am (gpgconf-w32): New target. Builds gpgconf with
	subsystem windows.
	* build-aux/speedo/w32/wixlib.wxs: Package it.

2020-11-03  Werner Koch  <wk@gnupg.org>

	w32: Fix strftime problem on Windows.
	+ commit e8aae18b997b3fdbfac86c644be94044aa67224d
	* common/gettime.c: Include locale.h.
	(asctimestamp): Increase buffer.  On Windows use setlocale.

	gpg: Switch to AES256 for symmetric encryption in de-vs mode.
	+ commit d1f2a6d9f71cf50318f4891c84aeedb975553896
	* g10/gpg.c (set_compliance_option): For AES256 and SHA256 in de-vs
	mode.
	* g10/encrypt.c (setup_symkey): Add extra compliance check.
	(encrypt_simple): Avoid printing a second error oncplinace failure.

2020-11-02  Werner Koch  <wk@gnupg.org>

	gpg: Allow setting notations with the empty string as value.
	+ commit e1bafa3574ccd56d9f8f8c1deb3d8fb9fd7025cc
	* g10/misc.c (pct_expando): Catch special case of the empty string.
	Also map a NULL to the empty string.
	* g10/photoid.c (show_photos): Make an empty string used as command
	fail.

	build: Remove m4 macro defs which are not anymore used.
	+ commit 6397cf5fbe3bbc1f616431b011f76e031a387d4c
	* configure.ac (GNUPG_FUNC_MKDIR_TAKES_ONE_ARG): Do not use.
	* acinclude.m4 (GNUPG_FUNC_MKDIR_TAKES_ONE_ARG): Remove unused macro
	defs.
	(GNUPG_CHECK_FAQPROG): Ditto.
	(GNUPG_CHECK_DOCBOOK_TO_TEXI): Ditto.
	(GNUPG_CHECK_MLOCK): Ditto.

	gpg: Do not use weak digest algos if selected by recipient prefs.
	+ commit 15746d60d492f5792e4a179ab0a08801b4049695
	* g10/misc.c (is_weak_digest): New.
	(print_digest_algo_note): Use it here.
	* g10/sig-check.c (check_signature_end_simple): Use it.
	* g10/sign.c (hash_for): Do not use recipient_digest_algo if it is in
	the least of weak digest algorithm.

2020-11-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	gpg: Fix iteration over signatures.
	+ commit b004701adca89ba85f75e12a4d284297147fe4f2
	* g10/keyedit.c (keyedit_quick_revsig): Take signature of correct node

2020-11-02  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Don't put zero-byte for ECC.
	+ commit 8211d0bc3ba5ed15d0668050c08a6e28228b08a4
	* kbx/keybox-openpgp.c (parse_key): Only put zero for non-ECC.

	gpg: Fix debug output for key_check_all_keysigs with opaque MPI.
	+ commit 90c3d623ce37695a1eb29c0a7276b23490d14603
	* g10/key-check.c (key_check_all_keysigs): Handle opaque MPI.

	gpg: Fix check_signature2 for opaque MPI.
	+ commit 029ba6dc961c683d6683c97667d3c0e103738aa4
	* g10/sig-check.c (check_signature2): Handle the case of opaque MPI.

	gpg: Change the API for checksum to use const qualifier.
	+ commit 21d8927f794bd901b13feaaac6d31d463349a64f
	* g10/main.h (checksum): Use const.
	* g10/misc.c (checksum): Use const.

	gpg: Fix counting buffer size in check_signature2.
	+ commit 3151210e455f14848921fac838a5064749258d9f
	* g10/sig-check.c (check_signature2): Use GCRYMPI_FMT_PGP.

2020-10-30  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix SOS handling with libgcrypt version <= 1.8.
	+ commit 813e24108a139c8059dad8bc679b2ab76b807ed9
	* g10/misc.c (checksum_mpi): Don't depend new feature
	of gcry_mpi_print which supports opaque MPI.

	gpg: Fix first zero-byte case for SOS handling.
	+ commit dd4fb1c8f668f78fbcf5052e80c5c40d4cdad20c
	* g10/export.c (transfer_format_to_openpgp): Check the first byte.
	* g10/pkglue.c (sexp_extract_param_sos): Likewise.

2020-10-28  Werner Koch  <wk@gnupg.org>

	gpg: New command --quick-revoke-sig.
	+ commit 243f9176e799b2328f2e5bed93099bfc474fdc5a
	* g10/gpg.c (enum cmd_and_opt_values): Add aQuickRevSig.
	(opts): Add --quick-revoke-sig.
	(main): Implement.
	* g10/keyedit.c (quick_find_keyblock): Add arg 'want_secret' and
	adjust all callers.
	(keyedit_quick_revsig): new.
	* g10/revoke.c (get_default_sig_revocation_reason): New.
	* g10/keylist.c (cmp_signodes): Make global.

2020-10-27  Werner Koch  <wk@gnupg.org>

	gpg: Sort the signatures in standard key listings.
	+ commit 742e2729f4bcadfeb93260107462f4faa108d3b2
	* g10/gpg.c (parse_list_options): Add "sort-sigs".
	(main): Make it the default.
	* g10/options.h (LIST_SORT_SIGS): New.
	* g10/keylist.c (cmp_signodes): New.
	(list_keyblock_print): Sort signatures and factor signature printing
	code out to ...
	(list_signature_print): new.

2020-10-27  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Handle canonical serialno and app specific serialno differently.
	+ commit e59d2b3632d8c778bd2c4375a1c3ba9c786c4360
	* scd/app-common.h (card_get_serialno): Add IS_CANONICAL arg.
	* scd/app.c (app_send_devinfo): Use app specific serialno.
	(card_get_serialno): Support two different cases.
	(app_get_serialno): Return app specific serialno.
	(send_serialno_and_app_status): Return canonical serialno.
	* scd/command.c (cmd_serialno): Return app specific serialno.
	(cmd_learn): Return canonical serialno.

2020-10-26  Werner Koch  <wk@gnupg.org>

	g10: Make call to agent_scd_serialno more robust.
	+ commit 0f780b1aebb1b1bde219401735a1c24c1f0a7978
	* g10/call-agent.c (agent_scd_serialno): Make sure that NULL is stored
	on error at r_serialno.
	* g10/card-util.c (card_status): Simplify freeing of seriaono.
	(factory_reset): Ditto.

2020-10-26  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Flush the cache when writing cert data object.
	+ commit 8264b10d33e46d2caac2f2c38ccb5f764c31ad77
	* scd/app-piv.c (do_writecert): Flush the cache of the data object.

	gpg: Fix double free on error.
	+ commit a153d0f7691486efe0aadfb1e226544ae6d20ffd
	* g10/card-util.c (card_status): Check an error return.

	gpg,tools: Fix detecting OpenPGP card by serialno.
	+ commit 157f1de64e437cecd75335e9f4077ba9835e3da0
	* tools/gpg-card.c (list_openpgp): Use ->apptype to determine card's
	APP.
	* g10/card-util.c (get_info_for_key_operation): Likewise.
	(current_card_status): Even if its SERIALNO is not like OpenPGP card,
	it's OpenPGP card when app says so.

	scd: Internal CCID driver thing only for SPR532.
	+ commit 31def32eeed8cff705ca827e4bbc0bfcc80c512f
	* scd/ccid-driver.c (ccid_vendor_specific_setup): New.  Limit
	only for SPR532, excluding other readers by SCM.
	(ccid_slot_status): Use ccid_vendor_specific_setup.

2020-10-24  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Internal CCID driver limiting only for SPR532.
	+ commit 3c6b5dfa2a2379a5f5eaa052f7dbc73462097425
	* scd/ccid-driver.c (ccid_vendor_specific_init): Only do that for
	SPR532.

2020-10-23  Werner Koch  <wk@gnupg.org>

	common: Allow building with released libgpg-error.
	+ commit 32f336d9555f18464d72a5068c290ab82ee92617
	* common/sysutils.c (gnupg_access) [W32]: Fix for older libgpgrt.

2020-10-23  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Handle Yubikey's multiple apps and serialno.
	+ commit 2d4de4b6f06c87cd0f72b2a0d09950e1b50841b2
	* scd/app-common.h (yubikey_get_serialno): New.
	* scd/app-openpgp.c (yubikey_get_serialno): New.
	* scd/app.c (card_get_serialno): Use OpenPGP app's serialno,
	when it's enabled for Yubikey.
	(send_serialno_and_app_status): Use card_get_serialno, not
	directly accessing ->serialno.

	scd: Use app_get_serialno for app_getattr.
	+ commit c8cc35dd2c106d91a793667690c0b200560d5d2d
	* scd/app.c (app_getattr): Use app_get_serialno.

	scd: Don't overwrite serialno for Yubikey.
	+ commit 65c91e601ae93aee1a5fa399d4a5d4498ad76eda
	* scd/app-openpgp.c (app_select_openpgp): Keep ->serialno.

	scd,openpgp: Use app_get_serialno function to get SERIALNO.
	+ commit 41505f0ae544535b524a409d87aa2540607fc9a4
	* scd/app-openpgp.c (check_keyidstr): Don't directly access
	app->serialno, but use app_get_serialno.
	(do_with_keygrip): Likewise.

2020-10-21  Werner Koch  <wk@gnupg.org>

	common: New functions gnupg_opendir et al.
	+ commit 7e22e08e2ab09cd3c2317f5e80e8ee47d46eff4b
	* common/sysutils.h (struct gnupg_dirent_s): New.
	* common/sysutils.c: Include dirent.h.
	(struct gnupg_dir_s): New.
	(gnupg_opendir, gnupg_readdir, gnupg_closedir): New.  Change all
	callers of opendir, readdir, and closedir to use these functions.

	w32: Make gnupg_remove and gnupg_rename_file Unicode aware.
	+ commit 9a0197b6fe412cfc66b0cece521267180e454416
	* common/sysutils.c (w32_rename): New.
	(gnupg_rename_file) [W32]: Support Unicode.
	(gnupg_remove) [W32]: Support Unicode.  Drop Windows-CE support.

2020-10-20  Werner Koch  <wk@gnupg.org>

	Replace all calls to stat by gnupg_stat.
	+ commit 18e5dd7b03ced51611c9ba1345cf498a0aaf14a6
	* common/sysutils.c (gnupg_stat): New.
	* common/sysutils.h: Include sys/stat.h.

	Replace most calls to open by a new wrapper.
	+ commit 4dcef0e17836e8725c31a3b76f2bf7144345c808
	* common/sysutils.c (any8bitchar) [W32]: New.
	(gnupg_open): New.  Replace most calls to open by this.
	* common/iobuf.c (any8bitchar) [W32]: New.
	(direct_open) [W32]: Use CreateFileW if needed.

	w32: Allow Unicode filenames for dotlock.
	+ commit b47c355b18d9537ccc3dd3e80cc1825b018ecff7
	* common/dotlock.c (any8bitchar) [W32]: New.
	(dotlock_create_w32): Use strconcat and CreateFileW.

	* common/t-dotlock.c: Source include dotlock.c and modify to allow
	manual testing on Windows.

	Replace all calls to access by gnupg_access.
	+ commit c94ee1386e0d5cdac51086c4d5b92de59c09c9b5
	* common/sysutils.c (gnupg_access): New.  Replace all calls to access
	by this wrapper.
	* common/homedir.c (w32_shgetfolderpath): Change to return UTF-8
	directory name.
	(standard_homedir): Adjust for change.
	(w32_commondir, gnupg_cachedir): Ditto.

2020-10-09  NIIBE Yutaka  <gniibe@fsij.org>

	gpg,ecc: Fix SOS handling when receiving from agent.
	+ commit 228836f79f64559c9582ac2d475e50af57684bf8
	* g10/export.c (transfer_format_to_openpgp): It's not simple opaque
	MPI, but SOS.

	agent: Fix SEGV when debuging for cache enabled.
	+ commit 33cb1655f1b7c597d1ebdcb38447648477e6ac9f
	* agent/cache.c (agent_get_cache): Avoid dereferencing NULL.

2020-10-05  Werner Koch  <wk@gnupg.org>

	gpgsm: Fix detection of too old keyboxd.
	+ commit 4eb9ce847825e8c6a07ce27d303c56233e85d007
	* sm/keydb.c (warn_version_mismatch): Add arg ctrl and pass on.
	(create_new_context): Pass ctrl to warn function.

	dirmngr: Minor cleanup for better readability.
	+ commit b258f8de7e9fc436d72c4d4ff8f98e9b86d2f3f5
	* dirmngr/ldap.c (start_default_fetch_ldap): Rename to
	start_cacert_fetch_ldap and remove arg attr.  Instead use
	"cACertificate" directly.
	* dirmngr/crlfetch.c (ca_cert_fetch): Change the only caller.
	(start_cert_fetch_ldap): Rename arg for clarity.

	dirmngr: Add warning on the use of --add-servers.
	+ commit 210575d8826ea61e4914e4b61eff7b875c972b85
	* tools/gpgconf-comp.c (known_options_dirmngr): Degrade add-servers to
	expert mode.

	gpg: Switch to ed25519+cv25519 as default algo.
	+ commit ff31dde456f32950f0df6c974b4c41f1d650d68f
	* g10/keygen.c (DEFAULT_STD_KEY_PARAM): Change to former future
	default ago.
	(ask_algo): Change default and also the way we indicate the default
	algo in the list of algos.
	(ask_curve): Indicate the default curve.

	keyboxd: Fix duplicates when listing keys by uid.
	+ commit 194034f813a09a0021e6aa82d64ea0693b37c8d0
	* kbx/backend-sqlite.c (struct be_sqlite_local_s): Add fields
	lastubid_valid and lastubid.
	(run_sql_prepare): Add optional extra2 arg and chage callers.
	(run_select_statement): Add an ORDER BY clause to most SELECTs.
	(be_sqlite_search): Skip duplicated keyblocks in a search.

2020-10-04  Werner Koch  <wk@gnupg.org>

	build: Fix SENDMAIL define for a PATH with spaces.
	+ commit 6c36b8bb23bb033aaae5f1dff3b38d8e0e44717c
	* configure.ac: Fix use of $PATH

	(cherry picked from commit 77e416741abb0a871733bd46cbc81329859de96e)

2020-10-02  Werner Koch  <wk@gnupg.org>

	gpgconf: New option --show-versions.
	+ commit 357ad9ae29677c1676b56d2b81282e2f78ec8040
	* tools/gpgconf.c: Include exechelp.h.  New option --show-versions.
	(get_revision_from_blurb): New.
	(show_version_gnupg): New.
	(show_version_libgcrypt): New.
	(show_version_gpgrt): New.
	(show_versions_via_dirmngr): New.
	(show_versions): New.
	* tools/gpgconf-comp.c (GPGNAME): Remove unused macro.
	* dirmngr/dirmngr.c (main): New internal option --gpgconf-versions.
	(get_revision_from_blurb): New.
	(gpgconf_versions): New.

	w32: Silence warning due to recent change of split_fields.
	+ commit 371228a244232f2b74181e0aa3c44d698df840ce
	* common/compliance.c (gnupg_rng_is_compliant): Make fields const.

	gpg: Fix parameter parsing form ed448.
	+ commit e824e27d36021a868c855244d22c7d40a88a396e
	* g10/keygen.c (parse_key_parameter_part): Set algo also for 448.

2020-10-01  Andre Heinecke  <aheinecke@gnupg.org>

	doc: Remove enable-extended-key-format in vsnfd.
	+ commit d84862cf109c75ae30ed5e2531b4554083c6a558
	* doc/examples/vsnfd.prf: Remove enable-extended-key-format

2020-09-30  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Internal CCID driver: More fix for SPR532.
	+ commit 920f258eb6018ecec1d63bad6a0fb0772f72affa
	* scd/ccid-driver.c (bulk_in): Handle the case of missing intr_cb.

	scd: Report any error for LEARN command.
	+ commit 862d9c6face9b4ad61f6e59bf1ba9b5f5d05c58c
	* scd/app-openpgp.c (do_learn_status): Report any error.

2020-09-29  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Internal CCID driver fix.
	+ commit 1444203ca32ccfa4bd5097d2d49565c4055c620b
	* scd/ccid-driver.c (intr_cb): More useful debug output.
	(ccid_slot_status): Remove redundant condition.

	scd: Internal CCID driver: Call libusb_clear_halt at ccid_setup_intr.
	+ commit 6af978713e4c69d7814f47e709f1dfb3fe9076d1
	* scd/ccid-driver.c (ccid_setup_intr): Reset the endpoint.
	(ccid_vendor_specific_init): Don't call libusb_clear_halt.

2020-09-28  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Internal CCID driver: Fix a failure path.
	+ commit d561c936a217627bc29aac628a8d01f7003dcd28
	* scd/ccid-driver.c (ccid_open_usb_reader): On error, call
	libusb_release_interface.

	scd: Internal CCID: Handle LIBUSB_ERROR_TIMEOUT at ccid_get_atr.
	+ commit b1e8072320c19246962beb6d67dc5784b5a72364
	* scd/ccid-driver.c (ccid_slot_status): Handle LIBUSB_ERROR_TIMEOUT.

	scd: Internal CCID: Clear the handle after use.
	+ commit c5e8ef3ab980012b64f5894f437e2ff568b02f43
	* scd/apdu.c (close_ccid_reader): Clear the handle.
	(open_ccid_reader): Likewise.

	scd: Change handling of SPR532 card reader.
	+ commit 684a52dffa8b7f79b26fe53b3ab10d7748a8fb37
	* scd/ccid-driver.c (ccid_vendor_specific_init): Put some workaround
	for SPR532 initialization.
	(ccid_slot_status): Send ESCape command after GetSlotStatus.

2020-09-25  Werner Koch  <wk@gnupg.org>

	keyboxd: Make use of the config table.
	+ commit f8fbd9e7346ee0c3b09271ec2cdb589282eae1c9
	* kbx/backend-sqlite.c (DATABASE_VERSION): New.
	(table_definitions): Make column name of table config unique.
	(create_or_open_database): Read and set the database version.
	(get_config_value, set_config_value): New.

2020-09-25  NIIBE Yutaka  <gniibe@fsij.org>

	scd: For PC/SC, send the ESC command at init for SPR532 reader.
	+ commit 93e3c97889120dd17d79b7c8dd04293553785c9b
	* scd/apdu.c (struct reader_table_s): Remove is_spr532.
	(pcsc_vendor_specific_init): Send the ESC command for SPR532.
	(pcsc_pinpad_verify, pcsc_pinpad_modify): Remove no_lc hack.

	scd: For SPR532, submit the ESCape command at initialization.
	+ commit 4fae55f8ee11b3f710524e5e8b8a91b159949f2d
	* scd/ccid-driver.c (ccid_vendor_specific_init): Submit the ESC
	command for VENDOR_SCM.
	(ccid_transceive_secure): Don't submit the ESC command every time.

2020-09-24  Werner Koch  <wk@gnupg.org>

	gpg: New experimental import option "bulk-import"
	+ commit d49a945b12d98fadd0d37f4e50b5e02799e16305
	* g10/options.h (IMPORT_BULK): New.
	* g10/import.c (parse_import_options): Add "bulk-import".
	* g10/call-keyboxd.c (in_transaction): New var.
	(gpg_keyboxd_deinit_session_data): Run a commit if in bulk import
	mode.
	(create_new_context): Run a begin transaction if in bulk import mode.

	keyboxd: New command TRANSACTION.
	+ commit c2b14f5d6852fb9efaca8aeec7961e9d036203e8
	* kbx/backend-sqlite.c (be_sqlite_rollback): New.
	(be_sqlite_commit): New.
	(be_sqlite_search): Take care of global transactions.
	(be_sqlite_store): Ditto.
	(be_sqlite_delete): Ditto.
	* kbx/frontend.c (kbxd_rollback, kbxd_commit): New.
	* kbx/keyboxd.h (opt): Add vars for transactions.
	* kbx/kbxserver.c (struct server_local_s): Add fields next_session and
	client_pid.
	(session_list): New var.
	(cmd_transaction): New.
	(register_commands): Register command.
	(kbxd_start_command_handler): Store pids and track sessions.  Do a
	final rollback.

	tests: Integrate --use-keyboxd into the OpenPGP test suite.
	+ commit b19a60c6f7e892635db9e22499a7a44087c86c41
	* tests/openpgp/all-tests.scm (all-tests): Replace extended-key-format
	mode with a new keyboxd mode.
	* tests/openpgp/defs.scm (create-gpghome): Ditto.
	* tests/openpgp/gpgv.scm: Adjust for keyboxd mode.
	* tests/openpgp/issue2419.scm: Fix to allow setting a log-file into
	gpg.conf for debugging.

	keyboxd: Implement multiple search descriptions.
	+ commit 25ad3c22d79d06c16a5fc652b0a6e3ffd99ad2b6
	* kbx/kbx-client-util.c (kbx_client_data_simple): New.
	* kbx/backend-sqlite.c (struct be_sqlite_local_s): Add field descidx.
	(be_sqlite_search): Use that.
	* g10/call-keyboxd.c (keydb_search): Implement multi mode.

	keyboxd: Fix UDPATE keyblob SQL statement.
	+ commit 1f89d50537b3b16165e921df60734ce6203650cb
	* kbx/backend-sqlite.c: Always use ?NNN for SQL parameters.

	tests: Fix convenience function to run gpg.
	+ commit 97798eec4b77470b3aecdbee9729fa76b8550dfe
	* tests/openpgp/defs.scm (pipe:gpg): Remove stray dash.

	keyboxd: Remove unused variables.
	+ commit 0ac003b4576392ca3e930304a98bbf8183ab5f8b
	* kbx/kbx-client-util.c (datastream_thread): No need to set PK_NO and
	UID_NO.

	keyboxd: Integrate into gpgconf.
	+ commit acaeba2dbdb9bbd68a823c671d5c3577fef5d26d
	* common/asshelp.c (lock_spawning): Use a dedicated name for keyboxd.
	* common/homedir.c (keyboxd_socket_name): New.
	(gnupg_module_name): Put keyboxd into libexecdir.
	* tools/gpgconf-comp.c (known_options_keyboxd): New.
	(gc_component): Add entry for keyboxd.
	(keyboxd_runtime_change): New.
	(gc_component_launch): Support keyboxd.
	* tools/gpgconf.c (list_dirs): Emit new item keyboxd-socket.
	(main): Also remove keyboxd socket.

2020-09-24  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix CCID internal driver for interrupt transfer.
	+ commit 7cbb513a2dc150a90a30c53316970df2a439d494
	* scd/ccid-driver.c (intr_cb): Handle the case of multiple messages.

2020-09-22  Werner Koch  <wk@gnupg.org>

	gpg: Set the found-by flags in the keyblock in keyboxd mode.
	+ commit 183509756179fadd95d1cc740047b94dc16bb279
	* g10/keydb-private.h (struct keydb_handle_s): Add fields to return
	the ordinals of the last found blob.
	* g10/call-keyboxd.c (keydb_get_keyblock): Pass them to the keyblock
	parser.

	sm: Fix returning of the ephemeral flag in keyboxd mode.
	+ commit b810320b1bf76209dc1087cb91ca34232d9268c3
	* sm/keydb.c (search_status_cb): Skip over the ubid.

	common: Fix name of keyboxd.
	+ commit c81a7b09368a474de4e3572fbb527d1597408ab1
	* common/homedir.c (gnupg_module_name): Fix name.

	keyboxd: Extend PUBKEY_INFO status line with an uid ordinal.
	+ commit 0e892bda4e0bf9db9116d7d5585d4e7b0d2eae57
	* kbx/backend-sqlite.c (table_definitions): Add column UINO to
	userids.
	(be_sqlite_local_s): Add fields select_col_uidno and
	select_col_subkey.
	(run_select_statement): Also select subkey or uidno column.
	(be_sqlite_search): Return their values.
	(store_into_userid): Store the UIDNO.
	* kbx/backend-support.c (be_return_pubkey): Extend PUBKEY_INFO.

	kbx: Add bounds check to detect corrupt keyboxes.
	+ commit e0a312bfd646485ae8a0ae5e26720fc1667c5490
	* kbx/keybox-dump.c (_keybox_dump_blob): Fix the fixmes.

2020-09-21  Werner Koch  <wk@gnupg.org>

	scd: Extend KEYPAIRINFO with an algorithm string.
	+ commit 26da47ae53d51e16ae6867cd419ddbf124a94933
	* scd/app-openpgp.c (send_keypair_info): Emit the algo string as part
	of a KEYPAIRINFO.
	* scd/command.c (do_readkey): Ditto.
	* scd/app-piv.c (do_readkey): Ditto.
	* scd/app-nks.c (do_learn_status_core): Ditto.
	(struct fid_cache_s): Add field algostr.
	(flush_fid_cache): Release it.
	(keygripstr_from_pk_file): Fill it and add it to the cache.  Use a
	single exit label.
	* scd/app-help.c (app_help_get_keygrip_string_pk): Add new arg
	r_algostr.  Change all callers.

	sm: Implement delete key in keyboxd mode.
	+ commit c772770574ea2d337f8745ff304b1b8acd8a2e4c
	* sm/keydb.c (keydb_delete): Implement keyboxd mode.
	(keydb_update_cert): Disable unused function.
	* kbx/backend-sqlite.c (be_sqlite_delete): Delete from issuer.

2020-09-18  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix regression for access through the extra secket.
	+ commit 8a84a71f3a58a3e943f238b70743cd6408477eba
	* agent/command.c (cmd_keyinfo): Allow KEYINFO command for one key.
	(cmd_scd): Allow SCD command to invoke GETINFO, GETATTR, and
	KEYINFO --list=encr sub commands.

	common,agent,dirmngr,g10,tools: Fix split_fields API.
	+ commit dfdcf14738976c6b236f4fa1c3b68af351024b3c
	* common/stringhelp.h (split_fields): Use const * for the strings in
	the ARRAY.
	(split_fields_colon): Likewise.
	* common/stringhelp.c (split_fields, split_fields_colon): Fix
	the implementation.
	* agent/call-scd.c, agent/command.c: Follow the change.
	* common/t-stringhelp.c, dirmngr/loadswdb.c: Likewise.
	* g10/call-agent.c, tools/card-call-scd.c: Likewise.
	* tools/card-yubikey.c, tools/gpg-card.c: Likewise.
	* tools/gpg-card.h, tools/gpg-wks-client.c: Likewise.
	* tools/gpgconf-comp.c, tools/gpgconf.c: Likewise.
	* tools/wks-util.c: Likewise.

2020-09-16  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Clear PIN cache when changing key attributes.
	+ commit 8ff36630277f05fbe4e43c7d757eb90da8645e3f
	* scd/app-openpgp.c (change_keyattr): Clear all PINs.

	scd: Clear caching PIN at KDF setup.
	+ commit f4c07fc3d3c32e96d4306f6daa60b6de7fba7dc5
	* scd/app-openpgp.c (do_setattr): Clear PINs.

	scd: Add better support for KDF feature.
	+ commit 316a8cbc7523560d999e46eb524165db11682210
	* scd/app-openpgp.c (do_setattr): Handle kdf-seup "off" for Gnuk.

	gpg,scd: Fix handling of KDF feature.
	+ commit 8dfd0ebfd8cf2b6bcecbd91c8f7fad6db583aa5a
	* g10/card-util.c (kdf_setup): Fix the default value.
	* scd/app-openpgp.c (do_setattr): Support kdf-setup "off" by
	Zeitcontrol.  Make sure Gnuk and Yubikey work well.

2020-09-15  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix the use case of verify_chv2 by CHECKPIN.
	+ commit 6e51f2044aebb885ea81dae259db1b7f477b1c44
	* scd/app-openpgp.c (verify_chv2): Call verify_a_chv with chvno=1
	when needed.

2020-09-11  Werner Koch  <wk@gnupg.org>

	scd:piv: Avoid conflict when writing a cert.
	+ commit fbc1b199fdc8fd9a4ab422f005b4eb521b594c5c
	* scd/app-piv.c (map_curve_name_to_oid): New.
	(my_cmp_public_key): New.
	(do_writecert): Replace simple memcmp by cmp_canon_sexp.

	common: New function cmp_canon_sexp.
	+ commit b6ba6a79ce9336f1b53f16f3d1190dd009fb166e
	* common/sexputil.c (cmp_canon_sexp): New.
	(cmp_canon_sexp_def_tcmp): New.
	* common/t-sexputil.c (test_cmp_canon_sexp): Add a simple test.

	keyboxd: Implement lookup by short and long keyid.
	+ commit 9a94db1f662a1c5973b57b25e25aeab1bc33250e
	* kbx/backend-sqlite.c: Change definition of column KID.
	(kid_from_mem): Remove.
	(kid_from_u32): Rewrite.
	(run_sql_bind_int64): Remove.
	(run_select_statement): Implement lookup by short keyid.  Fix lookup
	by long keyid.
	(store_into_fingerprint): Adjust kid arg.

	keyboxd: Add ephemeral and revoked flag to the sqlite backend.
	+ commit 616c60d93dfab27dde00e1489c6c51340ec93b6c
	* kbx/backend-support.c (be_return_pubkey): Add args is_ephemeral and
	is_revoked.  Adjust callers.
	* kbx/backend-sqlite.c: Alter table pubkey to add new columns.
	(run_select_statement): Add new column to all selects.
	(be_sqlite_search): Return the new flags.

2020-09-10  Andre Heinecke  <aheinecke@gnupg.org>

	doc: Update and extend module overview.
	+ commit d62797ebcc15ffac52664fe08759d18a92491ddc
	* doc/gnupg-module-overview.svg: Add examples of GPGME aware
	applications

2020-09-10  Werner Koch  <wk@gnupg.org>

	sm: Implement initial support for keyboxd.
	+ commit ed6ebb696e4063dc664d7ee74fc492025881c459
	* sm/gpgsm.h (MAX_FINGERPRINT_LEN): New.
	* sm/keydb.c (struct keydb_local_s): Change definition of
	search_result.
	(keydb_get_cert): Implement keyboxd mode.
	(keydb_get_flags): Temporary hack for keyboxd mode.  Needs to be
	fixed.
	(struct store_parm_s, store_inq_cb): New.
	(keydb_insert_cert): Implement keyboxd mode.
	(keydb_locate_writable): Make static.
	(keydb_search_reset): Implement keyboxd mode.
	(search_status_cb): New.
	(keydb_search): Implement keyboxd mode. Replace return code -1 by
	GPG_ERR_NOT_FOUND.
	(keydb_set_cert_flags): Replace return code -1 by GPG_ERR_NOT_FOUND.
	* sm/keylist.c (list_cert_colon): Adjust for replacement of -1 by
	GPG_ERR_NOT_FOUND.
	(list_internal_keys): Ditto.
	* sm/sign.c (add_certificate_list): Ditto.
	* sm/certchain.c (find_up_search_by_keyid): Ditto.
	(find_up_external, find_up, find_up_dirmngr): Ditto.
	(gpgsm_walk_cert_chain): Ditto.
	(get_regtp_ca_info): Ditto.
	* sm/certlist.c (gpgsm_add_to_certlist): Ditto.
	(gpgsm_find_cert): Ditto.
	* sm/delete.c (delete_one): Ditto.
	* sm/export.c (gpgsm_export): Ditto.
	(gpgsm_p12_export): Ditto.
	* sm/import.c (gpgsm_import_files): Ditto.

	keyboxd: Add basic support for X.509.
	+ commit c9677d416e6ff190c589af35b514a01a787085fb
	* kbx/keybox-blob.c (x509_email_kludge): Rename to ...
	(_keybox_x509_email_kludge): this and make global.
	* kbx/backend.h: Include ksba.h.
	* kbx/backend-support.c (be_get_x509_serial): New.
	(be_get_x509_keygrip): New.
	* kbx/backend-sqlite.c (table_definitions): New table 'issuers'.
	(run_select_statement): Implements modes ISSUER, ISSUER_SN, SUBJECT.
	(store_into_userid): Add arg override_mbox.
	(store_into_issuer): New.
	(be_sqlite_store): Implement x509 part.

	keyboxd: Use D-lines instead of a separate thread.
	+ commit 6fcc263c182fc49d9ba2d1bd7649b4af1e9f3e3a
	* kbx/kbx-client-util.c (kbx_client_data_new): Add arg 'dlines'.
	* g10/call-keyboxd.c (open_context): Set DLINES to true.
	* sm/keydb.c (open_context): Ditto.

	keyboxd: Add options --openpgp and --x509 to SEARCH.
	+ commit 29977e21d18188e16e50fee95a95e05fdbd97caf
	* kbx/keyboxd.h (struct server_control_s): Replace the two request
	objects by just one.  Add filter flags.
	* kbx/kbxserver.c (cmd_search): Add options --openpgp and --x509.
	(cmd_killkeyboxd): Do not return GPG_ERR_EOF.
	* kbx/frontend.c (kbxd_release_session_info): Adjust for the new
	request object.
	(kbxd_search, kbxd_store, kbxd_delete): Ditto.
	* kbx/backend-sqlite.c (struct be_sqlite_local_s): Add filter flags.
	(run_sql_prepare): Add optional arg 'extra'.  Change callers.
	(run_sql_bind_ntext): New.
	(run_sql_bind_text): Just call run_sql_bind_ntext.
	(run_select_statement): Add ctrl arg.  Implement the filter flags.

	* g10/call-keyboxd.c (keydb_search): Use the --openpgp option.

	gpg-connect-agent: Catch signals so that SIGPIPE is ignored.
	+ commit 3cf9bb4d73cfe78d3d48734e7c8a65d9a98112a5
	* dirmngr/server.c (cmd_killdirmngr): Return 0.
	* tools/gpg-connect-agent.c (main): Catch signals.

	dirmngr: Fix the pool keyserver case for a single host in the pool.
	+ commit 5a87011c46b5b01659c3cbc3c7a04da94ae5ca9e
	* dirmngr/ks-engine-hkp.c (map_host): Set R_HOSTNAME also for
	localhost and if there is no pool.

	dirmngr: Align the gnutls use of CAs with the ntbtls code.
	+ commit faabc49797df43c4904b6230f83e8c6677e88b22
	* dirmngr/http.c (http_session_new) <gnutls>: Use only the special
	pool certificate for the default keyserver.

2020-09-10  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Flush KDF DO (0x00F9) when it's being set.
	+ commit d4cb774ddd8830836c9c87a90db01f749ac8d67c
	* scd/app-openpgp.c (do_setattr): Call flush_cache_item always.

2020-09-09  Werner Koch  <wk@gnupg.org>

	agent: Keep some permissions of private-keys-v1.d.
	+ commit 8ed85ef3de9cdeee86e281a8b46be1bd49a36e7a
	* common/sysutils.c (modestr_to_mode): Re-implement.
	(gnupg_chmod): Support keeping of permissions.

	kbx: Change X.509 S/N search definition.
	+ commit adec6a84f6ee176764391da358ae150f92b1f1e4
	* kbx/keybox-search-desc.h (struct keydb_search_desc): Do not overload
	SNLLEN with a hex flag.  Add SNHEX.
	* kbx/keybox-search.c (keybox_search): Adjust.
	* common/userids.c (classify_user_id): Adjust.
	* sm/keydb.c (keydb_search_desc_dump): Adjust.
	* g10/keydb.c (keydb_search_desc_dump): Adjust.

2020-09-08  NIIBE Yutaka  <gniibe@fsij.org>

	gpg,tools: Add handling of supported algorithms by a card.
	+ commit 2bc1ec294422504e2d2e5d20716aba68f1c2b0d7
	* g10/call-agent.h (struct agent_card_info_s): Add supported_keyalgo.
	* g10/call-agent.c (learn_status_cb): Parse KEY-ATTR-INFO.
	(agent_release_card_info): Release supported_keyalgo.
	* tools/gpg-card.h (struct card_info_s): Add supported_keyalgo.
	* tools/card-call-scd.c (learn_status_cb): Parse KEY-ATTR-INFO.
	(release_card_info): Release supported_keyalgo.

	scd: Add a workaround for Yubikey.
	+ commit 0db9c83555b4a8a0c52f96e96ec20dbfd3d75272
	* scd/app-openpgp.c (get_public_key): Handle wrong code for Yubikey.

2020-09-07  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix handling 0x00FA to support OpenPGP card 3.4.
	+ commit 270c49b8c6eaf99df7b417f9d0e45eba0acfb423
	* scd/app-openpgp.c (data_objects): It may be longer.

2020-09-04  Werner Koch  <wk@gnupg.org>

	gpg: Initialize a parameter to silence valgrind.
	+ commit 65eb1569809a3c42e8afb064f6194fac2e34a03a
	* g10/keygen.c (read_parameter_file): Initialize nline.
	* g10/textfilter.c (copy_clearsig_text): Initialize bufsize.

2020-09-04  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Support GET DATA response with no header for DO 0x00FA.
	+ commit 43bbc25b0f57dec24412886ff46041e0b1f3de26
	* scd/app-openpgp.c (do_getattr): Support Gnuk, as well.

	scd: Parse "Algorithm Information" data object in scdaemon.
	+ commit eba2563dabbb4f61537900289fbe3ae113904733
	* scd/app-openpgp.c (data_objects): 0x00FA for binary data.
	(do_getattr): Parse the data and send it in status lines.
	(get_algorithm_attribute_string): New.

2020-09-03  Werner Koch  <wk@gnupg.org>

	sm: New options to prepare the use of keyboxd.
	+ commit 046f419f806036248c058c4bd44368f8596287b7
	* sm/Makefile.am (AM_CFLAGS): Add npth flags.
	(common_libs): Use npth version of the lib.
	(gpgsm_LDADD): Add npth libs.
	* sm/gpgsm.c (oUseKeyboxd, oKeyboxdProgram): New.
	(opts): New options --use-keyboxd and --keyboxd-program.
	(main): Set them.
	(gpgsm_deinit_default_ctrl): New.
	(main): Call it.
	* sm/server.c (gpgsm_server): Ditto.
	* sm/gpgsm.h (opt): Add fields use_keyboxd and keyboxd_program.
	(keydb_local_s): New type.
	(struct server_control_s): Add field keybd_local.
	* sm/keydb.c: Include assuan.h, asshelp.h, and kbx-client-util.h.
	(struct keydb_local_s): New.
	(struct keydb_handle): Add fields for keyboxd use.
	(gpgsm_keydb_deinit_session_data): New.
	(warn_version_mismatch): New.
	(create_new_context): New.
	(open_context): New.
	(keydb_new): Implement keyboxd mode.
	(keydb_release): Ditto.
	(keydb_get_resource_name): Ditto.

	* sm/keydb.c: Add stub support for all other functions.

	sm: Add arg ctrl to keydb_new.
	+ commit a7d006293ec84532cc1972cd2f990198eadf1a1a
	* sm/keydb.c (keydb_new): Add arg and change all callers.

2020-09-03  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Add handling of "Algorithm Information" DO.
	+ commit 90d0072165cc5c6888f14462392a211de0c4b232
	* cd/app-openpgp.c (data_objects): Add 0x00FA.
	(do_getattr): Add KEY-ATTR-INFO.

2020-09-02  Werner Koch  <wk@gnupg.org>

	gpg: Fix segv importing certain keys.
	+ commit 8ec9573e57866dda5efb4677d4454161517484bc
	* g10/key-check.c (key_check_all_keysigs): Initialize issuer.

	keyboxd: Restructure client access code.
	+ commit 497db0b5bcd688c4e2144ba167bd2ac485069d1b
	* kbx/kbx-client-util.c: New.
	* kbx/kbx-client-util.h: New.
	* kbx/Makefile.am (client_sources): New.
	* g10/keydb.c (parse_keyblock_image): Rename to keydb_parse_keyblock
	and make global.
	* g10/call-keyboxd.c: Include kbx-client-util.h.
	(struct keyboxd_local_s): Remove struct datastream.  Add field kcd.
	Remove per_session_init_done.
	(lock_datastream, unlock_datastream): Remove.
	(prepare_data_pipe, datastream_thread): Remove.
	(keydb_get_keyblock_do_parse): Remove.
	(gpg_keyboxd_deinit_session_data): Release the KCD object.
	(open_context): Use of kbx_client_data_new.
	(keydb_get_keyblock): Simplify.
	(keydb_search): Use kbx_client_data_cmd and _wait.

	keyboxd: Fix user id based queries.
	+ commit 4d839f5a8083e1ddd4767c838f56a4079f846c6d
	* kbx/backend-sqlite.c (run_select_statement): Add the missing join
	for user id bases queries.

	common: New helper function gnupg_close_pipe.
	+ commit 2042f5a4641f4e43137b7683077b4d733d216417
	* common/exechelp-posix.c (gnupg_close_pipe): New.
	* common/exechelp-w32.c (gnupg_close_pipe): New.

2020-09-01  Werner Koch  <wk@gnupg.org>

	Use only one copy of the warn_server_mismatch function.
	+ commit 2cd8bae23d7382588cf096df3eed83e02331a2bf
	* common/asshelp.c (warn_server_version_mismatch): New.  Actually a
	slightly modified version of warn_version_mismatch found in other
	modules.
	* common/status.c (gnupg_status_strings): New.
	* g10/cpr.c (write_status_strings2): New.
	* g10/call-agent.c (warn_version_mismatch): Use the new unified
	warn_server_version_mismatch function.
	* g10/call-dirmngr.c (warn_version_mismatch): Ditto.
	* g10/call-keyboxd.c (warn_version_mismatch): Ditto.
	* sm/call-agent.c (warn_version_mismatch): Ditto.
	* sm/call-dirmngr.c (warn_version_mismatch): Ditto.
	* tools/card-call-scd.c (warn_version_mismatch): Ditto.

2020-08-28  Werner Koch  <wk@gnupg.org>

	sm: Fix a bug in the rfc2253 parser.
	+ commit 16c1d8a14e98894408f30349cab68ff17ef6b35e
	* sm/certdump.c (parse_dn_part): Fix parser flaw.

2020-08-28  NIIBE Yutaka  <gniibe@fsij.org>

	common: Fix fallback handling to utf-8.
	+ commit 393dcdd61c3b2da00a97176c647d9bd1c908ceba
	* common/utf8conv.c (handle_iconv_error): Set NO_TRANSLATION.

2020-08-27  Werner Koch  <wk@gnupg.org>

	scd: New option to APDU command to return the ATR as data.
	+ commit a0a4744bd0640e587b33ec3dae819ec4054f0472
	* scd/command.c (cmd_apdu): Add new option --data-atr.
	* tools/gpg-card.c (cmd_apdu): Use that here.  Also fix the --exlen
	option and do not print the statusword in atr mode.
	* tools/card-call-scd.c (scd_apdu): Detect atr mode anddon't assume a
	status word.

	scd: Fix reading of the ATR for card type detection.
	+ commit 95b5a852e269e602ade6a07ed468e9072c247b8c
	* scd/app.c (app_new_register): Do not use apdu_get_slot.

	dirmngr: Print the last alert message returned by NTBTLS.
	+ commit 05358d73841149f64dc5d620f4b8855255e7f4da
	* dirmngr/http.c (send_request): Print the last TLS alert.

2020-08-27  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Add heuristics to identify cardtype.
	+ commit 9f148360a2bf04672b43ef7cec48e21d44b06ae1
	* scd/app-common.h (cardtype_t): Add CARDTYPE_GNUK and
	CARDTYPE_ZEITCONTROL.
	* scd/app.c (strcardtype): Handle CARDTYPE_GNUK and
	CARDTYPE_ZEITCONTROL.
	(app_new_register): Detect Gnuk and Zeit Control implementation
	by examining its ATR string.

	scd: Add condition for VERIFY with 0x82.
	+ commit af189be481df02a77e088aa0a60a1fc02dfa12bf
	* scd/app-openpgp.c (verify_chv2): Check availability of keys in
	question.

2020-08-26  Werner Koch  <wk@gnupg.org>

	build: Silence gcc warning -Wformat-zero-length.
	+ commit 90a87d96eaf5b97cd53cb0ee0495b646be7b84bb
	* configure.ac: Avoid useless gcc warning.  We use an empty string
	quite often, for example in log_printhex.

2020-08-25  Werner Koch  <wk@gnupg.org>

	gpg: Remove left over debug output from recent change.
	+ commit fc1a1857551c05135d54e2e620e609fda59d5bca
	* g10/import.c (collapse_subkeys): Remove debug out.

	examples: Simplify vsnfd.prf.
	+ commit 40acc5ef3ef73494e67d88ea310503e5bf08bc36
	* doc/examples/vsnfd.prf: Remove default-new-key-algo option.

	sm: Do not require a default keyring for --gpgconf-list.
	+ commit e7677da479c4fb5abd0339de807b27c0f487d2e0
	* sm/gpgsm.c (main): No default keyring for gpgconf mode.

	gpgconf: Silence warnings from parsing the options files.
	+ commit ad1254b59d41e127879fc9f495d392316135b4a5
	* tools/gpgconf-comp.c (retrieve_options_from_program): Set verbose
	flag for the arg parser only in --verbose mode.

	agent: Allow using --gogconf-list even if HOME does not exist.
	+ commit b17846e4fd02f65b24ada306855fb110c56c5e73
	* agent/gpg-agent.c (main): Do not create directories in gpgconf mode.

	gpgconf,w32: New debug command --show-codepages.
	+ commit 32021dfa5bcaa056c18e4ec40fdcd0f8b7de382b
	* tools/gpgconf.c (aShowCodepages): New.
	(opts): New command --show-codepages.
	(main) [W32]: Implement

	gpg: Collapse duplicate subkeys.
	+ commit 633c1fea5f0dc4cb270c22ee41c24e1ec0706204
	* g10/options.h (IMPORT_COLLAPSE_UIDS): New.
	(IMPORT_COLLAPSE_SUBKEYS): New.
	* g10/gpg.c (main): Make them the default.
	* g10/import.c (parse_import_options): New import options
	"no-collapse-uids" and "no-collapse_subkeys".
	(collapse_subkeys): New.
	(import_one_real): Collapse subkeys and allow disabling the collapsing
	using the new options.
	(read_key_from_file_or_buffer): Always collapse subkeys.
	* g10/keyedit.c (fix_keyblock): Call collapse_subkeys.

2020-08-21  Werner Koch  <wk@gnupg.org>

	gpgtar,w32: Handle Unicode file names.
	+ commit 34e7703a962809921e83770f20f3eb66599265d1
	* tools/gpgtar.c (oUtf8Strings): New.
	(opts): Add option --utf8-strings.
	(parse_arguments): Set option.
	* tools/gpgtar.h (opt): Add field utf8strings.
	* tools/gpgtar-create.c (name_to_utf8): New.
	(fillup_entry_w32): Use that.
	(scan_directory): Ditto.
	(scan_directory) [W32]: Convert file name to utf8.
	(gpgtar_create): Convert pattern.

	common: Use gpgrt functions for mkdir and chdir.
	+ commit eec70e539e44c288068f26f190d52a5718fd3a10
	* common/sysutils.c (gnupg_mkdir): Divert to gpgrt_mkdir.
	(gnupg_chdir): Divert to gpgrt_chdir

	common,w32: Do not assume the ANSI code during string conversion.
	+ commit 5305ce17ff7a68ecc88c5ae8c4bec5897df6322f
	* common/utf8conv.c (get_w32_codepage): New.
	(wchar_to_native): Use instead oc CP_ACP.
	(native_to_wchar): Ditto.

	common: Strip trailing CR,LF from w32_strerror.
	+ commit 33fd55ca6f3efc50c260469179788e9f725ddc58
	* common/stringhelp.c (w32_strerror): Strip trailing CR,LF.
	* common/iobuf.c (iobuf_get_filelength): Use -1 and not 0 for the
	arg to w32_strerror.

2020-08-20  Werner Koch  <wk@gnupg.org>

	gpgtar: Make --files-from and --null work as described.
	+ commit e276f63e4a80e8d1cb1ba5621cedaeb0ccda956d
	* tools/gpgtar-create.c (gpgtar_create): Add args files_from and
	null_names.  Improve reading from a file.
	* tools/gpgtar.c: Make global vars static.
	(main): Remove tests for --files-from and --null option combinations.
	Pass option variables to gpgtar_create.

	build: New configure option --disable-tests.
	+ commit 32aac55875f324f8c3d85dad8483604eae65e3e8
	* configure.ac: Add option --disable-tests.  Print warnings in the
	summary.
	(DISABLE_TESTS): New am_conditional.

	gpg: Fix regression for non-default --passphrase-repeat option.
	+ commit b8c4dd902df34faa4d23efb2bb4ac222c8bbdbdb
	* agent/command.c (cmd_get_passphrase): Take care of --repeat with
	--newsymkey.

2020-08-19  Werner Koch  <wk@gnupg.org>

	gpg,gpgsm: Record the creation time of a private key.
	+ commit 4031c42bfd0135874a5b362df175de93a19f1b51
	* sm/call-agent.c (gpgsm_agent_genkey): Pass --timestamp option.
	(gpgsm_agent_import_key): Ditto.
	* g10/call-agent.c (agent_genkey): Add arg timestamp and pass it on.
	(agent_import_key): Ditto.
	* g10/import.c (transfer_secret_keys): Pass the creation date to the
	agent.
	* g10/keygen.c (common_gen): Ditto.

2020-08-19  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix condition of string_to_aead_algo.
	+ commit 1d66b518ca83e8d315283682b1e504f1e171a0b1
	* g10/misc.c (string_to_aead_algo): Only compare if not NULL.

	dns: Fix memory use-after-free.
	+ commit cc0d53905ce9306b51bace2682ae3d1d122c7881
	* dirmngr/dns.c (dns_res_stub): Fix RESCONF usage.

	common: Fix iobuf.c.
	+ commit f58d441bee7e93e6344f833acc1412b3be2f6818
	* common/iobuf.c (iobuf_cancel): Initialize DUMMY.
	(do_iobuf_fdopen): Initialize LEN.
	(iobuf_read_line): Fix the loop condition.

	Silence compiler warnings.
	+ commit f3e424d4e7273e60e69747ca4936149af7b6482a
	* common/openpgp-oid.c (map_openpgp_pk_to_gcry): Use cast for enum
	conversion.
	* dirmngr/dns-stuff.c (get_dns_srv): Use explicit conversion from
	int to float.
	* sm/gpgsm.c (parse_keyserver_line): Initialize ERR.

	scd: Fix possible uninitialized variables.
	+ commit 4fa0a65676a29cb53ee242caf13c393f7573c9a3
	* scd/app-openpgp.c (do_change_pin): Initialize resultlen2.
	(do_change_pin): Don't call wipe_and_free on the error path.
	Initialize bufferlen2.

2020-08-17  Werner Koch  <wk@gnupg.org>

	agent: Allow to pass a timestamp to genkey and import.
	+ commit 0da923a1240ac78d60c92cdd8488c4e405c3243b
	* agent/command.c (cmd_genkey): Add option --timestamp.
	(cmd_import_key): Ditto.
	* agent/genkey.c (store_key): Add arg timestamp and change callers.
	(agent_genkey): Ditto.
	* agent/findkey.c (write_extended_private_key): Add args timestamp and
	new key to write a Created line.
	(agent_write_private_key): Add arg timestamp.
	(agent_write_shadow_key): Ditto.
	 agent/protect-tool.c (agent_write_private_key): Ditto as dummy arg.

2020-08-14  Werner Koch  <wk@gnupg.org>

	Add --chuid to gpg, gpg-card, and gpg-connect-agent.
	+ commit 6bcb609e1b2a507caa2e1a078178709d808b590b
	* g10/gpg.c (oChUid): New.
	(opts): Add --chuid.
	(main): Implement --chuid.  Delay setting of homedir until the new
	chuid is done.
	* sm/gpgsm.c (main): Delay setting of homedir until the new chuid is
	done.
	* tools/gpg-card.c (oChUid): New.
	(opts): Add --chuid.
	(changeuser): New helper var.
	(main): Implement --chuid.
	* tools/gpg-connect-agent.c (oChUid): New.
	(opts): Add --chuid.
	(main): Implement --chuid.

2020-08-13  Werner Koch  <wk@gnupg.org>

	gpg: Ignore personal_digest_prefs for ECDSA keys.
	+ commit 53d84f98157070f24dc861f1a75980474d074ddb
	* g10/sign.c (hash_for): Simplify hash algo selection for ECDSA.

2020-08-12  Werner Koch  <wk@gnupg.org>

	scd: Log info about CCIDs with permission problems.
	+ commit 2af884c64354182b1903d7a77df07e877f5ed7ba
	* scd/apdu.c (open_ccid_reader): Add arg r_cciderr.
	(apdu_open_reader): Print a note on EPERM of the USB device.

	scd: Map some error codes from libusb to ccid-driver error codes.
	+ commit 9a8d7e41bba1926158a21ebdda542241493ef983
	* scd/ccid-driver.h (CCID_DRIVER_ERR_USB_*): New error codes.
	* scd/apdu.h: New SW_HOST error codes.
	* scd/apdu.c (host_sw_string): Print them
	* scd/ccid-driver.c (map_libusb_error): New.
	(ccid_open_usb_reader, bulk_in, abort_cmd): Map libusb error codes.
	* scd/iso7816.c (map_sw): Map new codes to gpg-error.

	common: Pass the WAYLAND_DISPLAY envvar along.
	+ commit 3944430ffeaa032719fd82f8eaa118b3f326b8ed
	* common/session-env.c (stdenvnames): Add WAYLAND_DISPLAY.

2020-08-10  Werner Koch  <wk@gnupg.org>

	scd:piv: Allow signing using PSS.
	+ commit cbf203801e021e0f4d4143ecc92296ae7d0f0dd7
	* scd/app-piv.c (do_sign): Allow for PSS.

	agent: Add option --pss to pksign to be used by smartcards.
	+ commit bb096905b9ee1f5175efee1ab6c98045a26a2678
	* agent/command.c (cmd_sethash): Add option --pss and allow for
	--hash=null.
	* agent/agent.h (struct server_control_s): Add digest.is_pss and
	zero where needed.
	* agent/pksign.c (agent_pksign_do): Allow for PSS with cards.
	* scd/command.c (cmd_pksign): Add for --hash=none.

2020-08-07  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix trustdb for v5key.
	+ commit 373c975859a55f942276d6078f27ee33570bf2d5
	* g10/keydb.h (fpr20_from_pk): New.
	* g10/keyid.c (fpr20_from_pk): New.
	* g10/tdbio.c (tdbio_search_trust_byfpr): Use fpr20_from_pk.
	* g10/trustdb.c (keyid_from_fpr20): New.
	(verify_own_keys): Use keyid_from_fpr20.
	(tdb_update_ownertrust): Use fpr20_from_pk.
	(update_min_ownertrust): Likewise.
	(update_validity): Likewise.

	gpg: Fix short key ID for v5key.
	+ commit 20982bbd7539d2032f4d6249a2654c245445521d
	* g10/keyid.c (keyid_from_pk): Return keyid[0] for v5key.
	* g10/keyring.c (keyring_search): Handle short key ID for v5key.

2020-08-06  Werner Koch  <wk@gnupg.org>

	gpgsm: New option --chuid.
	+ commit 646a30fd394a739ef653556b1a7b2eeebda95951
	* sm/gpgsm.c (oChUid, opts): New option --chuid.
	(main): Implement option.

	gpgconf: New option --chuid.
	+ commit d10f45184c4482036c41f4818c84c0725a0c2c94
	* tools/gpgconf.c (oChUid, opts): New option --chuid.
	(main): Implement.

	common: New helper function gnupg_chuid.
	+ commit 8ff00ef0de871ca43076b00df4871c3165ced001
	* common/sysutils.c (try_set_envvar): New.
	(gnupg_chuid): New.

2020-08-06  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Support v5key for short kid and long kid.
	+ commit df531848a9618131921d584baba81c128f94de68
	* kbx/keybox-search.c (has_short_kid): Support v5key.
	(has_long_kid): Likewise.

2020-08-05  Werner Koch  <wk@gnupg.org>

	gpg: Add level 16 to --gen-random.
	+ commit d847f0651ab4304129145b55353501636b4e4728
	* g10/gpg.c (main): Add that hack.

2020-08-04  Werner Koch  <wk@gnupg.org>

	sm: Also show the SHA-256 fingerprint.
	+ commit e7d70923901eeb6a2c26445aee9db7e78f6f7f3a
	* sm/keylist.c (list_cert_colon): Emit a new "fp2" record.
	(list_cert_raw): Print the SHA2 fingerprint.
	(list_cert_std): Ditto.

2020-08-03  NIIBE Yutaka  <gniibe@fsij.org>

	w32: Fix cast from intptr_t of _get_osfhandle.
	+ commit 8e04cf969e95ccaa31bbaa7333938af1ea7476c6
	* common/exectool.c (gnupg_exec_tool_stream): Cast to unsigned long.

2020-07-31  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix coercion for pinentry_pid handling.
	+ commit da3a4c54a8ce8a7dc442c70bda9b7eda22d43e57
	* agent/call-pinentry.c (start_pinentry): Don't use pid_t.

	scd: Silence compiler warning.
	+ commit 2a34a2afea5fcb5f4ed206afa110650db3dd7ef0
	* scd/app-openpgp.c (build_ecc_privkey_template): Fix allocation size.

2020-07-30  NIIBE Yutaka  <gniibe@fsij.org>

	w32: Add NETLIBS for sm/t-minip12.
	+ commit c1f81eb9fc2544a417ebc2ce19b04541525da684
	* sm/Makefile.am (t_minip12_LDADD): Add NETLIBS.

	w32: More adding NETLIBS.
	+ commit 5fa4427419c875e46d051ae6ed376d5ad6037401
	* common/Makefile.am (t_common_ldadd): Add $(NETLIBS).

	w32: Add link to $(NETLIB) for -lws2_32.
	+ commit d69f5570ee5e1b099e39fdf64e18add23ff5c815
	* dirmngr/Makefile.am (dirmngr_LDADD): Add $(NETLIBS).
	* sm/Makefile.am (gpgsm_LDADD): Ditto.
	* tools/Makefile.am (gpg_wks_client_LDADD): Ditto.

2020-07-27  NIIBE Yutaka  <gniibe@fsij.org>

	kbx: Fix short KID and long KID handling for FPR32.
	+ commit fa4a2bd7a1ba8d4bda5f9cec0826104f50142d4f
	* kbx/keybox-search.c (blob_cmp_fpr_part): For FPR32, it's
	the first part in the fingerprint.

2020-07-17  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix closing reader and reeleasing context in PC/SC.
	+ commit daa2cec6a543f06a2e408d97a80a5041027f16a9
	* scd/apdu.c (close_pcsc_reader): Unlock the reader_table_lock.
	(apdu_dev_list_finish): Release the context when no readers.

	Use gpgrt's new option parser for symcryptrun.
	+ commit f484ac2b2d2ea176db1a70d961a778180147d9b2
	* tools/symcryptrun.c: Follow API change of the new option parser.

	scd: PC/SC: Don't release the context when it's in use.
	+ commit 46d185f60397f68830bfdfb99627b29aea5016f1
	* scd/apdu.c (close_pcsc_reader): Check if it's not in the loop.

	gpg-card: Fix type of historyname.
	+ commit 43000b0434b47a72608b41d67054ba42db21b699
	* tools/gpg-card.c (interactive_loop): Remove const qualifier.

2020-07-16  Werner Koch  <wk@gnupg.org>

	gpg: Do not close stdout after --export-ssh-key.
	+ commit 5c514a274ca8ac6be875818237e2e1bbc0c6a2a5
	* g10/export.c (export_ssh_key): Do not close stdout.

2020-07-16  NIIBE Yutaka  <gniibe@fsij.org>

	common: Avoid undefined behavior of left shift operator.
	+ commit 8abf065307ff4a7ea873fe59f76173bf17dac241
	* common/iobuf.c (block_filter): Handle an error earlier.
	Make sure it's unsigned.

2020-07-15  NIIBE Yutaka  <gniibe@fsij.org>

	regexp: Import change from JimTcl.
	+ commit 91cb46d948db234be1ea8092f5db9e14294f1b79
	* regexp/jimregexp.h, regexp/jimregexp.c: Fix from JimTcl.

2020-07-14  Werner Koch  <wk@gnupg.org>

	agent: Fix regression with --newsymkey in loopback mode.
	+ commit 0a6af6dc12998ef7b19673ad05d11e82f826de9d
	* agent/command.c (cmd_get_passphrase): Never repeat in loopback mode;
	same as with !OPT_NEWSYMKEY.

2020-07-13  NIIBE Yutaka  <gniibe@fsij.org>

	dirmngr: Handle EAFNOSUPPORT at connect_server.
	+ commit 109d16e8f644da97ed9c00e6f9010a53097f587a
	* dirmngr/http.c (connect_server): Skip server with EAFNOSUPPORT.

2020-07-10  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: For decryption, support use of a key with no 'encrypt' usage.
	+ commit 31ae0718ba10c3b1b670ba6131b4995de24aa7a1
	* g10/pubkey-enc.c (get_session_key): Don't skip at no PUBKEY_USAGE_ENC.
	Emit information the key has no 'encrypt' usage.

2020-07-08  Werner Koch  <wk@gnupg.org>

	Do not use the pinentry's qualitybar.
	+ commit 999d25d47d45a0f594c84d51c041da0b24d68c5d
	* agent/genkey.c (agent_ask_new_passphrase): No qualitybar.
	* g10/call-agent.c (agent_get_passphrase): Ditto.
	* sm/call-agent.c (gpgsm_agent_ask_passphrase): Ditto.

	gpg: Use integrated passphrase repeat entry also for -c.
	+ commit a6a4bbf6debd925a23c22eea86a562f061fdfe6c
	* g10/call-agent.c (agent_get_passphrase): Add arg newsymkey.
	* g10/passphrase.c (passphrase_get): Add arg newsymkey.
	(passphrase_to_dek): Pass it on.

	agent: New option --newsymkey for GET_PASSPHRASE.
	+ commit eace4bbe1ded8b01f9ad52ebc1871f2fd13c3a08
	* agent/call-pinentry.c (agent_get_passphrase): Add arg pininfo.
	* agent/genkey.c (check_passphrase_constraints): New arg no_empty.
	* agent/command.c (reenter_passphrase_cmp_cb): New.
	(cmd_get_passphrase): Add option --newsymkey.

2020-07-07  Werner Koch  <wk@gnupg.org>

	gpg: Fix flaw in symmetric algorithm selection in mixed mode.
	+ commit 6864bba78e76a1ff72aec140ae9f4e752454c463
	* g10/encrypt.c (setup_symkey): Use default_cipher_algo function
	instead of the fallback s2k_cipher_algo.  Fix error code.
	(encrypt_simple): Use setup_symkey.

2020-07-03  Werner Koch  <wk@gnupg.org>

	sm: Exclude rsaPSS from de-vs compliance mode.
	+ commit 969abcf40cdfc65f3ee859c5e62889e1a8ccde91
	* common/compliance.h (PK_ALGO_FLAG_RSAPSS): New.
	* common/compliance.c (gnupg_pk_is_compliant): Add arg alog_flags and
	test rsaPSS.  Adjust all callers.
	(gnupg_pk_is_allowed): Ditto.
	* sm/misc.c (gpgsm_ksba_cms_get_sig_val): New wrapper function.
	(gpgsm_get_hash_algo_from_sigval): New.
	* sm/certcheck.c (gpgsm_check_cms_signature): Change type of sigval
	arg.  Add arg pkalgoflags.  Use the PK_ALGO_FLAG_RSAPSS.
	* sm/verify.c (gpgsm_verify): Use the new wrapper and new fucntion to
	also get the algo flags.  Pass algo flags along.

2020-07-02  Werner Koch  <wk@gnupg.org>

	scd:nks: Implement writecert for the Signature card v2.
	+ commit c1663c690b29d2dea8bc782c42de5eca08a24cc9
	* scd/iso7816.c (CMD_UPDATE_BINARY): New.
	(iso7816_update_binary): New.
	* scd/app-nks.c (do_deinit): Factor some code out to...
	(flush_fid_cache): new.
	(do_writecert): New.
	(app_select_nks): Register new handler.

	dirmngr: Silence annoying warning for missing default ldap server file.
	+ commit f55a05a69ba07eb2ed354a9275e71e94c5e362aa
	* dirmngr/dirmngr.c (parse_ldapserver_file): Add arg ignore_enoent.
	(main): Use that arg for the default file.

	Support a history file in gpg-card and gpg-connect-agent.
	+ commit d70b8769c888f42896ae3ef4972bf82e9b5a0c32
	* common/gpgrlhelp.c (read_write_history): New.
	(gnupg_rl_initialize): Register new function.
	* common/ttyio.c (my_rl_rw_history): New var.
	(tty_private_set_rl_hooks): Add arg read_write_history.
	(tty_read_history): New.
	(tty_write_history): New.
	* tools/gpg-card.c (HISTORYNAME): New.
	(oNoHistory): New enum value.
	(opts): New option --no-history.
	(cmd_history): New.
	(cmds): New command "history".
	(interactive_loop): Read and save the history.
	* tools/gpg-connect-agent.c (HISTORYNAME): New.
	(opts): New option --no-history.
	(main): Read and save the history.  New command /history.

2020-06-30  Werner Koch  <wk@gnupg.org>

	scd:nks: Fix certificate read problem with TCOS signature card v2.
	+ commit 07aef873ebc77241e9a2be225537319f6fc15a41
	* scd/app-nks.c (filelist): Add a dedicated key entry for ESIGN.
	(do_readcert): Test for the app_id.

	scd: Change how the removed card flag is set.
	+ commit 58b091df831f61c8d3551114f2480d36e73de2da
	* scd/command.c (cmd_serialno): Set/clear card removed flags for all
	connections using the current card.

	card: Better detect removed cards.  Add TCOS PIN menu.
	+ commit fb10b6cba43f4ed8675093ac25f461de4dacdce9
	* tools/card-call-scd.c (scd_change_pin): Add arg 'nullpin'.
	* tools/gpg-card.h (struct card_info_s): Add field 'card_removed'.
	* tools/gpg-card.c (fixup_scd_errors): New.
	(maybe_set_card_removed): New.
	(list_one_kinfo): Change type of first arg to get access to INFO.  Set
	card_removed flag.
	(list_all_kinfo): Improve label alignment.
	(cmd_list): Check that the current card is still available.
	(cmd_passwd): Add option --nullpin and menu to chnage TCOS PINs.
	(dispatch_command): Handle card_removed flag.
	(interactive_loop): Ditto.

2020-06-30  NIIBE Yutaka  <gniibe@fsij.org>

	ecc: Support Ed448/X448 key generation.
	+ commit 45398518fb76e2b859d2d48cf4cdbc11fbbda4fa
	* g10/keygen.c (ask_curve): Support Ed448/X448 keys.
	(generate_keypair): Support switch to X448 key.

2020-06-29  Werner Koch  <wk@gnupg.org>

	scd: Shorten cardio debug output for all zeroes.
	+ commit 9b6f574928546e6905a92c3e74d72478f1585c66
	* scd/apdu.c (all_zero_p): New.
	(send_le): Use it.

	sm: Fix regression in Friday's commit.
	+ commit 4f1c257c03667497d642930884b65c4f2245adbd
	* sm/gpgsm.c (main): Set ERR also for encrypt.

2020-06-26  Werner Koch  <wk@gnupg.org>

	sm: Try not to output a partial new message after an error.
	+ commit ccbb0cfeefed096a9841b6557d10eef12d55b721
	* sm/gpgsm.c (main) <aSign,aEncr>:  Uses gpgrt_fcancel on error.

	sm: Print the serial number of a cert also in decimal.
	+ commit 208a90197317fb9746ecf54a1d14acbeeddfbd18
	* sm/certdump.c: Include membuf.h.
	(gpgsm_print_serial_decimal): New.
	* sm/keylist.c (list_cert_raw): Print s/n also in decimal
	(list_cert_std): Ditto.

2020-06-25  Werner Koch  <wk@gnupg.org>

	scd:nks: Fix remaining tries warning in --reset mode.
	+ commit 2429e8559844e27de478d7e90834a714b3748834
	* scd/app-nks.c (do_change_pin): Chnage computaion of 'remaining'.

	card: Add  password change menu for NKS cards.
	+ commit 28c069db3bb5a1065de69bcc0435c8415df87e5b
	* tools/gpg-card.c (cmd_passwd): Add menu for NKS.  Add option
	--reset.

	sm: Fix support verification of nistp521 signatures.
	+ commit 17a25c14f1ed1199898ad618c17204eafd5524c1
	* sm/certcheck.c (do_encode_md): Fix obvious bug.

2020-06-24  James Bottomley  <James.Bottomley@HansenPartnership.com>
	    Werner Koch  <wk@gnupg.org>

	agent: separate out daemon handling infrastructure for reuse.
	+ commit f541e1d95a91d4764c7ed0df10c293bfd493dd41
	* agent/call-scd.c: Factor re-usable code out to ...
	* agent/call-daemon.c: new.  Store infos in an array to allow for
	other backend daemons.
	* agent/Makefile.am (gpg_agent_SOURCES): Add new file.
	* agent/agent.h: Include assuan.h.
	(enum daemon_type): New.
	(opt): Replace scdaemon_program by daemon_program array.  Replace
	scd_local by a array d_local.  Change users accordingly.

2020-06-24  Werner Koch  <wk@gnupg.org>

	gpgconf: Fix regression in --launch and --kill from March.
	+ commit 2d8f060679bafed27909a5ad54b7f74a9f8dd51b
	* tools/gpgconf.h (gc_component_id_t): Align order with gc_component
	array.

2020-06-24  NIIBE Yutaka  <gniibe@fsij.org>

	gpg,agent: Support Ed448 signing.
	+ commit a763bb2580b0d586a80b8ccd3654f41e49604f4f
	* agent/pksign.c (do_encode_eddsa): First argument is NBITs,
	so that it can support Ed448, as well as Ed25519.
	(agent_pksign_do): Follow the change.
	* agent/sexp-secret.c (fixup_when_ecc_private_key): No fix-up needed
	for Ed448, it's only for classic curves.
	* common/openpgp-oid.c (oidtable): Add Ed448.
	* common/sexputil.c (get_pk_algo_from_key): Ed448 is only for EdDSA.
	* g10/export.c (match_curve_skey_pk): Ed448 is for EdDSA.
	* g10/keygen.c (gen_ecc): Support Ed448 with the name of "ed448".
	(ask_algo, parse_key_parameter_part): Handle "ed448".
	* g10/pkglue.c (pk_verify): Support Ed448.
	(pk_check_secret_key): Support Ed448.
	* g10/sign.c (hash_for): Defaults to SHA512 for Ed448.
	(make_keysig_packet): Likewise.

2020-06-23  NIIBE Yutaka  <gniibe@fsij.org>

	ecc: Use "cv448" to specify key using X448.
	+ commit c94eea15d6847c08d2d9ff1c7608953f25fea67d
	* common/openpgp-oid.c (oidtable): Use "cv448".
	(oid_cv448): Rename from oid_x448.
	(openpgp_oidbuf_is_cv448, openpgp_oid_is_cv448): Likewise.
	* common/util.h (openpgp_oid_is_cv448): Follow the change.
	* g10/ecdh.c (pk_ecdh_generate_ephemeral_key): Likewise.
	* g10/keygen.c (gen_ecc, ask_algo): Use "cv448".
	(parse_key_parameter_part): Likewise.
	* g10/pkglue.c (get_data_from_sexp): Fix for debug output.

2020-06-19  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Use get_pk_algo_from_key.
	+ commit 4bdade5b0bea1816a2479c73abc71b41f09ba727
	* agent/findkey.c (key_parms_from_sexp, is_eddsa): Remove.
	(agent_pk_get_algo): Remove.
	* agent/pksign.c (agent_pksign_do): Use get_pk_algo_from_key.

	agent: Clean up for getting info from SEXP.
	+ commit d2e4aa5ee4c5128547cc45c2e1ac35fdc5c00f45
	* agent/agent.h (agent_is_dsa_key, agent_is_eddsa_key): Remove.
	(agent_pk_get_algo): New.
	* agent/findkey.c (agent_pk_get_algo): New.
	* agent/pksign.c (do_encode_dsa): Use generic GCRY_PK_ECC.
	(agent_pksign_do): Use agent_pk_get_algo.

	agent: A little clean up.
	+ commit abc6a3100a33122ba3673b578a2b364a6b45d252
	* agent/findkey.c (agent_is_eddsa_key): Remove dead case.

2020-06-17  Werner Koch  <wk@gnupg.org>

	agent: Fix regression in 'd' fixup code for shadowed keys.
	+ commit d1e1c622d55e783ae5bf601249598f0da8d5e688
	* agent/sexp-secret.c (fixup_when_ecc_private_key): Ignore shadowed
	keys.

	sm: Support verification of nistp521 signatures.
	+ commit 596212e71abf33b30608348b782c093dace83110
	* sm/certcheck.c (do_encode_md): Take care of nistp521.

2020-06-09  Werner Koch  <wk@gnupg.org>

	gpg: Fix for new SOS changes when used with Libgcrypt < 1.8.6.
	+ commit eeb599c9e261586a664430058b7cfad7025a503f
	* g10/free-packet.c (is_mpi_copy_broken): New.
	(my_mpi_copy): Mix gcry_mpi_copy.

	gpg: Extend the TRUST_ status lines.
	+ commit 96f1ed5468002330ea21d9ad32ac3b464bb40b1a
	* g10/pkclist.c (write_trust_status): Add arg mbox.
	(check_signatures_trust): Appenmd mbox to the status lines.

2020-06-09  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Use bytes for ECDH.
	+ commit da5e0bc31b4c6f16ed5ff9b35063f3b03eb7ff16
	* g10/ecdh.c (extract_secret_x): Use byte * instead of MPI.
	(prepare_ecdh_with_shared_point): Use char * instead of MPI.
	(pk_ecdh_encrypt_with_shared_point): Likewise.
	(pk_ecdh_decrypt): Likewise.
	* g10/pkglue.h (pk_ecdh_encrypt_with_shared_point, pk_ecdh_decrypt):
	Change declaration.
	* g10/pkglue.c (get_data_from_sexp): New.
	(pk_encrypt): Use get_data_from_sexp instead of get_mpi_from_sexp.
	Follow the change of pk_ecdh_encrypt_with_shared_point.
	* g10/pubkey-enc.c (get_it): Follow the change of pk_ecdh_decrypt.

	gpg: Add X448 support.
	+ commit e9760eb9e70b9804c988dafe01851f6600869d9e
	* common/openpgp-oid.c (oidtable): Add X448.
	(oid_x448,openpgp_oidbuf_is_x448,openpgp_oid_is_x448): New.
	* common/util.h (openpgp_oid_is_x448): New.
	* g10/ecdh.c (gen_k): Add handling of opaque MPI and support
	endianness.
	(pk_ecdh_generate_ephemeral_key): X448 requires opaque MPI.
	* g10/keygen.c (gen_ecc): Add support for X448.
	(ask_algo, parse_key_parameter_part): Likewise.

	gpg,ecc: Handle external representation as SOS with opaque MPI.
	+ commit f5bc94555458123f93d8b07816a68fb7485421e1
	* g10/pkglue.h (sexp_extract_param_sos): New.
	* g10/build-packet.c (sos_write): New.
	(do_key, do_pubkey_enc, do_signature): Use sos_write for ECC.
	* g10/export.c (cleartext_secret_key_to_openpgp): Use
	sexp_extract_param_sos.
	(transfer_format_to_openpgp): Use opaque MPI for ECC.
	* g10/keygen.c (ecckey_from_sexp): Use sexp_extract_param_sos.
	* g10/keyid.c (hash_public_key): Handle opaque MPI for SOS.
	* g10/parse-packet.c (sos_read): New.
	(parse_pubkeyenc,parse_signature,parse_key): Use sos_read for ECC.
	* g10/pkglue.c (sexp_extract_param_sos): New.
	(pk_verify): Handle opaque MPI for SOS.
	(pk_encrypt): Use sexp_extract_param_sos.
	* g10/seskey.c (encode_session_key): Use opaque MPI.
	* g10/sign.c (do_sign): Use sexp_extract_param_sos.

2020-06-08  Werner Koch  <wk@gnupg.org>

	gpg: If possible TRUST values now depend on signer's UID or --sender.
	+ commit 5c2080f4670a768787f5cb4ed5c32e0946837883
	* g10/mainproc.c (check_sig_and_print): Add failsafe check for PK.
	Pass KEYBLOCK down do check_signatures_trust.  Protect existsing error
	ocde in case the signature expired.
	* g10/pkclist.c (is_in_sender_list): New.
	(check_signatures_trust): Add args keyblock and pk.  Add new uid based
	checking code.
	* g10/test-stubs.c, g10/gpgv.c: Adjust stubs.

2020-06-08  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix the condition to detect leading 0x00 problem.
	+ commit e2e5736842299ebfb8263b674d5cbfb9b784d70f
	* agent/sexp-secret.c (fixup_when_ecc_private_key): Use curve name
	to identify the issue.

2020-06-05  NIIBE Yutaka  <gniibe@fsij.org>

	agent,ecc: Use of opaque MPI for ECC, fixup 'd'.
	+ commit 47c1c329ed823a562185f86e98ac903605104f11
	* agent/Makefile.am: Add sexp-secret.c.
	* agent/agent.h: New function declarations.
	* agent/sexp-secret.c: New.
	* agent/findkey.c (agent_key_from_file): Use sexp_sscan_private_key.
	* agent/protect-tool.c (read_and_unprotect): Fix up private part,
	calling fixup_when_ecc_private_key.

	agent: For ECC, use opaque MPI for key representation.
	+ commit 2b118516240b4bddd34c68c23a99bea56682a509
	* agent/cvt-openpgp.c (scan_pgp_format): New with SOS support.
	(do_unprotect): Use scan_pgp_format, handle opaque MPI for ECC.
	(convert_from_openpgp_main): Use opaque MPI for ECC.
	(apply_protection): Set GCRYMPI_FLAG_USER1 flag for encrypted secret.
	(extract_private_key): Use "/qd" for ECC, opaque MPI.

	agent,ssh: Tighten condition for EdDSA.
	+ commit a7d46c78e242e72f6ff681f6fe56ffc4dcb74a18
	* agent/command-ssh.c (ssh_key_to_blob): Prepare for non-prefixed
	point representation of EdDSA.

	agent: Remove duplicated code for EdDSA.
	+ commit 2e988546c59ba25bf9e63521112c0c3c73b012f1
	* agent/command-ssh.c (ssh_receive_key): Curve is "Ed25519".
	Use sexp_key_construct always.

	agent: Clean up do_encode_md.
	+ commit 4c0b12f817f15862111a01493aaadce943410ee9
	* agent/pksign.c (do_encode_md): Directly use sexp_build.

2020-06-03  Werner Koch  <wk@gnupg.org>

	doc: Minor enhancement for reproducibility.
	+ commit 074ab108e768b2f946d789c1f3a7f14a65e07c52
	* doc/Makefile.am (defsincdate): In no repo mode and with
	SOURCE_DATE_EPOCH set, use that instead of blanking the date.

	card: Improve openpgp key writing in "writecert".
	+ commit 4f6e0e12cbd3444b9e6ea5e4b92ea5b3072a3e17
	* tools/card-keys.c (struct export_key_status_parm_s): New.
	(export_key_status_cb): New.
	(get_minimal_openpgp_key): New.
	* tools/gpg-card.c (cmd_writecert): Allow writing a keyblock directly
	from an existing gpg key.

	gpg: Improve generation of keys stored on card (brainpool,cv25519).
	+ commit 48251cf9a7d3776667342f4705ac3de89bd75534
	* g10/keygen.c (ask_key_flags_with_mask): Allow more than ECDH for
	legacy curves.
	(ask_algo): Tweak mapping of ECC to OpenPGP algos
	(parse_key_parameter_part): Ditto.
	(generate_subkeypair): Create the subkey with the time stored on the
	card.

	sm: Fix recently introduced regression in CSR creation.
	+ commit 7558128e16d7fc20b9c40bf7e150ca08bbb4467f
	* sm/certreqgen.c (create_request): Also set SIGKEYLEN.

2020-05-29  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix condition for C5 data object for newer Yubikey.
	+ commit f3df8dbb696fed192501fa7f741c2e0e0936a3d5
	* scd/app-openpgp.c (compare_fingerprint): Relax the condition.

2020-05-28  Werner Koch  <wk@gnupg.org>

	card: Allow to store and retrieve keyblocks in OpenPGP cards.
	+ commit 2d9592e78f4978307e378e07d6c170a28000a494
	* tools/gpg-card.c: Include tlv.h.
	(cmd_writecert): Add option --openpgp.
	(cmd_readcert): Ditto.

	card: New command "apdu"
	+ commit ed0759f39be04dd6108237f5ed03c7cfd1cb4642
	* tools/card-call-scd.c (scd_apdu): Add optional arg 'options'.
	* tools/gpg-card.c (cmd_apdu): New.
	(enum cmdids): Add cmdAPDU.
	(dispatch_command): Add command "apdu".
	(interactive_loop): Ditto.

2020-05-27  Werner Koch  <wk@gnupg.org>

	card: Update card info after "generate".
	+ commit 94d31660c6db22c3b539f440994d286f687c273f
	* tools/gpg-card.c (cmd_generate): Re-read the card on success.

	scd:openpgp: New KEY-STATUS attribute.
	+ commit 21496761226c1020a98e3ec7dd2b9dd013d4386b
	* scd/app-openpgp.c (do_getattr): Return KEY-STATUS

	card: Add command "bye"
	+ commit 08310849a28071fbca761fa4ca18702b39092947
	* tools/gpg-card.c: Add command "bye" as alias for "quit".
	* tools/gpg-connect-agent.c (main): Add "/quit" as alias for "/bye"

	card: Take care of removed and re-inserted cards.
	+ commit 46a3de4b5acb37274ddd132499a3243e1f92b506
	* tools/gpg-card.c (cmd_list): Take care of the need_sn_cmd flag.
	(cmd_factoryreset): Clear that flag.
	(dispatch_command): Set flag after a reset and after a
	CARD_NOT_PRESENT error.

2020-05-26  Werner Koch  <wk@gnupg.org>

	card: Implement UID command and print capabilities.
	+ commit c2a47475ba0f6bd1de80e92dd91949501256025e
	* tools/card-call-scd.c (learn_status_cb): Return the full value for
	UIF.  Add info about SM, MCL3, and PD.
	* tools/gpg-card.h (struct card_info_s): Add corresponding fields.
	* tools/gpg-card.c (list_openpgp): Print capabilities.  Print the
	permanent flag for UIF.
	(cmd_uif): Implement.

	scd:openpgp: Add attribute "UIF" for convenience.
	+ commit 11f0700282c1eeaee8db6686c38aca0900271351
	* scd/app-openpgp.c (do_getattr): New attrubute "UIF".
	(do_learn_status): Use that.

	scd: Fix Yubikey app switching problem.
	+ commit 20090886706e2af6723ca11e292272fc00cffe07
	* scd/app.c (select_all_additional_applications_internal): Re-select
	first app.  Add arg 'ctrl'.

2020-05-22  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Clean up ECDH code path (5).
	+ commit 510bda7d3754801be18a592694578589fe503fb8
	* g10/ecdh.c (pk_ecdh_encrypt_with_shared_point): Now, it's only for
	encrytion.
	(pk_ecdh_decrypt): Use prepare_ecdh_with_shared_point and move decrypt
	code path in original pk_ecdh_encrypt_with_shared_point here.
	* g10/pkglue.h (pk_ecdh_encrypt_with_shared_point): Change API.
	* g10/pkglue.c (pk_encrypt): Follow the change.

	gpg: Clean up ECDH code path (4).
	+ commit 64d93271bfce1968ebe61324b900875dbd6dd2eb
	* g10/ecdh.c (prepare_ecdh_with_shared_point): New.
	(pk_ecdh_encrypt_with_shared_point): Fixing error paths for closing
	the cipher handle, use prepare_ecdh_with_shared_point.

	gpg: Clean up ECDH code path (3).
	+ commit 80c02d13d9994abae9e67c3554528352c621cd9b
	* g10/ecdh.c (derive_kek): New.
	(pk_ecdh_encrypt_with_shared_point): Use derive_kek.

	gpg: Clean up ECDH code path (2).
	+ commit a973d9113840282468015eb26f07f2b32f977d70
	* g10/ecdh.c (build_kdf_params): New.
	(pk_ecdh_encrypt_with_shared_point): Use build_kdf_params, and check
	things before extract_secret_x.

	gpg: Clean up ECDH code path (1).
	+ commit 960d37644cbbe2a234352d0bc58095e2b0371eec
	* g10/ecdh.c (extract_secret_x): New.
	(pk_ecdh_encrypt_with_shared_point): Use extract_secret_x.

2020-05-20  NIIBE Yutaka  <gniibe@fsij.org>

	dirmngr: dns: Fix allocation of string buffer in stack.
	+ commit 30eef28bc0f5deaa1b4b7f04293a6527524280a9
	* dirmngr/dns.h (dns_strsection, dns_strclass)
	(dns_strtype): Change APIs.
	* dirmngr/dns.c (dns_p_lines): Use __dst for dns_strsection.
	(dns_rr_print): Use __dst for dns_strclass and dns_strtype.
	(dns_trace_dump): Likewise.
	(dns_ai_print): Use __dst for dns_strtype.
	(dns_strsection): Add an argument __dst for storage.
	(dns_strclass, dns_strtype): Likewise.
	(parse_packet): Use __dst for dns_strsection.
	(send_query): Use __dst for dns_strtype.
	(isection): Use __dst for dns_strsection.
	(iclass): Use __dst for dns_strclass.
	(itype): Use __dst for dns_strtype.

2020-05-19  Werner Koch  <wk@gnupg.org>

	sm: Create ECC certificates with AKI and SKI by default.
	+ commit 44676819f2873705b78849e7b2fd22214b691642
	* sm/certreqgen.c (create_request): Create AKI and SKI by default.

	common: New function to extract Q from an ECC key.
	+ commit 3cd9dac7e0976643c6e4b6537cf363b2b12d422f
	* common/sexputil.c (get_ecc_q_from_canon_sexp): New.

2020-05-18  Werner Koch  <wk@gnupg.org>

	sm: Support creation of EdDSA certificates.
	+ commit 6dc3846d78192e393be73c16c72750734a9174d1
	* sm/misc.c (transform_sigval): Support EdDSA.
	* sm/certreqgen.c (create_request): Support EdDSA cert creation.
	* sm/certcheck.c (gpgsm_check_cert_sig): Map some ECC algo OIDs to
	hash algos.
	* sm/call-agent.c (struct sethash_inq_parm_s): New.
	(sethash_inq_cb): New.
	(gpgsm_agent_pksign): Add mode to pass plain data for EdDSA.

	agent: Allow to use SETHASH for arbitrary data.
	+ commit b18fb0264abdb6cb0a99ba0ba941dc9a6e35f74a
	* agent/agent.h (struct server_control_s): Add field digest.data.
	* agent/gpg-agent.c (agent_deinit_default_ctrl): Free that field.
	* agent/command.c (reset_notify): Ditto.
	(start_command_handler): ditto.
	(cmd_sethash): Add new option --inquire.
	* agent/call-scd.c (agent_card_pksign): For now return an error if
	inquire mode was used.
	* agent/command-ssh.c (ssh_handler_sign_request): Make sure
	digest.data is cleared.
	* agent/divert-scd.c (divert_pksign): Implement inquire mode.
	* agent/pksign.c (agent_pksign_do): Ditto.

2020-05-13  Werner Koch  <wk@gnupg.org>

	sm: Support import and verification of EdDSA certificates.
	+ commit b1694987bb6484405d41d34046a5290176feadd0
	* sm/certdump.c (gpgsm_get_serial): New.
	* sm/certcheck.c (gpgsm_check_cert_sig): Support EdDSA signatures.

2020-05-11  Werner Koch  <wk@gnupg.org>

	sm: Support signing using ECDSA.
	+ commit f44d395bdfec464b1e2a0a1aef39561e6e48a45c
	* sm/gpgsm.h (struct certlist_s): Add helper field pk_algo.
	* sm/sign.c (gpgsm_sign): Store the public key algo.  Take the hash
	algo from the curve.  Improve diagnostic output in verbose mode.

2020-05-08  Werner Koch  <wk@gnupg.org>

	sm: Allow decryption using dhSinglePass-stdDH-sha1kdf-scheme.
	+ commit 68b857df13c8a4e6cae5e3a29fd065bf90764547
	* sm/decrypt.c (ecdh_decrypt): Support
	dhSinglePass-stdDH-sha1kdf-scheme.  Factor key derive code out to ...
	(ecdh_derive_kek): new global function.  Allow for hashs shorter than
	the key.
	(hash_ecc_cms_shared_info): Make file-only.
	* sm/encrypt.c (ecdh_encrypt): Replace derive code by a call to the
	new ecdh_derive_kek.  Add test code to create data using
	dhSinglePass-stdDH-sha1kdf-scheme.
	* sm/gpgsm.h (opt): Add member force_ecdh_sha1kdf.
	* sm/gpgsm.c: Add option --debug-force-ecdh-sha1kdf.

	sm: Print algorithm infos in data decryption mode.
	+ commit 439c9b5cb55044f13d4af6563f4e791093d510b0
	* common/sexputil.c (cipher_mode_to_string): New.
	* sm/decrypt.c (prepare_decryption): Show cipher algo and mode.
	(gpgsm_decrypt): Show key algo and fingerprint

	sm: Cleanup the use of GCRY_PK_ECC and GCRY_PK_ECDSA.
	+ commit 34b628db4618a8712536aea695f934b0286e7b18
	* common/sexputil.c (pubkey_algo_to_string): New.
	* sm/certcheck.c (do_encode_md): Replace GCRY_PK_ECDSA by GCRY_PK_ECC.
	* sm/certreqgen-ui.c (check_keygrip): Add all ECC algorithms.
	* sm/gpgsm.c (our_pk_test_algo): Also allow EdDSA.
	* sm/verify.c (gpgsm_verify): Map ECC algo to ECDSA.  Use new pubkey
	algo name function

	sm: Improve readability of the data verification output.
	+ commit a759fa963a42e0652134130029217270b6d5d00b
	* sm/verify.c (gpgsm_verify): Print the used algorithms.

2020-05-07  Werner Koch  <wk@gnupg.org>

	card: Allow listing of NKS cards.
	+ commit 94966347452632f8140fae70f7fcbadcc2b81071
	* tools/card-call-scd.c (learn_status_cb): Always fill chvinfo.
	* tools/gpg-card.h (struct card_info_s): Increase size of chvinfo and
	chvmaxlen.
	* tools/gpg-card.c (list_nks): New.
	(print_a_version): Support single part version numbers.
	(list_card): Call list_nks.

	scd:nks: Add framework to support IDKey cards.
	+ commit 1f6a39092fe4b5f02bc4741a0a23d102d30f4063
	* scd/app-nks.c (NKS_APP_IDLM): New.
	(struct app_local_s): Replace NKS_VERSION by the global APPVERSION.
	(do_learn_status): Always send CHV-STATUS.
	(find_fid_by_keyref): Basic support for IDLM only use.
	(do_learn_status_core): Ditto.
	(do_readcert): Ditto.
	(verify_pin): Ditto.
	(parse_pwidstr): Ditto.
	(do_with_keygrip): Ditto.
	(switch_application): Ditto.
	(app_select_nks): Fallback to IDLM.

	scd:nks: Get the PIN prompts right for the Signature Card.
	+ commit aecc008acb64ebbb6c667c4a128af4e61da57f84
	* scd/app-nks.c (get_dispserialno): Move more to the top.
	(do_getattr): Add $DISPSERIALNO and SERIALNO.  Make CHV-STATUS work
	with NKS15.
	(verify_pin): Use dedicated min. PIN lengths.
	(parse_pwidstr): Support NKS15

	sm: Print the key types as standard key algorithm strings.
	+ commit 5c29d25e6c7c0a5a63ab4c46d4624217307adb78
	* sm/fingerprint.c (gpgsm_get_key_algo_info): Factor code out to ...
	(gpgsm_get_key_algo_info2): new.
	(gpgsm_pubkey_algo_string): New.
	* sm/keylist.c (list_cert_colon): Put curve into field 17
	(list_cert_raw): Print the unified key algotithm string instead of the
	algo and size.
	(list_cert_std): Ditto.

	scd:nks: Support decryption using ECDH.
	+ commit af45d884aa1c3eccbc6972a2e5197ece3fd1987a
	* scd/app-nks.c (struct fid_cache_s): Add field 'algo'.
	(keygripstr_from_pk_file): Add arg 'r_algo' to return the algo.
	(find_fid_by_keyref): Ditto.
	(get_dispserialno): New.
	(make_prompt): New.
	(verify_pin): Provide better prompts.
	(do_decipher): Support ECDH.
	(parse_pwidstr): Add hack tospecify any pwid..
	(do_change_pin): Support Signature Card V2.0 (NKS15) style NullPIN.
	Provide a better prompt.

	sm: Support decryption of ECDH data using a smartcard.
	+ commit ee6d29f1797e06977ae3d2edae9edc1165c6f144
	* sm/decrypt.c (ecdh_decrypt): Add arg nbits and detect bare secret.
	(prepare_decryption): Add arg nbits and pass on.
	(gpgsm_decrypt): Pass size of curve to prepare_decryption.

2020-05-05  Werner Koch  <wk@gnupg.org>

	scd: Extend an internal function to also return the algo.
	+ commit 314859d7e7de5010ca1e9d90b83acf3bc8493631
	* scd/app-help.c (app_help_get_keygrip_string_pk): Add optional arg
	r_algo.  Change all callers.
	(app_help_get_keygrip_string): Ditto.

2020-05-04  Werner Koch  <wk@gnupg.org>

	scd:nks: Add do_with_keygrip and implement a cache.
	+ commit 1e72a1a218490c0fc07811a02ddad6cc38913f77
	* scd/app-nks.c (struct fid_cache_s): New.
	(struct app_local_s): Add field 'fid_cache'.
	(do_deinit): Release the cache.
	(keygripstr_from_pk_file): Implement the cache.
	(find_fid_by_keyref): New
	(do_sign, do_decipher): Use new function.
	(do_with_keygrip): New.

	sm: Support encryption using ECDH keys.
	+ commit d5051e31a8fc07c339253c6b82426e0d0115a20a
	* sm/decrypt.c (hash_ecc_cms_shared_info): Make global.
	* sm/encrypt.c (ecdh_encrypt): New.
	(encrypt_dek): Add arg PK_ALGO and support ECDH.
	(gpgsm_encrypt): Pass PK_ALGO.

2020-04-27  Werner Koch  <wk@gnupg.org>

	sm: Add support to export ECC private keys.
	+ commit 5da6925a334c68d736804d8f19a684a678409d99
	* sm/minip12.c [TEST]: Remove test code.  Include util.h, tlv.h. and
	openpgpdefs.h.  Remove the class and tag constants and replace them by
	those from tlv.h.
	(builder_add_oid, builder_add_mpi): New.
	(build_key_sequence): Rename to ...
	(build_rsa_key_sequence): this.
	(build_ecc_key_sequence): New.
	(p12_build): Call RSA or ECC builder.
	(p12_raw_build): Ditto.
	* sm/export.c (gpgsm_p12_export): Use correct armor header for ECC.
	(sexp_to_kparms): Support ECC.

	* sm/t-minip12.c: New to replace the former TEST code in minip12.h.

2020-04-24  Werner Koch  <wk@gnupg.org>

	common: Add an easy to use DER builder.
	+ commit 5ea878274ef51c819368f021c69c518b9aef6f82
	* common/tlv-builder.c: New.
	* common/tlv.c: Remove stuff only used by GnuPG 1.
	(put_tlv_to_membuf, get_tlv_length): Move to ...
	* common/tlv-builder.c: here.
	* common/tlv.h (tlv_builder_t): New.

2020-04-23  Werner Koch  <wk@gnupg.org>

	sm: Support decryption of ECDH data.
	+ commit 95d83cf906177fe9f00e88ae42d4c118c7db4371
	* sm/decrypt.c: Include tlv.h.
	(string_from_gcry_buffer): New.
	(hash_ecc_cms_shared_info): New.
	(ecdh_decrypt): New.
	(prepare_decryption): Support ECDH.  Add arg pk_algo.
	(gpgsm_decrypt): Lift some variables from an inner code block.

	common: Add functions to help create DER objects.
	+ commit 5d015b38eb9f828acf522fa89e4944f3b343678c
	* common/tlv.c (put_tlv_to_membuf): New.
	(get_tlv_length): New.
	* common/tlv.h: Include membuf.h.

2020-04-21  Werner Koch  <wk@gnupg.org>

	sm: Support import of PKCS#12 encoded ECC private keys.
	+ commit 8dfef5197af9f655697e0095c6613137d51c91e7
	* sm/minip12.c: Include ksba.h.
	(oid_pcPublicKey): New const.
	(parse_bag_data): Add arg 'r-curve'.  Support parsing of ECC private
	keys.
	(p12_parse): Add arg 'r_curve'.
	* sm/import.c (parse_p12): Support ECC import.

2020-04-17  Werner Koch  <wk@gnupg.org>

	scd:nks: Allow retrieving certificates from a Signature Card v.20.
	+ commit f05a32e5c9db7d0840c74fccc350a9e0ff5fb819
	* scd/app-nks.c: Major rework to support non-RSA cards.

	scd: Detect missing card in "getinfo all_active_apps".
	+ commit 3633ca6e21f7feb97b6690025614575bb6909f8b
	* scd/app.c (send_card_and_app_list): Detect no app case.

2020-04-16  Werner Koch  <wk@gnupg.org>

	sm: Always allow authorityInfoAccess lookup if CRLs are also enabled.
	+ commit bbb7edb8807b7d3c8bb5284d8fdf21adb67cd87d
	* sm/certchain.c (find_up): Disable external lookups in offline mode.
	Always allow AKI lookup if CRLs are also enabled.

	sm: Lookup missing issuers first using authorityInfoAccess.
	+ commit f5efbd5a1169ca7700f430a4a26ba086e603c887
	* sm/call-dirmngr.c (gpgsm_dirmngr_lookup): Add optional arg URL and
	adjust all callers.
	* sm/certchain.c (oidstr_caIssuers): New.
	(struct find_up_store_certs_s): Add additional fields.
	(find_up_store_certs_cb): Store the fingerprint.
	(find_up_via_auth_info_access): New.
	(find_up): Try the AIA URI first.

	dirmngr: Allow http URLs with "LOOKUP --url"
	+ commit 7f1be1ea524ee53d8c7b628e0305b61ebad4ab25
	* dirmngr/crlfetch.c (read_cert_via_http): New.
	(fetch_cert_by_url): Implement http scheme.

	gpg: Make AEAD modes subject to compliance checks.
	+ commit cec397e00240829495de2b487fe60d997d810c03
	* g10/decrypt-data.c (decrypt_data): Move aead algo detection up.

2020-04-15  Werner Koch  <wk@gnupg.org>

	gpg: Fix broken setting of AEAD algo.
	+ commit df0edaf91a220f8c6dffbfd1f795e229858b096b
	* g10/main.h (DEFAULT_AEAD_ALGO): Set to OCB.

	sm,dirmngr: Restrict allowed parameters used with rsaPSS.
	+ commit c0d5c673542b3d517c33fe1a9ab26bcda1a5a95f
	* sm/certcheck.c (extract_pss_params): Check the used PSS params.
	* dirmngr/crlcache.c (finish_sig_check): Ditto.
	* dirmngr/validate.c (check_cert_sig): Ditto.

2020-04-15  NIIBE Yutaka  <gniibe@fsij.org>

	regexp: Fix generation of _unicode_mapping.c.
	+ commit 50b320952e99ea20f9b77c6c501280fe37fd2598
	* configure.ac (AWK_HEX_NUMBER_OPTION): Detect GNU Awk.
	* regexp/Makefile.am: Use AWK_HEX_NUMBER_OPTION.
	* regexp/parse-unidata.awk: Don't use strtonum.

2020-04-14  Werner Koch  <wk@gnupg.org>

	sm: Support rsaPSS verification also for CMS signatures.
	+ commit 6c28d9343ea6df9cda1b69e77751a9e958eb3d70
	* sm/certcheck.c (gpgsm_check_cert_sig): Factor PSS parsing out to ...
	(extract_pss_params): new.
	(gpgsm_check_cms_signature): Implement PSS.

2020-04-09  Werner Koch  <wk@gnupg.org>

	dirmngr: Support rsaPSS also in the general validate module.
	+ commit ba34f1415366d91d1831d717ec310ddda33f9cc4
	* dirmngr/validate.c (hash_algo_from_buffer): New.
	(uint_from_buffer): New.
	(check_cert_sig): Support rsaPSS.
	* sm/certcheck.c (gpgsm_check_cert_sig): Fix small memory leak on
	error.

	sm,dirmngr: Support rsaPSS signature verification.
	+ commit b45ab0ca08f8d6f9831192210b9ab141f4e450cf
	* sm/certcheck.c (hash_algo_from_buffer): New.
	(uint_from_buffer): New.
	(gpgsm_check_cert_sig): Handle PSS.
	* dirmngr/crlcache.c (hash_algo_from_buffer): New.
	(uint_from_buffer): New.
	(start_sig_check): Detect PSS and extract hash algo.  New arg to
	return a PSS flag.
	(finish_sig_check): New arg use_pss.  Extract PSS args and use them.
	(crl_parse_insert): Pass use_pss flag along.

	common: New function to map hash algo names.
	+ commit 5d5b70ae0f515290a3d64daa1d687fe8c8477f76
	* common/sexputil.c (hash_algo_to_string): New.

	scd:p15: Return a display S/N via Assuan.
	+ commit bfedc760efdcf606da7c214e84d12a10ee4cbcc0
	* scd/app-p15.c (make_pin_prompt): Factor some code out to ...
	(get_dispserialno): this.
	(do_getattr): Use new fucntion for a $DISPSERIALNO.

2020-04-08  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: ECDH: Accept longer padding.
	+ commit fd79cadf7ba5ce45dfb5e266975f58bf5c7ce145
	* g10/pubkey-enc.c (get_it): Remove check which mandates shorter
	padding.

2020-04-07  Werner Koch  <wk@gnupg.org>

	scd:p15: Show a pretty PIN prompt.
	+ commit 9ec8d984be4676126843d5aa7dfd0b7d71eff13c
	* scd/app-p15.c (struct prkdf_object_s): New fields common_name and
	serial_number.
	(release_prkdflist): Free them.
	(keygrip_from_prkdf): Parse cert and set them.
	(any_control_or_space): New.
	(make_pin_prompt): New.
	(verify_pin): Construct a pretty PIN prompt.
	(do_sign): Remove debug output.

	scd: Return GPG_ERR_BAD_PIN on 0x63Cn status word.
	+ commit f28795b615c3042f6eb7c9d941e232d0da50efbc
	* scd/iso7816.c (map_sw): Detect 0x63Cn status code.

	scd: Factor common PIN status check out.
	+ commit 60d018f6a91c4c90b8ecf13f88ac4256699f4007
	* scd/iso7816.h (ISO7816_VERIFY_ERROR): New.
	(ISO7816_VERIFY_NO_PIN): New.
	(ISO7816_VERIFY_BLOCKED): New.
	(ISO7816_VERIFY_NULLPIN): New.
	(ISO7816_VERIFY_NOT_NEEDED): New.
	* scd/iso7816.c (iso7816_verify_status): New.
	* scd/app-nks.c (get_chv_status): Use new function.
	* scd/app-piv.c (get_chv_status): Ditto.
	(verify_chv): Ditto.

	scd:p15: Fix decrypt followed by sign problem for D-Trust cards.
	+ commit 42ddcc87f4bca40d605d133b6cdb4e761a49a1c9
	* scd/iso7816.c (iso7816_select_mf): New.
	* scd/app-p15.c (card_product_t): New.
	(struct app_local_s): Add field 'card_product'.
	(read_ef_tokeninfo): Detect D-Trust card.
	(prepare_verify_pin): Switch to D-Trust AID.
	(do_decipher): Restore a SE for D-TRust cards.  Chnage the passing
	indicator to 0x81.

2020-04-06  NIIBE Yutaka  <gniibe@fsij.org>

	tools: Use internal regexp routines.
	+ commit 7ee2a9687da9560a5d17c7046c87c2f7a6733d5c
	* tools/gpg-check-pattern.c: Use jimregexp.h.

2020-04-03  Werner Koch  <wk@gnupg.org>

	scd:p15: Emit MANUFACTURER, $ENCRKEYID, $SIGNKEYID.
	+ commit aa60645b997d23ac2958f75fd349c1cd7b8af902
	* scd/app-p15.c (read_ef_tokeninfo): Store manufacturer_id.
	(do_getattr): Implement MANUFACTURER, $ENCRKEYID and $SIGNKEYID.
	(send_keypairinfo): Also print usage flags.

	gpg,card: Use the new MANUFACTURER attribute.
	+ commit 15352b0eac335e7993fcd7720106a3a7d22caae1
	* tools/gpg-card.h (struct card_info_s): Add manufacturer fields.
	* tools/card-call-scd.c (release_card_info): Release them.
	(learn_status_cb): Parse MANUFACTURER attribute.
	* tools/gpg-card.c (get_manufacturer): Remove.
	(list_card): Use the new attribute.
	* g10/call-agent.h (struct agent_card_info_s): Add manufacturer fields.
	* g10/call-agent.c (agent_release_card_info): Release them.
	(learn_status_cb): Parse MANUFACTURER attribute.
	* g10/card-util.c (get_manufacturer): Remove.
	(current_card_status): Use new attribute.

	scd:openpgp: New attribute "MANUFACTURER".
	+ commit 541a6a903e79c9146a379f5c6c0fb34e6c2b42c4
	* scd/app-openpgp.c (get_manufacturer): New..
	(do_getattr): Add new attribute "MANUFACTURER".
	(do_learn_status): Always print it.

2020-04-03  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Add regular expression support.
	+ commit ba247a114c75a84473c11c1484013b09fbb9bcd1
	* AUTHORS, COPYING.other: Update.
	* Makefile.am (SUBDIRS): Add regexp sub directory.
	* configure.ac (DISABLE_REGEX): Remove.
	* g10/Makefile.am (needed_libs): Add libregexp.a.
	* g10/trustdb.c: Remove DISABLE_REGEX support.
	* regexp/LICENSE, regexp/jimregexp.c, regexp/jimregexp.h,
	  regexp/utf8.c, regexp/utf8.h: New from Jim Tcl.
	* regexp/UnicodeData.txt: New from Unicode.
	* regexp/Makefile.am, regexp/parse-unidata.awk: New.
	* tests/openpgp/Makefile.am: Remove DISABLE_REGEX support.
	* tools/Makefile.am: Remove DISABLE_REGEX support.

2020-04-02  Werner Koch  <wk@gnupg.org>

	scd:p15: Implement do_with_keygrip and capabilities.
	+ commit 61c5b0767fac4c2d7fe95cdbc6d0f0a94878c813
	* scd/app-p15.c (prepare_verify_pin): Allow use without an AODF.
	(verify_pin): Ditto.
	(do_with_keygrip): Implement capability restrictions.

	scd:p15: Rename some variables and functions for clarity.
	+ commit 8149742ddfea6c76898786cb7de7c92bbf8aab0a
	* scd/app-p15.c: Rename keyinfo to prkdf.

	scd: Use Gcrypt usage constants for the do_with_keygrip capabilities.
	+ commit 5b7b42e2b2b7ba7b88f89ff4b4ee7baf0eef2a04
	* scd/command.c (cmd_keyinfo): Use Gcrypt constants for CAP.
	* scd/app-openpgp.c (do_with_keygrip): Adjust for them.
	* scd/app-piv.c (do_with_keygrip): Ditto.

2020-04-02  NIIBE Yutaka  <gniibe@fsij.org>

	scd: New command DEVINFO.
	+ commit 2ccbcfec121f768574a59aa2ecff22d8b422d61b
	* scd/app.c (notify_cond): New condition variable.
	(app_send_devinfo, app_wait): New.
	(scd_update_reader_status_file): Kick NOTIFY_COND.
	(initialize_module_command): Initialize NOTIFY_COND.
	* scd/command.c (struct server_local_s):  Add watching_status.
	(cmd_devinfo): New.
	(register_commands): Add DEVINFO command.
	(send_client_notifications): Write status change to DEVINFO channel.
	* scd/scdaemon.h (app_wait, app_send_devinfo): New.

2020-04-01  Werner Koch  <wk@gnupg.org>

	scd:p15: Cache the PIN.
	+ commit 29f8f52bf8161c238c26389ab178caa98801234e
	* scd/app-p15.c (struct prkdf_object_s): Add flag pin_verified.
	(verify_pin): Make use of it.

	scd:p15: Run a keygrip_from_prkdf before verify_pin.
	+ commit 132d82c1582009013af5c7bdb17cbaaa8807c70e
	* scd/app-p15.c (do_sign): Move keygrip_from_prkdf before PIN
	verification.
	(do_decipher): Add keygrip_from_prkdf.

	scd:p15: Support decryption with CardOS 5 cards.
	+ commit ca4391399c690a45270cca30f03ac564c394c1f6
	* scd/app-p15.c (do_decipher): New.

	scd:p15: Factor PIN verification out to a new function.
	+ commit 375b1454875ff079efc122e33b1216b412eecfaf
	* scd/app-p15.c (do_sign): Factor code out to ...
	(prepare_verify_pin, verify_pin): new functions.

	sm: Fix a warning in an es_fopencooie function.
	+ commit c7ff8c59b9252f8f27cabee3fea503f06c7d46ff
	* sm/certdump.c (format_name_writer): Take care of a flush request.

2020-03-31  Werner Koch  <wk@gnupg.org>

	scd:p15: Support signing with CardOS 5 cards.
	+ commit 103c1576b73ed75b771a8ffd1c97628651b99797
	* scd/app-help.c (app_help_get_keygrip_string_pk): Add optional arg
	r_pkey and change all callers.
	(app_help_get_keygrip_string): Ditto.
	* scd/app-p15.c (struct cdf_object_s): Use bit flags
	(struct aodf_object_s): Ditto.  Add field 'fid'.
	(struct prkdf_object_s): Ditto.  Add fields keygrip, keyalgo, and
	keynbits.
	(parse_certid): Allow a keygrip instead of a certid aka keyref.
	(read_ef_aodf): Store the FID.
	(keygripstr_from_prkdf): Rename to ...
	(keygrip_from_prkdf): this.  Remove arg r_gripstr and implement cache.
	Change callers to directly use the values from the object.  Also store
	the algo and length of the key ion the object.
	(keyref_from_keyinfo): New. Factored out code.
	(do_sign): Support SHA-256 and >2048 bit RSA keys.
	(do_with_keygrip): New.
	(app_select_p15): Register new function.

	scd:p15: Read certificates in extended mode.
	+ commit 2bdd4fc7b6cfd9ac5410d20f1cee66567a6b24c5
	* scd/app-p15.c (readcert_by_cdf): Allow reading in extended mode.

	scd: Add function for binary read in extended mode.
	+ commit c9ad81070a2bb1116d3f096a440c43e57e6f933a
	* scd/iso7816.c (iso7816_read_binary): Factor code out to ...
	(iso7816_read_binary_ext): new function.  Add arg extended_mode.

2020-03-30  Werner Koch  <wk@gnupg.org>

	scd:p15: Detect CardOS 5 cards and print some basic infos.
	+ commit 8a68d497f1dd0b124318eb47db9da0c4b64c8b8b
	* scd/app-p15.c (read_ef_odf): Detect the home_DF on the fly.  Silence
	the garbage warning for null bytes.
	(print_tokeninfo_tokenflags): New.
	(read_ef_tokeninfo): Print manufacturer, label, and flags.
	(app_select_p15): No need to use the app_get_slot macro.
	(CARD_TYPE_CARDOS_50): New const.
	(card_atr_list): Detect CardOS 5.0

	agent: Print an error if gpg-protect reads the extended key format.
	+ commit c5c21a064671dc8e461434d19cbde67b89df25e2
	* agent/protect-tool.c (read_key): Detect simple extended key format.

	sm: Fix possible NULL deref in error messages of --gen-key.
	+ commit 9c5c7c6f602c84589cd5c93a85a27b416e744338
	* sm/certreqgen.c: Protect printing the liniernur in case of !R.

2020-03-27  Werner Koch  <wk@gnupg.org>

	sm: Consider certificates w/o CRL DP as valid.
	+ commit 0b583a555e75fbb9140310390a267febd3329a12
	* sm/certchain.c (is_cert_still_valid): Shortcut if tehre is no DP.
	* common/audit.c (proc_type_verify): Print "n/a" if a cert has no
	distribution point.
	* sm/gpgsm.h (opt): Add field enable_issuer_based_crl_check.
	* sm/gpgsm.c (oEnableIssuerBasedCRLCheck): New.
	(opts): Add option --enable-issuer-based-crl-check.
	(main): Set option.

	scd:openpgp: Allow PKSIGN with keygrip also for OPENPGP.3.
	+ commit 4c4999b8185ace55eb5f3a6fa7d3dc0a77267b63
	* scd/app-openpgp.c (check_keyidstr): Add optional arg r_use_auth to
	test also for OpenPGP.3.
	(do_sign): Enable that new mode.

2020-03-27  NIIBE Yutaka  <gniibe@fsij.org>

	gpgsm: Fix the previous commit.
	+ commit e06a8e3e87f044a5bf6ee06f92cc4fd2a0914863


2020-03-26  NIIBE Yutaka  <gniibe@fsij.org>

	gpgsm: Support key generation with ECC.
	+ commit 49ea53b755f0fef468055a1493e790735908f865
	* sm/certreqgen.c (pKEYCURVE): New.
	(read_parameters): Add pKEYCURVE handling.
	(proc_parameters): Support ECC key generation.

	gpgsm: Remove restriction of key generation (only RSA).
	+ commit 238707db8b05a385af5419e606ea5110ace31d2b
	* sm/certreqgen.c (proc_parameters): Remove checking GCRY_PK_RSA.

2020-03-19  Werner Koch  <wk@gnupg.org>

	gpgconf: Take care of --homedir when reading/updating options.
	+ commit c1844ca7520f9a67bff85ee4fbf49c6725668289
	* tools/gpgconf-comp.c (gpg_agent_runtime_change): Remove unused var.
	(scdaemon_runtime_change): Ditto.
	(dirmngr_runtime_change): Ditto.
	(gc_component_check_options): Pass --homedir if needed.
	(retrieve_options_from_program): Take care of --homedir.

2020-03-18  Werner Koch  <wk@gnupg.org>

	gpg: Also allow a v5 fingerprint for --trusted-key.
	+ commit 4287f89557b3bc9ab2876331e1bcb143d759fb47
	* g10/trustdb.c (tdb_register_trusted_key): Add case for 32 octet
	fingerprints.

2020-03-18  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpg: Update --trusted-key to accept fingerprint as well as long key id.
	+ commit 810ea2cc684480c6aadceb2a10dd00f3fa67f2fb
	* g10/trustdb.c (tdb_register_trusted_key): accept fingerprint as well
	as long key ID.
	* doc/gpg.texi: document that --trusted-key can accept a fingerprint.

2020-03-18  Werner Koch  <wk@gnupg.org>
	    gniibe@fsij.org

	gpg: Fix key expiration and usage for keys created at the Epoch.
	+ commit 161a098be6f9d50fb5f7e120baee81e75d6eb5ad
	* g10/getkey.c (merge_selfsigs_main): Take a zero key creation time in
	account.

2020-03-14  Werner Koch  <wk@gnupg.org>

	gpgconf: Further simplify the gpgconf option processing.
	+ commit 451cd1b3928172b312ca2597c3318e6e9e8be97d
	* common/gc-opt-flags.h (GC_OPT_FLAG_RUNTIME): Move to ...
	* tools/gpgconf-comp.c: here.
	(known_options_scdaemon): Remove "options".
	(known_options_dirmngr): Remove "options".
	(known_options_gpgsm): Remove "options".
	(known_options_gpg): Remove "options" and "keyserver".
	(struct gc_option_s): Rename active t gpgconf_list.
	(gc_component_list_options): Do not act upon active.
	(option_check_validity): Ditto.
	(is_known_option): Make it work correctly for unknown options.
	(retrieve_options_from_program): Use renamed flag gpgconf_list only to
	detect duplicated items from --gpgconf-list.  Do not set runtime.
	Only e set the options if set by --gpgconf-list; never clear them.
	* agent/gpg-agent.c: Simplify the --gpgconf-list output.
	* dirmngr/dirmngr.c: Ditto.
	* g10/gpg.c: Ditto.
	* kbx/keyboxd.c: Ditto.
	* scd/scdaemon.c: Ditto.
	* sm/gpgsm.c: Ditto.
	* tests/openpgp/gpgconf.scm: Use "compliance" instead of "keyserver"
	for the string arg test.

	gpg: New option --auto-key-import.
	+ commit 6b306f45f4fbe36b90cec4685aabb267a61e283f
	* g10/gpg.c (opts): New options --auto-key-import,
	--no-auto-key-import, and --no-include-key-block.
	(gpgconf_list): Add them.
	* g10/options.h (opt): Add field flags.auto_key_import.
	* g10/mainproc.c (check_sig_and_print): Use flag to enable that
	feature.
	* tools/gpgconf-comp.c: Give the new options a Basic config level.

2020-03-13  Werner Koch  <wk@gnupg.org>

	gpg: Make use of the included key block in a signature.
	+ commit 6a4443c8425fd548020553b22d5a16ffad98371f
	* g10/import.c (read_key_from_file): Rename to ...
	(read_key_from_file_or_buffer): this and add new parameters.  Adjust
	callers.
	(import_included_key_block): New.
	* g10/packet.h (PKT_signature): Add field flags.key_block.
	* g10/parse-packet.c (parse_signature): Set that flags.
	* g10/sig-check.c (check_signature2): Add parm forced_pk and change
	all callers.
	* g10/mainproc.c (do_check_sig): Ditto.
	(check_sig_and_print): Try the included key block if no key is
	available.

	gpg: New option --include-key-block.
	+ commit 865d485180240369a20d3be14d0c6499783df2b5
	* common/openpgpdefs.h (SIGSUBPKT_KEY_BLOCK): New.
	* g10/gpg.c (oIncludeKeyBlock): New.
	(opts): New option --include-key-block.
	(main): Implement.
	* g10/options.h (opt): New flag include_key_block.
	* g10/parse-packet.c (dump_sig_subpkt): Support SIGSUBPKT_KEY_BLOCK.
	(parse_one_sig_subpkt): Ditto.
	(can_handle_critical): Ditto.
	* g10/sign.c (mk_sig_subpkt_key_block): New.
	(write_signature_packets): Call it for data signatures.

	gpg: Add property "fpr" for use by --export-filter.
	+ commit 32493ce50ad880de7b548d7870c6040a8233a8f5
	* g10/export.c (push_export_filters): New.
	(pop_export_filters): New.
	(export_pubkey_buffer): Add args prefix and prefixlen.  Adjust
	callers.
	* g10/import.c (impex_filter_getval): Add property "fpr".
	* g10/main.h (struct impex_filter_parm_s): Add field hexfpr.

2020-03-12  Werner Koch  <wk@gnupg.org>

	gpgconf: Rewrite the gpgconf-comp module.
	+ commit b4f1159a5bd7b2799d7d35e883e0632ebf3339c8
	* tools/gpgconf.h (gc_component_t): Change type to ...
	(gc_component_id_t): this.
	(GC_COMPONENT_ANY): New, so that we can use that in gpgconf-comp.c
	directly.
	* tools/gpgconf-comp.c: Major rework.

2020-03-06  Werner Koch  <wk@gnupg.org>

	gpg: Re-group the options in the --help output.
	+ commit 41eb5108ce59244d961df43bbf73b8aa6e95e9cd
	* g10/gpg.c (opts): Change oLoadExtensions, oStrict, and oNoStrict to
	use ARGPARSE_ignore and remove the code in the option switch.

	agent: Re-group the options in the --help output.
	+ commit c693b7f4ade97357c33b410728bb741674255487
	* agent/gpg-agent.c (oGreeting): Remove non existant dummy option.

	gpgconf: Support reading global options (part 2).
	+ commit 4423e9dcde5e1a8d73ff7386942fe3c0c4b917fc
	* tools/gpgconf-comp.c: Remove all regular option descriptions.  They
	are now read in from the component.  Also remove a few meanwhile
	obsolete options.
	* agent/gpg-agent.c: Add option description which were only set in
	gpgconf-comp.c.
	* dirmngr/dirmngr.c: Ditto.
	* scd/scdaemon.c: Ditto.
	* sm/gpgsm.c: Ditto.
	* g10/gpg.c: Ditto.

2020-03-05  Werner Koch  <wk@gnupg.org>

	gpgconf: Support reading global options (part 1).
	+ commit d2425d1495f4fe4f5c3a79d7dc5571fda00849d8
	* tools/gpgconf.c (main): Set the coinfig directories.
	* tools/gpgconf-comp.c (gc_backend): Change the name of the config
	files.
	(struct gc_option): Add new field 'attr'.
	(retrieve_options_from_program): Rewrite to use gpgrt_argparser.

2020-03-04  Werner Koch  <wk@gnupg.org>

	common: Add xreallocarray function.
	+ commit 6fa1808cb7639f0f3745b78c4b7ce902e42b228c
	* common/miscellaneous.c (xreallocarray): New func.
	* common/util.h (xtryreallocarray): New macro.

2020-03-03  Werner Koch  <wk@gnupg.org>

	gpgconf: Always use xmalloc.
	+ commit 178b3772ff79148b496715da1b8ca5ba86caf2bc
	* tools/gpgconf-comp.c: Fix spelling of "cannot".  Use log_assert
	instead of a plain assert.
	(gc_percent_escape, percent_deescape): Fail on malloc error.

2020-02-28  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix the previous commit.
	+ commit 19f70b5072b2ef80759ced83fe0dac9cf4dde830
	* scd/app-openpgp.c (do_setattr): Flush the KDF DO just before setting.

	scd: Improve setattr for KDF.
	+ commit 3ba7c9bcf7f19b0a308499fcf3dbbb15da38799a
	* scd/app-openpgp.c (do_setattr): For setting KDF DO, support standard
	OpenPGP card, which needs to update PIN.

	scd: Fix pinpad handling when KDF enabled.
	+ commit 11da441016222337284c519ff56aca34e3042373
	* scd/app-openpgp.c (do_getattr): Send the KDF DO information.

2020-02-25  Werner Koch  <wk@gnupg.org>

	gpg: Re-enable versioned config files.
	+ commit 79f2318aa5c54c57220aa73251635d21cee0ccfa
	* g10/gpg.c (main): Use ARGPARSE_FLAG_USERVERS.

	gpg: Re-add checking of config file permissions.
	+ commit 7e8f28653c1b4305758a61c064d793e32ba633d5
	* g10/gpg.c (main): Re-add permission checking of the user config
	file.  Re-add code to check against the SE-Linux secured file list.
	(get_default_configname): Remove unused func.
	* configure.ac (SAFE_VERSION, SAFE_VERSION_DOT)
	(SAFE_VERSION_DASH): Remove.

2020-02-22  Werner Koch  <wk@gnupg.org>

	Use gpgrt's new option parser for the new keyboxd.
	+ commit 833c04334a53530bd40d7dd815b6a0f1ffef296d
	* kbx/keyboxd.c: Switch to the new option parser and enable a global
	conf file.

	agent,dirmngr: Re-read the user specified config file.
	+ commit 941a48f9b12b4c470686321bf4fd58c23b6cf86d
	* agent/gpg-agent.c (reread_configuration): Use a two-part config
	file.
	* dirmngr/dirmngr.c (reread_configuration): Ditto.

	Remove the now obsolete argparse code.
	+ commit cdbe10b762f38449b86da69076209324b0c99982
	* tests/gpgscm/main.c: Switch to the new option parser.
	* common/argparse.c, common/argparse.h: Remove.
	* common/init.c (_init_common_subsystems): Do not call obsolete func.
	* common/Makefile.am (common_sources): Remove those files.

2020-02-21  Werner Koch  <wk@gnupg.org>

	Use gpgrt's new option parser for the remaining daemons.
	+ commit ba463128ce65a0f347643f7246a8e097c5be19f1
	* scd/scdaemon.c: Switch to the new option parser and enable a global
	conf file.
	* dirmngr/dirmngr.c: Ditto.
	* g13/g13.c: Ditto.
	* g13/g13-syshelp.c: Ditto.  Do not force verbose mode.
	* dirmngr/dirmngr_ldap.c: Switch to the new option parser.
	* dirmngr/dirmngr-client.c: Switch to the new option parser.

	Use gpgrt's new option parser for the tools.
	+ commit 3bc004decd289810bc1b6ad6fb8f47e45c770ce6
	* agent/preset-passphrase.c: Switch to the new option parser.
	* agent/protect-tool.c: Ditto.
	* kbx/kbxutil.c: Ditto.
	* tools/gpg-card.c: Ditto.
	* tools/gpg-check-pattern.c: Ditto.
	* tools/gpg-connect-agent.c: Ditto.
	* tools/gpg-pair-tool.c: Ditto.
	* tools/gpg-wks-client.c: Ditto.
	* tools/gpg-wks-server.c: Ditto.
	* tools/gpgconf.c: Ditto.
	* tools/gpgsplit.c: Ditto.
	* tools/gpgtar.c: Ditto.

2020-02-20  Werner Koch  <wk@gnupg.org>

	Use gpgrt's new option parser for gpgc, gpgsm, and gpg-agent.
	+ commit 2c823bd878fcdbcc4f6c34993e1d0539d9a6b237
	* g10/gpgv.c: Use new option parser.
	* sm/gpgsm.c: Ditto.
	* agent/gpg-agent.c: Ditto.
	(opts): Add option --no-options.

	gpg: Use gpgrt's new option parser to provide a global conf file.
	+ commit 0e8f6e2aa98c212442001036fb5178cd6cd8af59
	* common/util.h: Remove argparse.h.
	* common/argparse.c: Undef GPGRT_ENABLE_ARGPARSE_MACROS.
	* configure.ac (GPGRT_ENABLE_ARGPARSE_MACROS): Define.
	* agent/gpg-agent.c: Undef GPGRT_ENABLE_ARGPARSE_MACROS and include
	argparse.h.  Do this also for all main modules which use our option
	parser except for gpg.  Replace calls to strusage by calls to
	gpgrt_strusage everywhere.

	* g10/gpg.c (opts): Change type to gpgrt_opt_t.  Flag oOptions and
	oNoOptions with ARGPARSE_conffile and ARGPARSE_no_conffile.
	(main): Change type of pargs to gpgrt_argparse_t.  Rework the option
	parser to make use of the new gpgrt_argparser.

2020-02-19  Werner Koch  <wk@gnupg.org>

	card: New option --info for command list and select by s/n.
	+ commit ee911df979e9b53787162367865ca24682adae6e
	* tools/gpg-card.c (cmd_list): add option --info.  Factor soem code
	out to ...
	(print_card_list): new.

2020-02-19  NIIBE Yutaka  <gniibe@fsij.org>

	gpg: Fix default-key selection when card is available.
	+ commit 41913d76f7db4a7dabab26c1bc439c96ad86712f
	* g10/getkey.c (get_seckey_default_or_card): Handle the case
	when card key is not suitable for requested usage.

2020-02-19  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	Spelling cleanup.
	+ commit 0904b8ef348a52335c378bee6dc90a978885d66f
	No functional changes, just fixing minor spelling issues.

	---

	Most of these were identified from the command line by running:

	  codespell \
	    --ignore-words-list fpr,stati,keyserver,keyservers,asign,cas,iff,ifset \
	    --skip '*.po,ChangeLog*,help.*.txt,*.jpg,*.eps,*.pdf,*.png,*.gpg,*.asc' \
	    doc g13 g10 kbx agent artwork scd tests tools am common dirmngr sm \
	    NEWS README README.maint TODO

2020-02-19  Nick Piper  <nick.piper@cgi.com>

	doc: Correction of typo in documentation of KEY_CONSIDERED.
	+ commit 0e1cbabc0ad4fe2ca9644fffb5cf27b1a8a1509f


2020-02-17  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Disable pinpad if it's impossible by KDF DO.
	+ commit 95c7498b76231d3297541172d878f6a26702539b
	* scd/app-openpgp.c (struct app_local_s): Add pinpad.disabled field.
	(do_getattr): Set pinpad.disabled field.
	(check_pinpad_request): Use the pinpad.disabled field.
	(do_setattr): Update pinpad.disabled field.

2020-02-15  Werner Koch  <wk@gnupg.org>

	gpgsm: Fix import of some CR,LF ternminated certificates.
	+ commit 6248739799fd4a877529089375e2a4103d33e6f4
	* common/ksba-io-support.c (base64_reader_cb): Detect the END tag and
	don't just rely on the padding chars.  This could happen only with
	CR+LF termnmated PEM files.  Also move the detection into the invalid
	character detection branch for a minor parser speedup.

2020-02-13  Werner Koch  <wk@gnupg.org>

	build: New configure option --disable-keyboxd.
	+ commit 6cac2bd0382eb7ed0d249f077522516e64fc1d8f
	* configure.ac: Add option --dsiable-keyboxd
	* kbx/Makefile.am: Do not build keyboxd in that case.

	scd: Print the main app name also for not fully supported cards.
	+ commit 11d917c7796dc748e2d798d327a045ba295994f4
	* scd/app.c (send_serialno_and_app_status): Add fallback.

	card: Fix openpgp subkey listing.
	+ commit e582d8f5b2c1bac8b6ccdfd6412b621a2584eb7f
	* tools/gpg-card.c (list_one_kinfo): Fix printing of the subkeys.

	gpg: New option --full-timestrings.
	+ commit 86312b920a1d5817903d7175e9c2109bcf521b7c
	* g10/options.h (opt): Add flags.full_timestrings.
	* g10/gpg.c (oFullTimestrings): New.
	(opts): New option.
	(main): Set new flag.
	* g10/keyid.c (dateonlystr_from_pk): New.
	(dateonlystr_from_sig): New.
	(datestr_from_pk): Divert to isotimestamp if requested.
	(datestr_from_sig): Ditto.
	(expirestr_from_pk): Ditto.
	(expirestr_from_sig): Ditto.
	(revokestr_from_pk): Ditto.
	* g10/import.c (impex_filter_getval): Use dateonlystr_from_sig and
	dateonlystr_from_pk.

	gpg: Changes to allow direct key generation from an OpenPGP card.
	+ commit 14ac350f868ca71492c20c7b682d0b55b4893c9c
	* g10/call-agent.h (struct keypair_info_s): Add fields keytime and
	usage.
	* g10/call-agent.c (struct keypairinfo_cb_parm_s): New.
	(scd_keypairinfo_status_cb): Rework to store parsed KEYPAIRINFO data.
	(agent_scd_keypairinfo): Change accordingly.
	(agent_scd_readkey): Add arg ctrl and change callers.  Change return
	arg from an strlist_t to a keypair_info_t.
	(readkey_status_cb): Use KEYPAIRINFO instead of KEY-TIME.
	* g10/keygen.c (pSUBKEYCREATIONDATE): New.
	(pAUTHKEYCREATIONDATE): New.
	(get_parameter_u32): Allow for new parameters.
	(do_create_from_keygrip): For card keys use direct scd call which does
	not create a stub file.
	(ask_algo): Rework to use the new keypair_info_t as return from
	agent_scd_keypairinfo.
	(parse_key_parameter_part): Likewise.  Also get and return the key
	creation time using a arg.
	(parse_key_parameter_string): New args r_keytime and r_subkeytime.
	(parse_algo_usage_expire): New arg r_keytime.
	(proc_parameter_file): Ignore the explict pCREATIONDATE for card keys.
	(quickgen_set_para): New arg keytime.
	(quick_generate_keypair): Get the keytimes and set the pCARDKEY flag.
	(generate_keypair): Likewise.
	(do_generate_keypair): Implement the cardkey with keytime thingy.
	(generate_subkeypair): Use the keytime parameters.
	* g10/keygen.c (pAUTHKEYCREATIONDATE): New.  Not yet set but may come
	handy later.
	(get_parameter_u32): Take care of that.
	(do_generate_keypair): For cardkeys sign with the current time.

	card: Take the key creation time from the KEYPAIRINFO.
	+ commit e63f8bee4044e0cc9ebc1f9c0f9f6b63660d45e8
	* tools/card-call-scd.c (learn_status_cb): Adjust for recent change.

	scd:openpgp: Return key creation time as part of KEYPARIINFO.
	+ commit 1ad84aabb410e56bea074b82a06fe32b2897b660
	* scd/app-openpgp.c (send_keypair_info): Reaturn the key creation time
	as part of a KEYPAIRINFO.
	(do_readkey): Do not return the KEY-TIME anymore.

	agent: Allow signing with card key even without a stub key.
	+ commit 638526d37fee0a1febac9d29fab384b913819fc9
	* agent/call-scd.c (agent_card_serialno): Allow NULL for R_SERIAL.
	(struct readkey_status_parm_s): New.
	(readkey_status_cb): New.
	(agent_card_readkey): Add optional arg R_KEYREF and change all
	callers.
	* agent/findkey.c (key_parms_from_sexp): Allow also a "public-key".
	* agent/divert-scd.c (ask_for_card): Allow for SHADOW_INFO being NULL.
	* agent/pksign.c (agent_pksign_do): Fallback to sign with an on-card
	if there is no stub key yet.  Create the stub key.  Also fixed a
	misnaming between s_pkey and s_skey.

2020-02-12  Werner Koch  <wk@gnupg.org>

	gpg: Rename the struct card_key_info_s.
	+ commit 8c63430d1a40a70ff8b4ddf1ed0fcabf9c0afbcc
	* g10/call-agent.h (struct card_key_info_s): Rename to ...
	(struct keypair_info_s): this.
	(keypair_info_t): New.  Use this everywhere instead of
	card_key_info_s.
	* g10/call-agent.c (agent_scd_free_keyinfo): Rename to ..
	(free_keypair_info): this.  Change all callers.

	card: Fix parsing of the received card_list.
	+ commit 125c959677d55a8cf663c2dc248a3fc6f9be50bb
	* tools/card-call-scd.c (scd_cardlist): Allow for SERIALNO without any
	apps.

	card: List more info for an OpenPGP key.
	+ commit 1abfce82bd525de2976c31b83bb0e67e33364e58
	* tools/gpg-card.h (struct pubkey_s): Add field created.
	* tools/card-keys.c (parse_key_record): Set that field.
	* tools/gpg-card.c (print_shax_fpr): Print the fingerprint without
	spaces for easier c+p.
	(list_one_kinfo): Print the actual used fingerprint and creation date
	from the keyblock.

	card: New option --no-key-lookup.
	+ commit 2c6092bc5d794ae36cbf2f6b62337dc23f57bf3e
	* tools/gpg-card.h (opt): Add var no_key_lookup.
	* tools/gpg-card.c (oNoKeyLookup): New const.
	(opts): New option --no-key-lookup.
	(list_one_kinfo): Add arg no_key_lookup and implement.
	(list_all_kinfo): Add arg no_key_lookup.
	(list_openpgp, list_piv, list_card): Ditto.
